package config

import (
	"git.majava.org/software/dnsgen/pkg/integration/lookup"
	"git.majava.org/software/dnsgen/pkg/integration/puppetdb"
)

type WebProxy struct {
	Name        string   `json:"name"`
	MetadataUrl string   `json:"metadata_url"`
	ProxyTarget string   `json:"proxy_target"`
	Skip        []string `json:"skip"`
}

type PuppetdbQuery struct {
	Name       string                `json:"name"`
	Connection puppetdb.ClientConfig `json:"connection"`
	Records    []puppetdb.Query      `json:"records"`
}

type Config struct {
	Domains []string `json:"domains"`

	NetboxUrl      string   `json:"netbox_url"`
	NetboxToken    string   `json:"netbox_token"`
	NetboxPrefixes []string `json:"netbox_prefixes"`

	KubernetesConfig   string   `json:"kubernetes_config"`
	KubernetesClusters []string `json:"kubernetes_clusters"`
	KubernetesPrefixes []string `json:"kubernetes_prefixes"`

	PuppetdbQueries []PuppetdbQuery `json:"puppetdb_queries"`

	WebProxies []WebProxy `json:"web_proxies"`

	Lookups []lookup.Lookup `json:"lookups"`
}
