package dns

import "net"

func FindMostSpecificPrefix(prefixes []string, addr net.IP) string {
	mostSpecific := ""
	mostSpecificLen := 0

	for _, prefix := range prefixes {
		prefixAddr, prefixNet, _ := net.ParseCIDR(prefix)
		if (addr.To4() != nil) != (prefixAddr.To4() != nil) {
			continue
		}

		if !prefixNet.Contains(addr) {
			continue
		}

		prefixLen, _ := prefixNet.Mask.Size()
		if prefixLen <= mostSpecificLen {
			continue
		}

		mostSpecific = prefix
		mostSpecificLen = prefixLen
	}

	return mostSpecific
}
