package dns

import (
	"encoding/hex"
	"fmt"
	"net"
)

func GetReverseName(addr net.IP, family RecordType) string {
	if family == RecordTypeA {
		values := addr.To4()
		ret := ""

		for i := 3; i >= 0; i-- {
			ret += fmt.Sprintf("%v.", values[i])
		}

		return ret + "in-addr.arpa."
	} else {
		ret := ""
		hex := hex.EncodeToString(addr)

		for i := 31; i >= 0; i-- {
			ret += fmt.Sprintf("%v.", hex[i:i+1])
		}

		return ret + "ip6.arpa."
	}
}
