// Code generated by gqlclientgen - DO NOT EDIT.

package netbox

import (
	"context"
	"encoding/json"
	"fmt"
	gqlclient "git.sr.ht/~emersion/gqlclient"
)

// An autonomous system (AS) number is typically used to represent an independent routing domain. A site can have
// one or more ASNs assigned to it.
type ASNFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Asn                 []string              `json:"asn,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Rir_id              []string              `json:"rir_id,omitempty"`
	Rir                 []string              `json:"rir,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Provider_id         []string              `json:"provider_id,omitempty"`
	Provider            []string              `json:"provider,omitempty"`
	AND                 *ASNFilter            `json:"AND,omitempty"`
	OR                  *ASNFilter            `json:"OR,omitempty"`
	NOT                 *ASNFilter            `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// ASNRange(id, created, last_updated, custom_field_data, description, name, slug, rir, start, end, tenant)
type ASNRangeFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Start               []string              `json:"start,omitempty"`
	End                 []string              `json:"end,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Rir_id              []string              `json:"rir_id,omitempty"`
	Rir                 []string              `json:"rir,omitempty"`
	AND                 *ASNRangeFilter       `json:"AND,omitempty"`
	OR                  *ASNRangeFilter       `json:"OR,omitempty"`
	NOT                 *ASNRangeFilter       `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// ASNRange(id, created, last_updated, custom_field_data, description, name, slug, rir, start, end, tenant)
type ASNRangeType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Start             Union              `json:"start"`
	End               Union              `json:"end"`
	Rir               *RIRType           `json:"rir,omitempty"`
	Tenant            *TenantType        `json:"tenant,omitempty"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
}

// An autonomous system (AS) number is typically used to represent an independent routing domain. A site can have
// one or more ASNs assigned to it.
type ASNType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Asn               Union              `json:"asn"`
	Rir               *RIRType           `json:"rir,omitempty"`
	Tenant            *TenantType        `json:"tenant,omitempty"`
	Sites             []SiteType         `json:"sites"`
	Providers         []ProviderType     `json:"providers"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
}

// An aggregate exists at the root level of the IP address space hierarchy in NetBox. Aggregates are used to organize
// the hierarchy and track the overall utilization of available address space. Each Aggregate is assigned to a RIR.
type AggregateFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Date_added          *DateFilterLookup     `json:"date_added,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Family              *int32                `json:"family,omitempty"`
	Prefix              *string               `json:"prefix,omitempty"`
	Rir_id              []string              `json:"rir_id,omitempty"`
	Rir                 []string              `json:"rir,omitempty"`
	AND                 *AggregateFilter      `json:"AND,omitempty"`
	OR                  *AggregateFilter      `json:"OR,omitempty"`
	NOT                 *AggregateFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An aggregate exists at the root level of the IP address space hierarchy in NetBox. Aggregates are used to organize
// the hierarchy and track the overall utilization of available address space. Each Aggregate is assigned to a RIR.
type AggregateType struct {
	Changelog         []ObjectChangeType   `json:"changelog"`
	Family            *IPAddressFamilyType `json:"family"`
	Display           string               `json:"display"`
	Class_type        string               `json:"class_type"`
	Tags              []TagType            `json:"tags"`
	Journal_entries   []JournalEntryType   `json:"journal_entries"`
	Custom_fields     JSON                 `json:"custom_fields"`
	Prefix            string               `json:"prefix"`
	Rir               *RIRType             `json:"rir,omitempty"`
	Tenant            *TenantType          `json:"tenant,omitempty"`
	Id                string               `json:"id"`
	Created           *DateTime            `json:"created,omitempty"`
	Last_updated      *DateTime            `json:"last_updated,omitempty"`
	Custom_field_data JSON                 `json:"custom_field_data"`
	Description       string               `json:"description"`
	Comments          string               `json:"comments"`
	Date_added        *Date                `json:"date_added,omitempty"`
}

// A physical connection between two endpoints.
type CableFilter struct {
	Id                    *IDFilterLookup       `json:"id,omitempty"`
	Label                 *StrFilterLookup      `json:"label,omitempty"`
	Length                *DecimalFilterLookup  `json:"length,omitempty"`
	Length_unit           *StrFilterLookup      `json:"length_unit,omitempty"`
	Description           *StrFilterLookup      `json:"description,omitempty"`
	Tenant_group_id       []string              `json:"tenant_group_id,omitempty"`
	Tenant_group          []string              `json:"tenant_group,omitempty"`
	Tenant_id             []string              `json:"tenant_id,omitempty"`
	Tenant                []string              `json:"tenant,omitempty"`
	Created               *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated          *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request    *string               `json:"created_by_request,omitempty"`
	Updated_by_request    *string               `json:"updated_by_request,omitempty"`
	Modified_by_request   *string               `json:"modified_by_request,omitempty"`
	Q                     *string               `json:"q,omitempty"`
	Tag                   []string              `json:"tag,omitempty"`
	Termination_a_type    *string               `json:"termination_a_type,omitempty"`
	Termination_a_id      []string              `json:"termination_a_id,omitempty"`
	Termination_b_type    *string               `json:"termination_b_type,omitempty"`
	Termination_b_id      []string              `json:"termination_b_id,omitempty"`
	Unterminated          *bool                 `json:"unterminated,omitempty"`
	Type                  *string               `json:"type,omitempty"`
	Status                *string               `json:"status,omitempty"`
	Color                 *string               `json:"color,omitempty"`
	Device_id             []string              `json:"device_id,omitempty"`
	Device                *StrFilterLookup      `json:"device,omitempty"`
	Rack_id               []string              `json:"rack_id,omitempty"`
	Rack                  *StrFilterLookup      `json:"rack,omitempty"`
	Location_id           []string              `json:"location_id,omitempty"`
	Location              *StrFilterLookup      `json:"location,omitempty"`
	Site_id               []string              `json:"site_id,omitempty"`
	Site                  *StrFilterLookup      `json:"site,omitempty"`
	Consoleport_id        []string              `json:"consoleport_id,omitempty"`
	Consoleserverport_id  []string              `json:"consoleserverport_id,omitempty"`
	Powerport_id          []string              `json:"powerport_id,omitempty"`
	Poweroutlet_id        []string              `json:"poweroutlet_id,omitempty"`
	Interface_id          []string              `json:"interface_id,omitempty"`
	Frontport_id          []string              `json:"frontport_id,omitempty"`
	Rearport_id           []string              `json:"rearport_id,omitempty"`
	Powerfeed_id          []string              `json:"powerfeed_id,omitempty"`
	Circuittermination_id []string              `json:"circuittermination_id,omitempty"`
	AND                   *CableFilter          `json:"AND,omitempty"`
	OR                    *CableFilter          `json:"OR,omitempty"`
	NOT                   *CableFilter          `json:"NOT,omitempty"`
	DISTINCT              *bool                 `json:"DISTINCT,omitempty"`
}

// A mapping between side A or B of a Cable and a terminating object (e.g. an Interface or CircuitTermination).
type CableTerminationFilter struct {
	Id                  *IDFilterLookup         `json:"id,omitempty"`
	Cable               *DjangoModelFilterInput `json:"cable,omitempty"`
	Cable_end           *StrFilterLookup        `json:"cable_end,omitempty"`
	Termination_type    *DjangoModelFilterInput `json:"termination_type,omitempty"`
	Termination_id      *IntFilterLookup        `json:"termination_id,omitempty"`
	Created             *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request  *string                 `json:"created_by_request,omitempty"`
	Updated_by_request  *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request *string                 `json:"modified_by_request,omitempty"`
	AND                 *CableTerminationFilter `json:"AND,omitempty"`
	OR                  *CableTerminationFilter `json:"OR,omitempty"`
	NOT                 *CableTerminationFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                   `json:"DISTINCT,omitempty"`
}

type CableTerminationTerminationType struct {
	// Underlying value of the GraphQL union
	Value CableTerminationTerminationTypeValue `json:"-"`
}

func (base *CableTerminationTerminationType) UnmarshalJSON(b []byte) error {
	type Raw CableTerminationTerminationType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "CircuitTerminationType":
		base.Value = new(CircuitTerminationType)
	case "ConsolePortType":
		base.Value = new(ConsolePortType)
	case "ConsoleServerPortType":
		base.Value = new(ConsoleServerPortType)
	case "FrontPortType":
		base.Value = new(FrontPortType)
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "PowerFeedType":
		base.Value = new(PowerFeedType)
	case "PowerOutletType":
		base.Value = new(PowerOutletType)
	case "PowerPortType":
		base.Value = new(PowerPortType)
	case "RearPortType":
		base.Value = new(RearPortType)
	case "":
		return fmt.Errorf("gqlclient: union CableTerminationTerminationType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union CableTerminationTerminationType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// CableTerminationTerminationTypeValue is one of: CircuitTerminationType | ConsolePortType | ConsoleServerPortType | FrontPortType | InterfaceType | PowerFeedType | PowerOutletType | PowerPortType | RearPortType
type CableTerminationTerminationTypeValue interface {
	isCableTerminationTerminationType()
}

// A mapping between side A or B of a Cable and a terminating object (e.g. an Interface or CircuitTermination).
type CableTerminationType struct {
	Changelog       []ObjectChangeType               `json:"changelog"`
	Display         string                           `json:"display"`
	Class_type      string                           `json:"class_type"`
	Tags            []TagType                        `json:"tags"`
	Journal_entries []JournalEntryType               `json:"journal_entries"`
	Custom_fields   JSON                             `json:"custom_fields"`
	Cable           *CableType                       `json:"cable,omitempty"`
	Termination     *CableTerminationTerminationType `json:"termination,omitempty"`
	Id              string                           `json:"id"`
	Created         *DateTime                        `json:"created,omitempty"`
	Last_updated    *DateTime                        `json:"last_updated,omitempty"`
	Cable_end       string                           `json:"cable_end"`
}

// A physical connection between two endpoints.
type CableType struct {
	Changelog         []ObjectChangeType                `json:"changelog"`
	Display           string                            `json:"display"`
	Class_type        string                            `json:"class_type"`
	Tags              []TagType                         `json:"tags"`
	Journal_entries   []JournalEntryType                `json:"journal_entries"`
	Custom_fields     JSON                              `json:"custom_fields"`
	Color             string                            `json:"color"`
	Tenant            *TenantType                       `json:"tenant,omitempty"`
	Terminations      []CableTerminationType            `json:"terminations"`
	A_terminations    []CableTerminationTerminationType `json:"a_terminations"`
	B_terminations    []CableTerminationTerminationType `json:"b_terminations"`
	Id                string                            `json:"id"`
	Created           *DateTime                         `json:"created,omitempty"`
	Last_updated      *DateTime                         `json:"last_updated,omitempty"`
	Custom_field_data JSON                              `json:"custom_field_data"`
	Description       string                            `json:"description"`
	Comments          string                            `json:"comments"`
	Type              *string                           `json:"type,omitempty"`
	Status            string                            `json:"status"`
	Label             string                            `json:"label"`
	Length            *Decimal                          `json:"length,omitempty"`
	Length_unit       *string                           `json:"length_unit,omitempty"`
	_abs_length       *Decimal                          `json:"_abs_length,omitempty"`
}

// A communications circuit connects two points. Each Circuit belongs to a Provider; Providers may have multiple
// circuits. Each circuit is also assigned a CircuitType and a Site, and may optionally be assigned to a particular
// ProviderAccount. Circuit port speed and commit rate are measured in Kbps.
type CircuitFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Cid                 *StrFilterLookup      `json:"cid,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Install_date        *DateFilterLookup     `json:"install_date,omitempty"`
	Termination_date    *DateFilterLookup     `json:"termination_date,omitempty"`
	Commit_rate         *IntFilterLookup      `json:"commit_rate,omitempty"`
	Distance            *DecimalFilterLookup  `json:"distance,omitempty"`
	Distance_unit       *StrFilterLookup      `json:"distance_unit,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Provider_id         []string              `json:"provider_id,omitempty"`
	Provider            []string              `json:"provider,omitempty"`
	Provider_account_id []string              `json:"provider_account_id,omitempty"`
	Provider_account    []string              `json:"provider_account,omitempty"`
	Provider_network_id []string              `json:"provider_network_id,omitempty"`
	Type_id             []string              `json:"type_id,omitempty"`
	Type                []string              `json:"type,omitempty"`
	Status              *string               `json:"status,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Termination_a_id    []string              `json:"termination_a_id,omitempty"`
	Termination_z_id    []string              `json:"termination_z_id,omitempty"`
	AND                 *CircuitFilter        `json:"AND,omitempty"`
	OR                  *CircuitFilter        `json:"OR,omitempty"`
	NOT                 *CircuitFilter        `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Assignment of a physical or virtual circuit to a CircuitGroup with an optional priority.
type CircuitGroupAssignmentFilter struct {
	Id                  *IDFilterLookup               `json:"id,omitempty"`
	Member_id           *IntFilterLookup              `json:"member_id,omitempty"`
	Priority            *StrFilterLookup              `json:"priority,omitempty"`
	Created             *DatetimeFilterLookup         `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup         `json:"last_updated,omitempty"`
	Created_by_request  *string                       `json:"created_by_request,omitempty"`
	Updated_by_request  *string                       `json:"updated_by_request,omitempty"`
	Modified_by_request *string                       `json:"modified_by_request,omitempty"`
	Q                   *string                       `json:"q,omitempty"`
	Tag                 []string                      `json:"tag,omitempty"`
	Member_type         *string                       `json:"member_type,omitempty"`
	Circuit             *StrFilterLookup              `json:"circuit,omitempty"`
	Circuit_id          []string                      `json:"circuit_id,omitempty"`
	Virtual_circuit     *StrFilterLookup              `json:"virtual_circuit,omitempty"`
	Virtual_circuit_id  []string                      `json:"virtual_circuit_id,omitempty"`
	Provider            *StrFilterLookup              `json:"provider,omitempty"`
	Provider_id         []string                      `json:"provider_id,omitempty"`
	Group_id            []string                      `json:"group_id,omitempty"`
	Group               []string                      `json:"group,omitempty"`
	AND                 *CircuitGroupAssignmentFilter `json:"AND,omitempty"`
	OR                  *CircuitGroupAssignmentFilter `json:"OR,omitempty"`
	NOT                 *CircuitGroupAssignmentFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                         `json:"DISTINCT,omitempty"`
}

type CircuitGroupAssignmentMemberType struct {
	// Underlying value of the GraphQL union
	Value CircuitGroupAssignmentMemberTypeValue `json:"-"`
}

func (base *CircuitGroupAssignmentMemberType) UnmarshalJSON(b []byte) error {
	type Raw CircuitGroupAssignmentMemberType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "CircuitType":
		base.Value = new(CircuitType)
	case "VirtualCircuitType":
		base.Value = new(VirtualCircuitType)
	case "":
		return fmt.Errorf("gqlclient: union CircuitGroupAssignmentMemberType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union CircuitGroupAssignmentMemberType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// CircuitGroupAssignmentMemberTypeValue is one of: CircuitType | VirtualCircuitType
type CircuitGroupAssignmentMemberTypeValue interface {
	isCircuitGroupAssignmentMemberType()
}

// Assignment of a physical or virtual circuit to a CircuitGroup with an optional priority.
type CircuitGroupAssignmentType struct {
	Tags              []TagType                         `json:"tags"`
	Display           string                            `json:"display"`
	Class_type        string                            `json:"class_type"`
	Group             *CircuitGroupType                 `json:"group"`
	Id                string                            `json:"id"`
	Created           *DateTime                         `json:"created,omitempty"`
	Last_updated      *DateTime                         `json:"last_updated,omitempty"`
	Custom_field_data JSON                              `json:"custom_field_data"`
	Priority          *string                           `json:"priority,omitempty"`
	Member            *CircuitGroupAssignmentMemberType `json:"member,omitempty"`
}

// An administrative grouping of Circuits.
type CircuitGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	AND                 *CircuitGroupFilter   `json:"AND,omitempty"`
	OR                  *CircuitGroupFilter   `json:"OR,omitempty"`
	NOT                 *CircuitGroupFilter   `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An administrative grouping of Circuits.
type CircuitGroupType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Tenant            *TenantType        `json:"tenant,omitempty"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
}

// CircuitTermination(id, created, last_updated, custom_field_data, cable, cable_end, mark_connected, circuit, term_side, termination_type, termination_id, port_speed, upstream_speed, xconnect_id, pp_info, description, _provider_network, _location, _site, _region, _site_group)
type CircuitTerminationFilter struct {
	Id                  *IDFilterLookup           `json:"id,omitempty"`
	Termination_id      *IntFilterLookup          `json:"termination_id,omitempty"`
	Term_side           *StrFilterLookup          `json:"term_side,omitempty"`
	Port_speed          *IntFilterLookup          `json:"port_speed,omitempty"`
	Upstream_speed      *IntFilterLookup          `json:"upstream_speed,omitempty"`
	Xconnect_id         *StrFilterLookup          `json:"xconnect_id,omitempty"`
	Description         *StrFilterLookup          `json:"description,omitempty"`
	Mark_connected      *bool                     `json:"mark_connected,omitempty"`
	Pp_info             *StrFilterLookup          `json:"pp_info,omitempty"`
	Cable_end           *StrFilterLookup          `json:"cable_end,omitempty"`
	Created             *DatetimeFilterLookup     `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup     `json:"last_updated,omitempty"`
	Created_by_request  *string                   `json:"created_by_request,omitempty"`
	Updated_by_request  *string                   `json:"updated_by_request,omitempty"`
	Modified_by_request *string                   `json:"modified_by_request,omitempty"`
	Q                   *string                   `json:"q,omitempty"`
	Tag                 []string                  `json:"tag,omitempty"`
	Cable_id            []string                  `json:"cable_id,omitempty"`
	Cabled              *bool                     `json:"cabled,omitempty"`
	Occupied            *bool                     `json:"occupied,omitempty"`
	Circuit_id          []string                  `json:"circuit_id,omitempty"`
	Termination_type    *string                   `json:"termination_type,omitempty"`
	Region_id           []string                  `json:"region_id,omitempty"`
	Region              []string                  `json:"region,omitempty"`
	Site_group_id       []string                  `json:"site_group_id,omitempty"`
	Site_group          []string                  `json:"site_group,omitempty"`
	Site_id             []string                  `json:"site_id,omitempty"`
	Site                []string                  `json:"site,omitempty"`
	Location_id         []string                  `json:"location_id,omitempty"`
	Location            []string                  `json:"location,omitempty"`
	Provider_network_id []string                  `json:"provider_network_id,omitempty"`
	Provider_id         []string                  `json:"provider_id,omitempty"`
	Provider            []string                  `json:"provider,omitempty"`
	AND                 *CircuitTerminationFilter `json:"AND,omitempty"`
	OR                  *CircuitTerminationFilter `json:"OR,omitempty"`
	NOT                 *CircuitTerminationFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                     `json:"DISTINCT,omitempty"`
}

type CircuitTerminationTerminationType struct {
	// Underlying value of the GraphQL union
	Value CircuitTerminationTerminationTypeValue `json:"-"`
}

func (base *CircuitTerminationTerminationType) UnmarshalJSON(b []byte) error {
	type Raw CircuitTerminationTerminationType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "LocationType":
		base.Value = new(LocationType)
	case "RegionType":
		base.Value = new(RegionType)
	case "SiteGroupType":
		base.Value = new(SiteGroupType)
	case "SiteType":
		base.Value = new(SiteType)
	case "ProviderNetworkType":
		base.Value = new(ProviderNetworkType)
	case "":
		return fmt.Errorf("gqlclient: union CircuitTerminationTerminationType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union CircuitTerminationTerminationType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// CircuitTerminationTerminationTypeValue is one of: LocationType | RegionType | SiteGroupType | SiteType | ProviderNetworkType
type CircuitTerminationTerminationTypeValue interface {
	isCircuitTerminationTerminationType()
}

// CircuitTermination(id, created, last_updated, custom_field_data, cable, cable_end, mark_connected, circuit, term_side, termination_type, termination_id, port_speed, upstream_speed, xconnect_id, pp_info, description, _provider_network, _location, _site, _region, _site_group)
type CircuitTerminationType struct {
	Custom_fields     JSON                               `json:"custom_fields"`
	Tags              []TagType                          `json:"tags"`
	Cable             *CableType                         `json:"cable,omitempty"`
	Link_peers        []LinkPeerType                     `json:"link_peers"`
	Changelog         []ObjectChangeType                 `json:"changelog"`
	Display           string                             `json:"display"`
	Class_type        string                             `json:"class_type"`
	Circuit           *CircuitType                       `json:"circuit"`
	Id                string                             `json:"id"`
	Created           *DateTime                          `json:"created,omitempty"`
	Last_updated      *DateTime                          `json:"last_updated,omitempty"`
	Custom_field_data JSON                               `json:"custom_field_data"`
	Cable_end         *string                            `json:"cable_end,omitempty"`
	Mark_connected    bool                               `json:"mark_connected"`
	Term_side         string                             `json:"term_side"`
	Port_speed        *int32                             `json:"port_speed,omitempty"`
	Upstream_speed    *int32                             `json:"upstream_speed,omitempty"`
	Xconnect_id       string                             `json:"xconnect_id"`
	Pp_info           string                             `json:"pp_info"`
	Description       string                             `json:"description"`
	Termination       *CircuitTerminationTerminationType `json:"termination,omitempty"`
}

func (*CircuitTerminationType) isLinkPeerType() {}

func (*CircuitTerminationType) isConnectedEndpointType() {}

func (*CircuitTerminationType) isCableTerminationTerminationType() {}

// A communications circuit connects two points. Each Circuit belongs to a Provider; Providers may have multiple
// circuits. Each circuit is also assigned a CircuitType and a Site, and may optionally be assigned to a particular
// ProviderAccount. Circuit port speed and commit rate are measured in Kbps.
type CircuitType struct {
	Changelog         []ObjectChangeType       `json:"changelog"`
	Contacts          []ContactAssignmentType  `json:"contacts"`
	Display           string                   `json:"display"`
	Class_type        string                   `json:"class_type"`
	Tags              []TagType                `json:"tags"`
	Journal_entries   []JournalEntryType       `json:"journal_entries"`
	Custom_fields     JSON                     `json:"custom_fields"`
	Provider          *ProviderType            `json:"provider"`
	Provider_account  *ProviderAccountType     `json:"provider_account,omitempty"`
	Termination_a     *CircuitTerminationType  `json:"termination_a,omitempty"`
	Termination_z     *CircuitTerminationType  `json:"termination_z,omitempty"`
	Type              *CircuitTypeType         `json:"type"`
	Tenant            *TenantType              `json:"tenant,omitempty"`
	Terminations      []CircuitTerminationType `json:"terminations"`
	Id                string                   `json:"id"`
	Created           *DateTime                `json:"created,omitempty"`
	Last_updated      *DateTime                `json:"last_updated,omitempty"`
	Custom_field_data JSON                     `json:"custom_field_data"`
	Description       string                   `json:"description"`
	Comments          string                   `json:"comments"`
	Distance          *Decimal                 `json:"distance,omitempty"`
	Distance_unit     *string                  `json:"distance_unit,omitempty"`
	_abs_distance     *Decimal                 `json:"_abs_distance,omitempty"`
	Cid               string                   `json:"cid"`
	Status            string                   `json:"status"`
	Install_date      *Date                    `json:"install_date,omitempty"`
	Termination_date  *Date                    `json:"termination_date,omitempty"`
	Commit_rate       *int32                   `json:"commit_rate,omitempty"`
}

func (*CircuitType) isCircuitGroupAssignmentMemberType() {}

// Circuits can be organized by their functional role. For example, a user might wish to define CircuitTypes named
// "Long Haul," "Metro," or "Out-of-Band".
type CircuitTypeFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Color               []string              `json:"color,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *CircuitTypeFilter    `json:"AND,omitempty"`
	OR                  *CircuitTypeFilter    `json:"OR,omitempty"`
	NOT                 *CircuitTypeFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Circuits can be organized by their functional role. For example, a user might wish to define CircuitTypes named
// "Long Haul," "Metro," or "Out-of-Band".
type CircuitTypeType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Color             string             `json:"color"`
	Circuits          []CircuitType      `json:"circuits"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
}

// A cluster of VirtualMachines. Each Cluster may optionally be associated with one or more Devices.
type ClusterFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Scope_id            *IntFilterLookup      `json:"scope_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Scope_type          *string               `json:"scope_type,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Group_id            []string              `json:"group_id,omitempty"`
	Group               []string              `json:"group,omitempty"`
	Type_id             []string              `json:"type_id,omitempty"`
	Type                []string              `json:"type,omitempty"`
	Status              *string               `json:"status,omitempty"`
	AND                 *ClusterFilter        `json:"AND,omitempty"`
	OR                  *ClusterFilter        `json:"OR,omitempty"`
	NOT                 *ClusterFilter        `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An organizational group of Clusters.
type ClusterGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	AND                 *ClusterGroupFilter   `json:"AND,omitempty"`
	OR                  *ClusterGroupFilter   `json:"OR,omitempty"`
	NOT                 *ClusterGroupFilter   `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An organizational group of Clusters.
type ClusterGroupType struct {
	Vlan_groups       []VLANGroupType    `json:"vlan_groups"`
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Clusters          []ClusterType      `json:"clusters"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
}

func (*ClusterGroupType) isVLANGroupScopeType() {}

type ClusterScopeType struct {
	// Underlying value of the GraphQL union
	Value ClusterScopeTypeValue `json:"-"`
}

func (base *ClusterScopeType) UnmarshalJSON(b []byte) error {
	type Raw ClusterScopeType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "LocationType":
		base.Value = new(LocationType)
	case "RegionType":
		base.Value = new(RegionType)
	case "SiteGroupType":
		base.Value = new(SiteGroupType)
	case "SiteType":
		base.Value = new(SiteType)
	case "":
		return fmt.Errorf("gqlclient: union ClusterScopeType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union ClusterScopeType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// ClusterScopeTypeValue is one of: LocationType | RegionType | SiteGroupType | SiteType
type ClusterScopeTypeValue interface {
	isClusterScopeType()
}

// A cluster of VirtualMachines. Each Cluster may optionally be associated with one or more Devices.
type ClusterType struct {
	Vlan_groups       []VLANGroupType      `json:"vlan_groups"`
	Changelog         []ObjectChangeType   `json:"changelog"`
	Display           string               `json:"display"`
	Class_type        string               `json:"class_type"`
	Tags              []TagType            `json:"tags"`
	Journal_entries   []JournalEntryType   `json:"journal_entries"`
	Custom_fields     JSON                 `json:"custom_fields"`
	Type              *ClusterTypeType     `json:"type,omitempty"`
	Group             *ClusterGroupType    `json:"group,omitempty"`
	Tenant            *TenantType          `json:"tenant,omitempty"`
	Virtual_machines  []VirtualMachineType `json:"virtual_machines"`
	Devices           []DeviceType         `json:"devices"`
	Id                string               `json:"id"`
	Created           *DateTime            `json:"created,omitempty"`
	Last_updated      *DateTime            `json:"last_updated,omitempty"`
	Custom_field_data JSON                 `json:"custom_field_data"`
	Description       string               `json:"description"`
	Comments          string               `json:"comments"`
	Name              string               `json:"name"`
	Status            string               `json:"status"`
	Scope             *ClusterScopeType    `json:"scope,omitempty"`
}

func (*ClusterType) isVLANGroupScopeType() {}

// A type of Cluster.
type ClusterTypeFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *ClusterTypeFilter    `json:"AND,omitempty"`
	OR                  *ClusterTypeFilter    `json:"OR,omitempty"`
	NOT                 *ClusterTypeFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A type of Cluster.
type ClusterTypeType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Clusters          []ClusterType      `json:"clusters"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
}

// A ConfigContext represents a set of arbitrary data available to any Device or VirtualMachine matching its assigned
// qualifiers (region, site, etc.). For example, the data stored in a ConfigContext assigned to site A and tenant B
// will be available to a Device in site A assigned to tenant B. Data is stored in JSON format.
type ConfigContextFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Is_active           *bool                 `json:"is_active,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Weight              *IntFilterLookup      `json:"weight,omitempty"`
	Auto_sync_enabled   *bool                 `json:"auto_sync_enabled,omitempty"`
	Data_synced         *DatetimeFilterLookup `json:"data_synced,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Platform_id         []string              `json:"platform_id,omitempty"`
	Platform            []string              `json:"platform,omitempty"`
	Cluster_type_id     []string              `json:"cluster_type_id,omitempty"`
	Cluster_type        []string              `json:"cluster_type,omitempty"`
	Cluster_group_id    []string              `json:"cluster_group_id,omitempty"`
	Cluster_group       []string              `json:"cluster_group,omitempty"`
	Cluster_id          []string              `json:"cluster_id,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Tag_id              []string              `json:"tag_id,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Data_source_id      []string              `json:"data_source_id,omitempty"`
	Data_file_id        []string              `json:"data_file_id,omitempty"`
	AND                 *ConfigContextFilter  `json:"AND,omitempty"`
	OR                  *ConfigContextFilter  `json:"OR,omitempty"`
	NOT                 *ConfigContextFilter  `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A ConfigContext represents a set of arbitrary data available to any Device or VirtualMachine matching its assigned
// qualifiers (region, site, etc.). For example, the data stored in a ConfigContext assigned to site A and tenant B
// will be available to a Device in site A assigned to tenant B. Data is stored in JSON format.
type ConfigContextType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Data_source       *DataSourceType    `json:"data_source,omitempty"`
	Data_file         *DataFileType      `json:"data_file,omitempty"`
	Roles             []DeviceRoleType   `json:"roles"`
	Device_types      []DeviceTypeType   `json:"device_types"`
	Tags              []TagType          `json:"tags"`
	Platforms         []PlatformType     `json:"platforms"`
	Regions           []RegionType       `json:"regions"`
	Cluster_groups    []ClusterGroupType `json:"cluster_groups"`
	Tenant_groups     []TenantGroupType  `json:"tenant_groups"`
	Cluster_types     []ClusterTypeType  `json:"cluster_types"`
	Clusters          []ClusterType      `json:"clusters"`
	Locations         []LocationType     `json:"locations"`
	Sites             []SiteType         `json:"sites"`
	Tenants           []TenantType       `json:"tenants"`
	Site_groups       []SiteGroupType    `json:"site_groups"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Data_path         string             `json:"data_path"`
	Auto_sync_enabled bool               `json:"auto_sync_enabled"`
	Data_synced       *DateTime          `json:"data_synced,omitempty"`
	Name              string             `json:"name"`
	Weight            int32              `json:"weight"`
	Description       string             `json:"description"`
	Is_active         bool               `json:"is_active"`
	Data              JSON               `json:"data"`
}

// ConfigTemplate(id, created, last_updated, data_source, data_file, data_path, auto_sync_enabled, data_synced, name, description, template_code, environment_params)
type ConfigTemplateFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Auto_sync_enabled   *bool                 `json:"auto_sync_enabled,omitempty"`
	Data_synced         *DatetimeFilterLookup `json:"data_synced,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Data_source_id      []string              `json:"data_source_id,omitempty"`
	Data_file_id        []string              `json:"data_file_id,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *ConfigTemplateFilter `json:"AND,omitempty"`
	OR                  *ConfigTemplateFilter `json:"OR,omitempty"`
	NOT                 *ConfigTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// ConfigTemplate(id, created, last_updated, data_source, data_file, data_path, auto_sync_enabled, data_synced, name, description, template_code, environment_params)
type ConfigTemplateType struct {
	Tags               []TagType            `json:"tags"`
	Changelog          []ObjectChangeType   `json:"changelog"`
	Display            string               `json:"display"`
	Class_type         string               `json:"class_type"`
	Data_source        *DataSourceType      `json:"data_source,omitempty"`
	Data_file          *DataFileType        `json:"data_file,omitempty"`
	Virtualmachines    []VirtualMachineType `json:"virtualmachines"`
	Devices            []DeviceType         `json:"devices"`
	Platforms          []PlatformType       `json:"platforms"`
	Device_roles       []DeviceRoleType     `json:"device_roles"`
	Id                 string               `json:"id"`
	Created            *DateTime            `json:"created,omitempty"`
	Last_updated       *DateTime            `json:"last_updated,omitempty"`
	Data_path          string               `json:"data_path"`
	Auto_sync_enabled  bool                 `json:"auto_sync_enabled"`
	Data_synced        *DateTime            `json:"data_synced,omitempty"`
	Name               string               `json:"name"`
	Description        string               `json:"description"`
	Template_code      string               `json:"template_code"`
	Environment_params *JSON                `json:"environment_params,omitempty"`
}

type ConnectedEndpointType struct {
	// Underlying value of the GraphQL union
	Value ConnectedEndpointTypeValue `json:"-"`
}

func (base *ConnectedEndpointType) UnmarshalJSON(b []byte) error {
	type Raw ConnectedEndpointType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "CircuitTerminationType":
		base.Value = new(CircuitTerminationType)
	case "ConsolePortType":
		base.Value = new(ConsolePortType)
	case "ConsoleServerPortType":
		base.Value = new(ConsoleServerPortType)
	case "FrontPortType":
		base.Value = new(FrontPortType)
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "PowerFeedType":
		base.Value = new(PowerFeedType)
	case "PowerOutletType":
		base.Value = new(PowerOutletType)
	case "PowerPortType":
		base.Value = new(PowerPortType)
	case "ProviderNetworkType":
		base.Value = new(ProviderNetworkType)
	case "RearPortType":
		base.Value = new(RearPortType)
	case "":
		return fmt.Errorf("gqlclient: union ConnectedEndpointType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union ConnectedEndpointType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// ConnectedEndpointTypeValue is one of: CircuitTerminationType | ConsolePortType | ConsoleServerPortType | FrontPortType | InterfaceType | PowerFeedType | PowerOutletType | PowerPortType | ProviderNetworkType | RearPortType
type ConnectedEndpointTypeValue interface {
	isConnectedEndpointType()
}

// A physical console port within a Device. ConsolePorts connect to ConsoleServerPorts.
type ConsolePortFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Speed               *IntFilterLookup      `json:"speed,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Mark_connected      *bool                 `json:"mark_connected,omitempty"`
	Cable_end           *StrFilterLookup      `json:"cable_end,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Module_id           []string              `json:"module_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Cable_id            []string              `json:"cable_id,omitempty"`
	Cabled              *bool                 `json:"cabled,omitempty"`
	Occupied            *bool                 `json:"occupied,omitempty"`
	Connected           *bool                 `json:"connected,omitempty"`
	Type                *string               `json:"type,omitempty"`
	AND                 *ConsolePortFilter    `json:"AND,omitempty"`
	OR                  *ConsolePortFilter    `json:"OR,omitempty"`
	NOT                 *ConsolePortFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A template for a ConsolePort to be created for a new Device.
type ConsolePortTemplateFilter struct {
	Id                  *IDFilterLookup            `json:"id,omitempty"`
	Name                *StrFilterLookup           `json:"name,omitempty"`
	Label               *StrFilterLookup           `json:"label,omitempty"`
	Type                *StrFilterLookup           `json:"type,omitempty"`
	Description         *StrFilterLookup           `json:"description,omitempty"`
	Created             *DatetimeFilterLookup      `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup      `json:"last_updated,omitempty"`
	Created_by_request  *string                    `json:"created_by_request,omitempty"`
	Updated_by_request  *string                    `json:"updated_by_request,omitempty"`
	Modified_by_request *string                    `json:"modified_by_request,omitempty"`
	Q                   *string                    `json:"q,omitempty"`
	Device_type_id      []string                   `json:"device_type_id,omitempty"`
	Module_type_id      []string                   `json:"module_type_id,omitempty"`
	AND                 *ConsolePortTemplateFilter `json:"AND,omitempty"`
	OR                  *ConsolePortTemplateFilter `json:"OR,omitempty"`
	NOT                 *ConsolePortTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                      `json:"DISTINCT,omitempty"`
}

// A template for a ConsolePort to be created for a new Device.
type ConsolePortTemplateType struct {
	Changelog    []ObjectChangeType `json:"changelog"`
	Display      string             `json:"display"`
	Class_type   string             `json:"class_type"`
	Device_type  *DeviceTypeType    `json:"device_type,omitempty"`
	Module_type  *ModuleTypeType    `json:"module_type,omitempty"`
	Id           string             `json:"id"`
	Created      *DateTime          `json:"created,omitempty"`
	Last_updated *DateTime          `json:"last_updated,omitempty"`
	Name         string             `json:"name"`
	Label        string             `json:"label"`
	Description  string             `json:"description"`
	Type         *string            `json:"type,omitempty"`
}

// A physical console port within a Device. ConsolePorts connect to ConsoleServerPorts.
type ConsolePortType struct {
	Changelog           []ObjectChangeType      `json:"changelog"`
	Custom_fields       JSON                    `json:"custom_fields"`
	Tags                []TagType               `json:"tags"`
	Display             string                  `json:"display"`
	Class_type          string                  `json:"class_type"`
	Device              *DeviceType             `json:"device"`
	Module              *ModuleType             `json:"module,omitempty"`
	Cable               *CableType              `json:"cable,omitempty"`
	Link_peers          []LinkPeerType          `json:"link_peers"`
	Connected_endpoints []ConnectedEndpointType `json:"connected_endpoints"`
	Id                  string                  `json:"id"`
	Created             *DateTime               `json:"created,omitempty"`
	Last_updated        *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data   JSON                    `json:"custom_field_data"`
	Name                string                  `json:"name"`
	Label               string                  `json:"label"`
	Description         string                  `json:"description"`
	Cable_end           *string                 `json:"cable_end,omitempty"`
	Mark_connected      bool                    `json:"mark_connected"`
	Type                *string                 `json:"type,omitempty"`
	Speed               *int32                  `json:"speed,omitempty"`
}

func (*ConsolePortType) isLinkPeerType() {}

func (*ConsolePortType) isInventoryItemComponentType() {}

func (*ConsolePortType) isConnectedEndpointType() {}

func (*ConsolePortType) isInventoryItemTemplateComponentType() {}

func (*ConsolePortType) isCableTerminationTerminationType() {}

// A physical port within a Device (typically a designated console server) which provides access to ConsolePorts.
type ConsoleServerPortFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Label               *StrFilterLookup         `json:"label,omitempty"`
	Speed               *IntFilterLookup         `json:"speed,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Mark_connected      *bool                    `json:"mark_connected,omitempty"`
	Cable_end           *StrFilterLookup         `json:"cable_end,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Region_id           []string                 `json:"region_id,omitempty"`
	Region              []string                 `json:"region,omitempty"`
	Site_group_id       []string                 `json:"site_group_id,omitempty"`
	Site_group          []string                 `json:"site_group,omitempty"`
	Site_id             []string                 `json:"site_id,omitempty"`
	Site                []string                 `json:"site,omitempty"`
	Location_id         []string                 `json:"location_id,omitempty"`
	Location            []string                 `json:"location,omitempty"`
	Rack_id             []string                 `json:"rack_id,omitempty"`
	Rack                []string                 `json:"rack,omitempty"`
	Device_id           []string                 `json:"device_id,omitempty"`
	Device              []string                 `json:"device,omitempty"`
	Device_type_id      []string                 `json:"device_type_id,omitempty"`
	Device_type         []string                 `json:"device_type,omitempty"`
	Device_role_id      []string                 `json:"device_role_id,omitempty"`
	Device_role         []string                 `json:"device_role,omitempty"`
	Virtual_chassis_id  []string                 `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string                 `json:"virtual_chassis,omitempty"`
	Device_status       *string                  `json:"device_status,omitempty"`
	Module_id           []string                 `json:"module_id,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Tag                 []string                 `json:"tag,omitempty"`
	Cable_id            []string                 `json:"cable_id,omitempty"`
	Cabled              *bool                    `json:"cabled,omitempty"`
	Occupied            *bool                    `json:"occupied,omitempty"`
	Connected           *bool                    `json:"connected,omitempty"`
	Type                *string                  `json:"type,omitempty"`
	AND                 *ConsoleServerPortFilter `json:"AND,omitempty"`
	OR                  *ConsoleServerPortFilter `json:"OR,omitempty"`
	NOT                 *ConsoleServerPortFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// A template for a ConsoleServerPort to be created for a new Device.
type ConsoleServerPortTemplateFilter struct {
	Id                  *IDFilterLookup                  `json:"id,omitempty"`
	Name                *StrFilterLookup                 `json:"name,omitempty"`
	Label               *StrFilterLookup                 `json:"label,omitempty"`
	Type                *StrFilterLookup                 `json:"type,omitempty"`
	Description         *StrFilterLookup                 `json:"description,omitempty"`
	Created             *DatetimeFilterLookup            `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup            `json:"last_updated,omitempty"`
	Created_by_request  *string                          `json:"created_by_request,omitempty"`
	Updated_by_request  *string                          `json:"updated_by_request,omitempty"`
	Modified_by_request *string                          `json:"modified_by_request,omitempty"`
	Q                   *string                          `json:"q,omitempty"`
	Device_type_id      []string                         `json:"device_type_id,omitempty"`
	Module_type_id      []string                         `json:"module_type_id,omitempty"`
	AND                 *ConsoleServerPortTemplateFilter `json:"AND,omitempty"`
	OR                  *ConsoleServerPortTemplateFilter `json:"OR,omitempty"`
	NOT                 *ConsoleServerPortTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                            `json:"DISTINCT,omitempty"`
}

// A template for a ConsoleServerPort to be created for a new Device.
type ConsoleServerPortTemplateType struct {
	Changelog    []ObjectChangeType `json:"changelog"`
	Display      string             `json:"display"`
	Class_type   string             `json:"class_type"`
	Device_type  *DeviceTypeType    `json:"device_type,omitempty"`
	Module_type  *ModuleTypeType    `json:"module_type,omitempty"`
	Id           string             `json:"id"`
	Created      *DateTime          `json:"created,omitempty"`
	Last_updated *DateTime          `json:"last_updated,omitempty"`
	Name         string             `json:"name"`
	Label        string             `json:"label"`
	Description  string             `json:"description"`
	Type         *string            `json:"type,omitempty"`
}

// A physical port within a Device (typically a designated console server) which provides access to ConsolePorts.
type ConsoleServerPortType struct {
	Changelog           []ObjectChangeType      `json:"changelog"`
	Custom_fields       JSON                    `json:"custom_fields"`
	Tags                []TagType               `json:"tags"`
	Display             string                  `json:"display"`
	Class_type          string                  `json:"class_type"`
	Device              *DeviceType             `json:"device"`
	Module              *ModuleType             `json:"module,omitempty"`
	Cable               *CableType              `json:"cable,omitempty"`
	Link_peers          []LinkPeerType          `json:"link_peers"`
	Connected_endpoints []ConnectedEndpointType `json:"connected_endpoints"`
	Id                  string                  `json:"id"`
	Created             *DateTime               `json:"created,omitempty"`
	Last_updated        *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data   JSON                    `json:"custom_field_data"`
	Name                string                  `json:"name"`
	Label               string                  `json:"label"`
	Description         string                  `json:"description"`
	Cable_end           *string                 `json:"cable_end,omitempty"`
	Mark_connected      bool                    `json:"mark_connected"`
	Type                *string                 `json:"type,omitempty"`
	Speed               *int32                  `json:"speed,omitempty"`
}

func (*ConsoleServerPortType) isLinkPeerType() {}

func (*ConsoleServerPortType) isInventoryItemComponentType() {}

func (*ConsoleServerPortType) isConnectedEndpointType() {}

func (*ConsoleServerPortType) isInventoryItemTemplateComponentType() {}

func (*ConsoleServerPortType) isCableTerminationTerminationType() {}

// ContactAssignment(id, created, last_updated, custom_field_data, object_type, object_id, contact, role, priority)
type ContactAssignmentFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Object_type_id      *IDFilterLookup          `json:"object_type_id,omitempty"`
	Object_id           *IntFilterLookup         `json:"object_id,omitempty"`
	Priority            *StrFilterLookup         `json:"priority,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Tag                 []string                 `json:"tag,omitempty"`
	Object_type         *string                  `json:"object_type,omitempty"`
	Contact_id          []string                 `json:"contact_id,omitempty"`
	Group_id            []string                 `json:"group_id,omitempty"`
	Group               []string                 `json:"group,omitempty"`
	Role_id             []string                 `json:"role_id,omitempty"`
	Role                []string                 `json:"role,omitempty"`
	AND                 *ContactAssignmentFilter `json:"AND,omitempty"`
	OR                  *ContactAssignmentFilter `json:"OR,omitempty"`
	NOT                 *ContactAssignmentFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// ContactAssignment(id, created, last_updated, custom_field_data, object_type, object_id, contact, role, priority)
type ContactAssignmentType struct {
	Custom_fields     JSON             `json:"custom_fields"`
	Tags              []TagType        `json:"tags"`
	Display           string           `json:"display"`
	Class_type        string           `json:"class_type"`
	Object_type       *ContentTypeType `json:"object_type,omitempty"`
	Contact           *ContactType     `json:"contact,omitempty"`
	Role              *ContactRoleType `json:"role,omitempty"`
	Id                string           `json:"id"`
	Created           *DateTime        `json:"created,omitempty"`
	Last_updated      *DateTime        `json:"last_updated,omitempty"`
	Custom_field_data JSON             `json:"custom_field_data"`
	Object_id         int32            `json:"object_id"`
	Priority          *string          `json:"priority,omitempty"`
}

// Contact information for a particular object(s) in NetBox.
type ContactFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Title               *StrFilterLookup      `json:"title,omitempty"`
	Phone               *StrFilterLookup      `json:"phone,omitempty"`
	Email               *StrFilterLookup      `json:"email,omitempty"`
	Address             *StrFilterLookup      `json:"address,omitempty"`
	Link                *StrFilterLookup      `json:"link,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Group_id            []string              `json:"group_id,omitempty"`
	Group               []string              `json:"group,omitempty"`
	AND                 *ContactFilter        `json:"AND,omitempty"`
	OR                  *ContactFilter        `json:"OR,omitempty"`
	NOT                 *ContactFilter        `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An arbitrary collection of Contacts.
type ContactGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Parent_id           []string              `json:"parent_id,omitempty"`
	Parent              []string              `json:"parent,omitempty"`
	Ancestor_id         []string              `json:"ancestor_id,omitempty"`
	Ancestor            []string              `json:"ancestor,omitempty"`
	AND                 *ContactGroupFilter   `json:"AND,omitempty"`
	OR                  *ContactGroupFilter   `json:"OR,omitempty"`
	NOT                 *ContactGroupFilter   `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An arbitrary collection of Contacts.
type ContactGroupType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Parent            *ContactGroupType  `json:"parent,omitempty"`
	Contacts          []ContactType      `json:"contacts"`
	Children          []ContactGroupType `json:"children"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
	Lft               int32              `json:"lft"`
	Rght              int32              `json:"rght"`
	Tree_id           int32              `json:"tree_id"`
	Level             int32              `json:"level"`
}

// Functional role for a Contact assigned to an object.
type ContactRoleFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *ContactRoleFilter    `json:"AND,omitempty"`
	OR                  *ContactRoleFilter    `json:"OR,omitempty"`
	NOT                 *ContactRoleFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Functional role for a Contact assigned to an object.
type ContactRoleType struct {
	Assignments       []ContactAssignmentType `json:"assignments"`
	Changelog         []ObjectChangeType      `json:"changelog"`
	Display           string                  `json:"display"`
	Class_type        string                  `json:"class_type"`
	Tags              []TagType               `json:"tags"`
	Custom_fields     JSON                    `json:"custom_fields"`
	Id                string                  `json:"id"`
	Created           *DateTime               `json:"created,omitempty"`
	Last_updated      *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data JSON                    `json:"custom_field_data"`
	Name              string                  `json:"name"`
	Slug              string                  `json:"slug"`
	Description       string                  `json:"description"`
}

// Contact information for a particular object(s) in NetBox.
type ContactType struct {
	Assignments       []ContactAssignmentType `json:"assignments"`
	Changelog         []ObjectChangeType      `json:"changelog"`
	Display           string                  `json:"display"`
	Class_type        string                  `json:"class_type"`
	Tags              []TagType               `json:"tags"`
	Journal_entries   []JournalEntryType      `json:"journal_entries"`
	Custom_fields     JSON                    `json:"custom_fields"`
	Group             *ContactGroupType       `json:"group,omitempty"`
	Id                string                  `json:"id"`
	Created           *DateTime               `json:"created,omitempty"`
	Last_updated      *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data JSON                    `json:"custom_field_data"`
	Description       string                  `json:"description"`
	Comments          string                  `json:"comments"`
	Name              string                  `json:"name"`
	Title             string                  `json:"title"`
	Phone             string                  `json:"phone"`
	Email             string                  `json:"email"`
	Address           string                  `json:"address"`
	Link              string                  `json:"link"`
}

// ContentType(id, app_label, model)
type ContentTypeType struct {
	Id        string `json:"id"`
	App_label string `json:"app_label"`
	Model     string `json:"model"`
}

// Represents a set of choices available for choice and multi-choice custom fields.
type CustomFieldChoiceSetFilter struct {
	Id                   *IDFilterLookup             `json:"id,omitempty"`
	Name                 *StrFilterLookup            `json:"name,omitempty"`
	Description          *StrFilterLookup            `json:"description,omitempty"`
	Base_choices         *StrFilterLookup            `json:"base_choices,omitempty"`
	Order_alphabetically *bool                       `json:"order_alphabetically,omitempty"`
	Created              *DatetimeFilterLookup       `json:"created,omitempty"`
	Last_updated         *DatetimeFilterLookup       `json:"last_updated,omitempty"`
	Created_by_request   *string                     `json:"created_by_request,omitempty"`
	Updated_by_request   *string                     `json:"updated_by_request,omitempty"`
	Modified_by_request  *string                     `json:"modified_by_request,omitempty"`
	Q                    *string                     `json:"q,omitempty"`
	Choice               *StrFilterLookup            `json:"choice,omitempty"`
	AND                  *CustomFieldChoiceSetFilter `json:"AND,omitempty"`
	OR                   *CustomFieldChoiceSetFilter `json:"OR,omitempty"`
	NOT                  *CustomFieldChoiceSetFilter `json:"NOT,omitempty"`
	DISTINCT             *bool                       `json:"DISTINCT,omitempty"`
}

// Represents a set of choices available for choice and multi-choice custom fields.
type CustomFieldChoiceSetType struct {
	Changelog            []ObjectChangeType `json:"changelog"`
	Display              string             `json:"display"`
	Class_type           string             `json:"class_type"`
	Choices_for          []CustomFieldType  `json:"choices_for"`
	Extra_choices        [][]string         `json:"extra_choices,omitempty"`
	Id                   string             `json:"id"`
	Created              *DateTime          `json:"created,omitempty"`
	Last_updated         *DateTime          `json:"last_updated,omitempty"`
	Name                 string             `json:"name"`
	Description          string             `json:"description"`
	Base_choices         *string            `json:"base_choices,omitempty"`
	Order_alphabetically bool               `json:"order_alphabetically"`
}

// CustomField(id, created, last_updated, type, related_object_type, name, label, group_name, description, required, unique, search_weight, filter_logic, default, related_object_filter, weight, validation_minimum, validation_maximum, validation_regex, choice_set, ui_visible, ui_editable, is_cloneable, comments)
type CustomFieldFilter struct {
	Id                     *IDFilterLookup       `json:"id,omitempty"`
	Name                   *StrFilterLookup      `json:"name,omitempty"`
	Label                  *StrFilterLookup      `json:"label,omitempty"`
	Group_name             *StrFilterLookup      `json:"group_name,omitempty"`
	Required               *bool                 `json:"required,omitempty"`
	Unique                 *bool                 `json:"unique,omitempty"`
	Search_weight          *IntFilterLookup      `json:"search_weight,omitempty"`
	Filter_logic           *StrFilterLookup      `json:"filter_logic,omitempty"`
	Ui_visible             *StrFilterLookup      `json:"ui_visible,omitempty"`
	Ui_editable            *StrFilterLookup      `json:"ui_editable,omitempty"`
	Weight                 *IntFilterLookup      `json:"weight,omitempty"`
	Is_cloneable           *bool                 `json:"is_cloneable,omitempty"`
	Description            *StrFilterLookup      `json:"description,omitempty"`
	Validation_minimum     *IntFilterLookup      `json:"validation_minimum,omitempty"`
	Validation_maximum     *IntFilterLookup      `json:"validation_maximum,omitempty"`
	Validation_regex       *StrFilterLookup      `json:"validation_regex,omitempty"`
	Created                *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated           *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request     *string               `json:"created_by_request,omitempty"`
	Updated_by_request     *string               `json:"updated_by_request,omitempty"`
	Modified_by_request    *string               `json:"modified_by_request,omitempty"`
	Q                      *string               `json:"q,omitempty"`
	Type                   *string               `json:"type,omitempty"`
	Object_type_id         []string              `json:"object_type_id,omitempty"`
	Object_type            *string               `json:"object_type,omitempty"`
	Related_object_type_id []string              `json:"related_object_type_id,omitempty"`
	Related_object_type    *string               `json:"related_object_type,omitempty"`
	Choice_set_id          []string              `json:"choice_set_id,omitempty"`
	Choice_set             []string              `json:"choice_set,omitempty"`
	AND                    *CustomFieldFilter    `json:"AND,omitempty"`
	OR                     *CustomFieldFilter    `json:"OR,omitempty"`
	NOT                    *CustomFieldFilter    `json:"NOT,omitempty"`
	DISTINCT               *bool                 `json:"DISTINCT,omitempty"`
}

// CustomField(id, created, last_updated, type, related_object_type, name, label, group_name, description, required, unique, search_weight, filter_logic, default, related_object_filter, weight, validation_minimum, validation_maximum, validation_regex, choice_set, ui_visible, ui_editable, is_cloneable, comments)
type CustomFieldType struct {
	Changelog             []ObjectChangeType        `json:"changelog"`
	Display               string                    `json:"display"`
	Class_type            string                    `json:"class_type"`
	Related_object_type   *ContentTypeType          `json:"related_object_type,omitempty"`
	Choice_set            *CustomFieldChoiceSetType `json:"choice_set,omitempty"`
	Id                    string                    `json:"id"`
	Created               *DateTime                 `json:"created,omitempty"`
	Last_updated          *DateTime                 `json:"last_updated,omitempty"`
	Type                  string                    `json:"type"`
	Name                  string                    `json:"name"`
	Label                 string                    `json:"label"`
	Group_name            string                    `json:"group_name"`
	Description           string                    `json:"description"`
	Required              bool                      `json:"required"`
	Unique                bool                      `json:"unique"`
	Search_weight         int32                     `json:"search_weight"`
	Filter_logic          string                    `json:"filter_logic"`
	Default               *JSON                     `json:"default,omitempty"`
	Related_object_filter *JSON                     `json:"related_object_filter,omitempty"`
	Weight                int32                     `json:"weight"`
	Validation_minimum    *int32                    `json:"validation_minimum,omitempty"`
	Validation_maximum    *int32                    `json:"validation_maximum,omitempty"`
	Validation_regex      string                    `json:"validation_regex"`
	Ui_visible            string                    `json:"ui_visible"`
	Ui_editable           string                    `json:"ui_editable"`
	Is_cloneable          bool                      `json:"is_cloneable"`
	Comments              string                    `json:"comments"`
}

// A custom link to an external representation of a NetBox object. The link text and URL fields accept Jinja2 template
// code to be rendered with an object as context.
type CustomLinkFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Enabled             *bool                 `json:"enabled,omitempty"`
	Link_text           *StrFilterLookup      `json:"link_text,omitempty"`
	Link_url            *StrFilterLookup      `json:"link_url,omitempty"`
	Weight              *IntFilterLookup      `json:"weight,omitempty"`
	Group_name          *StrFilterLookup      `json:"group_name,omitempty"`
	New_window          *bool                 `json:"new_window,omitempty"`
	Button_class        *StrFilterLookup      `json:"button_class,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Object_type_id      []string              `json:"object_type_id,omitempty"`
	Object_type         *string               `json:"object_type,omitempty"`
	AND                 *CustomLinkFilter     `json:"AND,omitempty"`
	OR                  *CustomLinkFilter     `json:"OR,omitempty"`
	NOT                 *CustomLinkFilter     `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A custom link to an external representation of a NetBox object. The link text and URL fields accept Jinja2 template
// code to be rendered with an object as context.
type CustomLinkType struct {
	Changelog    []ObjectChangeType `json:"changelog"`
	Display      string             `json:"display"`
	Class_type   string             `json:"class_type"`
	Id           string             `json:"id"`
	Created      *DateTime          `json:"created,omitempty"`
	Last_updated *DateTime          `json:"last_updated,omitempty"`
	Name         string             `json:"name"`
	Enabled      bool               `json:"enabled"`
	Link_text    string             `json:"link_text"`
	Link_url     string             `json:"link_url"`
	Weight       int32              `json:"weight"`
	Group_name   string             `json:"group_name"`
	Button_class string             `json:"button_class"`
	New_window   bool               `json:"new_window"`
}

// The database representation of a remote file fetched from a remote DataSource. DataFile instances should be created,
// updated, or deleted only by calling DataSource.sync().
type DataFileFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Path                *StrFilterLookup      `json:"path,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Size                *IntFilterLookup      `json:"size,omitempty"`
	Hash                *StrFilterLookup      `json:"hash,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Source_id           []string              `json:"source_id,omitempty"`
	Source              []string              `json:"source,omitempty"`
	AND                 *DataFileFilter       `json:"AND,omitempty"`
	OR                  *DataFileFilter       `json:"OR,omitempty"`
	NOT                 *DataFileFilter       `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// The database representation of a remote file fetched from a remote DataSource. DataFile instances should be created,
// updated, or deleted only by calling DataSource.sync().
type DataFileType struct {
	Display      string          `json:"display"`
	Class_type   string          `json:"class_type"`
	Source       *DataSourceType `json:"source"`
	Id           string          `json:"id"`
	Created      DateTime        `json:"created"`
	Last_updated DateTime        `json:"last_updated"`
	Path         string          `json:"path"`
	Size         int32           `json:"size"`
	Hash         string          `json:"hash"`
}

// A remote source, such as a git repository, from which DataFiles are synchronized.
type DataSourceFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Enabled             *bool                 `json:"enabled,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Source_url          *StrFilterLookup      `json:"source_url,omitempty"`
	Last_synced         *DatetimeFilterLookup `json:"last_synced,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Type                *string               `json:"type,omitempty"`
	Status              *string               `json:"status,omitempty"`
	AND                 *DataSourceFilter     `json:"AND,omitempty"`
	OR                  *DataSourceFilter     `json:"OR,omitempty"`
	NOT                 *DataSourceFilter     `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A remote source, such as a git repository, from which DataFiles are synchronized.
type DataSourceType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Datafiles         []DataFileType     `json:"datafiles"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Name              string             `json:"name"`
	Type              string             `json:"type"`
	Source_url        string             `json:"source_url"`
	Status            string             `json:"status"`
	Enabled           bool               `json:"enabled"`
	Ignore_rules      string             `json:"ignore_rules"`
	Parameters        *JSON              `json:"parameters,omitempty"`
	Last_synced       *DateTime          `json:"last_synced,omitempty"`
}

// Date (isoformat)
type Date string

type DateFilterLookup struct {
	Exact         *Date   `json:"exact,omitempty"`
	I_exact       *Date   `json:"i_exact,omitempty"`
	Contains      *Date   `json:"contains,omitempty"`
	I_contains    *Date   `json:"i_contains,omitempty"`
	In_list       []Date  `json:"in_list,omitempty"`
	Gt            *Date   `json:"gt,omitempty"`
	Gte           *Date   `json:"gte,omitempty"`
	Lt            *Date   `json:"lt,omitempty"`
	Lte           *Date   `json:"lte,omitempty"`
	Starts_with   *Date   `json:"starts_with,omitempty"`
	I_starts_with *Date   `json:"i_starts_with,omitempty"`
	Ends_with     *Date   `json:"ends_with,omitempty"`
	I_ends_with   *Date   `json:"i_ends_with,omitempty"`
	Range         []Date  `json:"range,omitempty"`
	Is_null       *bool   `json:"is_null,omitempty"`
	Regex         *string `json:"regex,omitempty"`
	I_regex       *string `json:"i_regex,omitempty"`
}

// Date with time (isoformat)
type DateTime string

type DatetimeFilterLookup struct {
	Exact         *DateTime  `json:"exact,omitempty"`
	I_exact       *DateTime  `json:"i_exact,omitempty"`
	Contains      *DateTime  `json:"contains,omitempty"`
	I_contains    *DateTime  `json:"i_contains,omitempty"`
	In_list       []DateTime `json:"in_list,omitempty"`
	Gt            *DateTime  `json:"gt,omitempty"`
	Gte           *DateTime  `json:"gte,omitempty"`
	Lt            *DateTime  `json:"lt,omitempty"`
	Lte           *DateTime  `json:"lte,omitempty"`
	Starts_with   *DateTime  `json:"starts_with,omitempty"`
	I_starts_with *DateTime  `json:"i_starts_with,omitempty"`
	Ends_with     *DateTime  `json:"ends_with,omitempty"`
	I_ends_with   *DateTime  `json:"i_ends_with,omitempty"`
	Range         []DateTime `json:"range,omitempty"`
	Is_null       *bool      `json:"is_null,omitempty"`
	Regex         *string    `json:"regex,omitempty"`
	I_regex       *string    `json:"i_regex,omitempty"`
}

// Decimal (fixed-point)
type Decimal string

type DecimalFilterLookup struct {
	Exact         *Decimal  `json:"exact,omitempty"`
	I_exact       *Decimal  `json:"i_exact,omitempty"`
	Contains      *Decimal  `json:"contains,omitempty"`
	I_contains    *Decimal  `json:"i_contains,omitempty"`
	In_list       []Decimal `json:"in_list,omitempty"`
	Gt            *Decimal  `json:"gt,omitempty"`
	Gte           *Decimal  `json:"gte,omitempty"`
	Lt            *Decimal  `json:"lt,omitempty"`
	Lte           *Decimal  `json:"lte,omitempty"`
	Starts_with   *Decimal  `json:"starts_with,omitempty"`
	I_starts_with *Decimal  `json:"i_starts_with,omitempty"`
	Ends_with     *Decimal  `json:"ends_with,omitempty"`
	I_ends_with   *Decimal  `json:"i_ends_with,omitempty"`
	Range         []Decimal `json:"range,omitempty"`
	Is_null       *bool     `json:"is_null,omitempty"`
	Regex         *string   `json:"regex,omitempty"`
	I_regex       *string   `json:"i_regex,omitempty"`
}

// An empty space within a Device which can house a child device
type DeviceBayFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Installed_device_id []string              `json:"installed_device_id,omitempty"`
	Installed_device    []string              `json:"installed_device,omitempty"`
	AND                 *DeviceBayFilter      `json:"AND,omitempty"`
	OR                  *DeviceBayFilter      `json:"OR,omitempty"`
	NOT                 *DeviceBayFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A template for a DeviceBay to be created for a new parent Device.
type DeviceBayTemplateFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Label               *StrFilterLookup         `json:"label,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Device_type_id      []string                 `json:"device_type_id,omitempty"`
	AND                 *DeviceBayTemplateFilter `json:"AND,omitempty"`
	OR                  *DeviceBayTemplateFilter `json:"OR,omitempty"`
	NOT                 *DeviceBayTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// A template for a DeviceBay to be created for a new parent Device.
type DeviceBayTemplateType struct {
	Changelog    []ObjectChangeType `json:"changelog"`
	Display      string             `json:"display"`
	Class_type   string             `json:"class_type"`
	Device_type  *DeviceTypeType    `json:"device_type"`
	Id           string             `json:"id"`
	Created      *DateTime          `json:"created,omitempty"`
	Last_updated *DateTime          `json:"last_updated,omitempty"`
	Name         string             `json:"name"`
	Label        string             `json:"label"`
	Description  string             `json:"description"`
}

// An empty space within a Device which can house a child device
type DeviceBayType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Custom_fields     JSON               `json:"custom_fields"`
	Tags              []TagType          `json:"tags"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Device            *DeviceType        `json:"device"`
	Installed_device  *DeviceType        `json:"installed_device,omitempty"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Label             string             `json:"label"`
	Description       string             `json:"description"`
}

// A Device represents a piece of physical hardware mounted within a Rack. Each Device is assigned a DeviceType,
// DeviceRole, and (optionally) a Platform. Device names are not required, however if one is set it must be unique.
//
// Each Device must be assigned to a site, and optionally to a rack within that site. Associating a device with a
// particular rack face or unit is optional (for example, vertically mounted PDUs do not consume rack units).
//
// When a new Device is created, console/power/interface/device bay components are created along with it as dictated
// by the component templates assigned to its DeviceType. Components can also be added, modified, or deleted after the
// creation of a Device.
type DeviceFilter struct {
	Id                         *IDFilterLookup       `json:"id,omitempty"`
	Asset_tag                  *StrFilterLookup      `json:"asset_tag,omitempty"`
	Face                       *StrFilterLookup      `json:"face,omitempty"`
	Position                   *DecimalFilterLookup  `json:"position,omitempty"`
	Latitude                   *DecimalFilterLookup  `json:"latitude,omitempty"`
	Longitude                  *DecimalFilterLookup  `json:"longitude,omitempty"`
	Airflow                    *StrFilterLookup      `json:"airflow,omitempty"`
	Vc_position                *IntFilterLookup      `json:"vc_position,omitempty"`
	Vc_priority                *IntFilterLookup      `json:"vc_priority,omitempty"`
	Description                *StrFilterLookup      `json:"description,omitempty"`
	Console_port_count         *Union                `json:"console_port_count,omitempty"`
	Console_server_port_count  *Union                `json:"console_server_port_count,omitempty"`
	Power_port_count           *Union                `json:"power_port_count,omitempty"`
	Power_outlet_count         *Union                `json:"power_outlet_count,omitempty"`
	Interface_count            *Union                `json:"interface_count,omitempty"`
	Front_port_count           *Union                `json:"front_port_count,omitempty"`
	Rear_port_count            *Union                `json:"rear_port_count,omitempty"`
	Device_bay_count           *Union                `json:"device_bay_count,omitempty"`
	Module_bay_count           *Union                `json:"module_bay_count,omitempty"`
	Inventory_item_count       *Union                `json:"inventory_item_count,omitempty"`
	Created                    *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated               *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request         *string               `json:"created_by_request,omitempty"`
	Updated_by_request         *string               `json:"updated_by_request,omitempty"`
	Modified_by_request        *string               `json:"modified_by_request,omitempty"`
	Q                          *string               `json:"q,omitempty"`
	Tag                        []string              `json:"tag,omitempty"`
	Tenant_group_id            []string              `json:"tenant_group_id,omitempty"`
	Tenant_group               []string              `json:"tenant_group,omitempty"`
	Tenant_id                  []string              `json:"tenant_id,omitempty"`
	Tenant                     []string              `json:"tenant,omitempty"`
	Contact                    []string              `json:"contact,omitempty"`
	Contact_role               []string              `json:"contact_role,omitempty"`
	Contact_group              []string              `json:"contact_group,omitempty"`
	Local_context_data         *bool                 `json:"local_context_data,omitempty"`
	Primary_ip4_id             []string              `json:"primary_ip4_id,omitempty"`
	Primary_ip6_id             []string              `json:"primary_ip6_id,omitempty"`
	Manufacturer_id            []string              `json:"manufacturer_id,omitempty"`
	Manufacturer               []string              `json:"manufacturer,omitempty"`
	Device_type                []string              `json:"device_type,omitempty"`
	Device_type_id             []string              `json:"device_type_id,omitempty"`
	Role_id                    []string              `json:"role_id,omitempty"`
	Role                       []string              `json:"role,omitempty"`
	Parent_device_id           []string              `json:"parent_device_id,omitempty"`
	Platform_id                []string              `json:"platform_id,omitempty"`
	Platform                   []string              `json:"platform,omitempty"`
	Region_id                  []string              `json:"region_id,omitempty"`
	Region                     []string              `json:"region,omitempty"`
	Site_group_id              []string              `json:"site_group_id,omitempty"`
	Site_group                 []string              `json:"site_group,omitempty"`
	Site_id                    []string              `json:"site_id,omitempty"`
	Site                       []string              `json:"site,omitempty"`
	Location_id                []string              `json:"location_id,omitempty"`
	Rack_id                    []string              `json:"rack_id,omitempty"`
	Parent_bay_id              []string              `json:"parent_bay_id,omitempty"`
	Cluster_id                 []string              `json:"cluster_id,omitempty"`
	Cluster_group              []string              `json:"cluster_group,omitempty"`
	Cluster_group_id           []string              `json:"cluster_group_id,omitempty"`
	Model                      []string              `json:"model,omitempty"`
	Name                       *StrFilterLookup      `json:"name,omitempty"`
	Status                     *string               `json:"status,omitempty"`
	Is_full_depth              *bool                 `json:"is_full_depth,omitempty"`
	Mac_address                []string              `json:"mac_address,omitempty"`
	Serial                     *StrFilterLookup      `json:"serial,omitempty"`
	Has_primary_ip             *bool                 `json:"has_primary_ip,omitempty"`
	Has_oob_ip                 *bool                 `json:"has_oob_ip,omitempty"`
	Virtual_chassis_id         []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis_member     *bool                 `json:"virtual_chassis_member,omitempty"`
	Config_template_id         []string              `json:"config_template_id,omitempty"`
	Console_ports              *bool                 `json:"console_ports,omitempty"`
	Console_server_ports       *bool                 `json:"console_server_ports,omitempty"`
	Power_ports                *bool                 `json:"power_ports,omitempty"`
	Power_outlets              *bool                 `json:"power_outlets,omitempty"`
	Interfaces                 *bool                 `json:"interfaces,omitempty"`
	Pass_through_ports         *bool                 `json:"pass_through_ports,omitempty"`
	Module_bays                *bool                 `json:"module_bays,omitempty"`
	Device_bays                *bool                 `json:"device_bays,omitempty"`
	Oob_ip_id                  []string              `json:"oob_ip_id,omitempty"`
	Has_virtual_device_context *bool                 `json:"has_virtual_device_context,omitempty"`
	AND                        *DeviceFilter         `json:"AND,omitempty"`
	OR                         *DeviceFilter         `json:"OR,omitempty"`
	NOT                        *DeviceFilter         `json:"NOT,omitempty"`
	DISTINCT                   *bool                 `json:"DISTINCT,omitempty"`
}

// Devices are organized by functional role; for example, "Core Switch" or "File Server". Each DeviceRole is assigned a
// color to be used when displaying rack elevations. The vm_role field determines whether the role is applicable to
// virtual machines as well.
type DeviceRoleFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Color               []string              `json:"color,omitempty"`
	Vm_role             *bool                 `json:"vm_role,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Config_template_id  []string              `json:"config_template_id,omitempty"`
	AND                 *DeviceRoleFilter     `json:"AND,omitempty"`
	OR                  *DeviceRoleFilter     `json:"OR,omitempty"`
	NOT                 *DeviceRoleFilter     `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Devices are organized by functional role; for example, "Core Switch" or "File Server". Each DeviceRole is assigned a
// color to be used when displaying rack elevations. The vm_role field determines whether the role is applicable to
// virtual machines as well.
type DeviceRoleType struct {
	Changelog         []ObjectChangeType   `json:"changelog"`
	Display           string               `json:"display"`
	Class_type        string               `json:"class_type"`
	Tags              []TagType            `json:"tags"`
	Custom_fields     JSON                 `json:"custom_fields"`
	Color             string               `json:"color"`
	Config_template   *ConfigTemplateType  `json:"config_template,omitempty"`
	Virtual_machines  []VirtualMachineType `json:"virtual_machines"`
	Devices           []DeviceType         `json:"devices"`
	Id                string               `json:"id"`
	Created           *DateTime            `json:"created,omitempty"`
	Last_updated      *DateTime            `json:"last_updated,omitempty"`
	Custom_field_data JSON                 `json:"custom_field_data"`
	Name              string               `json:"name"`
	Slug              string               `json:"slug"`
	Description       string               `json:"description"`
	Vm_role           bool                 `json:"vm_role"`
}

// A Device represents a piece of physical hardware mounted within a Rack. Each Device is assigned a DeviceType,
// DeviceRole, and (optionally) a Platform. Device names are not required, however if one is set it must be unique.
//
// Each Device must be assigned to a site, and optionally to a rack within that site. Associating a device with a
// particular rack face or unit is optional (for example, vertically mounted PDUs do not consume rack units).
//
// When a new Device is created, console/power/interface/device bay components are created along with it as dictated
// by the component templates assigned to its DeviceType. Components can also be added, modified, or deleted after the
// creation of a Device.
type DeviceType struct {
	Config_context            JSON                       `json:"config_context"`
	Image_attachments         []ImageAttachmentType      `json:"image_attachments"`
	Contacts                  []ContactAssignmentType    `json:"contacts"`
	Changelog                 []ObjectChangeType         `json:"changelog"`
	Display                   string                     `json:"display"`
	Class_type                string                     `json:"class_type"`
	Tags                      []TagType                  `json:"tags"`
	Journal_entries           []JournalEntryType         `json:"journal_entries"`
	Custom_fields             JSON                       `json:"custom_fields"`
	Console_port_count        Union                      `json:"console_port_count"`
	Console_server_port_count Union                      `json:"console_server_port_count"`
	Power_port_count          Union                      `json:"power_port_count"`
	Power_outlet_count        Union                      `json:"power_outlet_count"`
	Interface_count           Union                      `json:"interface_count"`
	Front_port_count          Union                      `json:"front_port_count"`
	Rear_port_count           Union                      `json:"rear_port_count"`
	Device_bay_count          Union                      `json:"device_bay_count"`
	Module_bay_count          Union                      `json:"module_bay_count"`
	Inventory_item_count      Union                      `json:"inventory_item_count"`
	Config_template           *ConfigTemplateType        `json:"config_template,omitempty"`
	Device_type               *DeviceTypeType            `json:"device_type"`
	Role                      *DeviceRoleType            `json:"role"`
	Tenant                    *TenantType                `json:"tenant,omitempty"`
	Platform                  *PlatformType              `json:"platform,omitempty"`
	Site                      *SiteType                  `json:"site"`
	Location                  *LocationType              `json:"location,omitempty"`
	Rack                      *RackType                  `json:"rack,omitempty"`
	Primary_ip4               *IPAddressType             `json:"primary_ip4,omitempty"`
	Primary_ip6               *IPAddressType             `json:"primary_ip6,omitempty"`
	Oob_ip                    *IPAddressType             `json:"oob_ip,omitempty"`
	Cluster                   *ClusterType               `json:"cluster,omitempty"`
	Virtual_chassis           *VirtualChassisType        `json:"virtual_chassis,omitempty"`
	Virtual_machines          []VirtualMachineType       `json:"virtual_machines"`
	Modules                   []ModuleType               `json:"modules"`
	Interfaces                []InterfaceType            `json:"interfaces"`
	Rearports                 []RearPortType             `json:"rearports"`
	Consoleports              []ConsolePortType          `json:"consoleports"`
	Powerports                []PowerPortType            `json:"powerports"`
	Cabletermination_set      []CableTerminationType     `json:"cabletermination_set"`
	Consoleserverports        []ConsoleServerPortType    `json:"consoleserverports"`
	Poweroutlets              []PowerOutletType          `json:"poweroutlets"`
	Frontports                []FrontPortType            `json:"frontports"`
	Devicebays                []DeviceBayType            `json:"devicebays"`
	Modulebays                []ModuleBayType            `json:"modulebays"`
	Services                  []ServiceType              `json:"services"`
	Inventoryitems            []InventoryItemType        `json:"inventoryitems"`
	Vdcs                      []VirtualDeviceContextType `json:"vdcs"`
	Id                        string                     `json:"id"`
	Created                   *DateTime                  `json:"created,omitempty"`
	Last_updated              *DateTime                  `json:"last_updated,omitempty"`
	Custom_field_data         JSON                       `json:"custom_field_data"`
	Description               string                     `json:"description"`
	Comments                  string                     `json:"comments"`
	Local_context_data        *JSON                      `json:"local_context_data,omitempty"`
	Name                      *string                    `json:"name,omitempty"`
	Serial                    string                     `json:"serial"`
	Asset_tag                 *string                    `json:"asset_tag,omitempty"`
	Position                  *Decimal                   `json:"position,omitempty"`
	Face                      *string                    `json:"face,omitempty"`
	Status                    string                     `json:"status"`
	Airflow                   *string                    `json:"airflow,omitempty"`
	Vc_position               *int32                     `json:"vc_position,omitempty"`
	Vc_priority               *int32                     `json:"vc_priority,omitempty"`
	Latitude                  *Decimal                   `json:"latitude,omitempty"`
	Longitude                 *Decimal                   `json:"longitude,omitempty"`
	Vc_master_for             *VirtualChassisType        `json:"vc_master_for,omitempty"`
	Parent_bay                *DeviceBayType             `json:"parent_bay,omitempty"`
}

// A DeviceType represents a particular make (Manufacturer) and model of device. It specifies rack height and depth, as
// well as high-level functional role(s).
//
// Each DeviceType can have an arbitrary number of component templates assigned to it, which define console, power, and
// interface objects. For example, a Juniper EX4300-48T DeviceType would have:
//
//   - 1 ConsolePortTemplate
//   - 2 PowerPortTemplates
//   - 48 InterfaceTemplates
//
// When a new Device of this type is created, the appropriate console, power, and interface objects (as defined by the
// DeviceType) are automatically created as well.
type DeviceTypeFilter struct {
	Id                                 *IDFilterLookup       `json:"id,omitempty"`
	Model                              *StrFilterLookup      `json:"model,omitempty"`
	Slug                               *StrFilterLookup      `json:"slug,omitempty"`
	Part_number                        *StrFilterLookup      `json:"part_number,omitempty"`
	U_height                           *DecimalFilterLookup  `json:"u_height,omitempty"`
	Exclude_from_utilization           *bool                 `json:"exclude_from_utilization,omitempty"`
	Is_full_depth                      *bool                 `json:"is_full_depth,omitempty"`
	Subdevice_role                     *StrFilterLookup      `json:"subdevice_role,omitempty"`
	Airflow                            *StrFilterLookup      `json:"airflow,omitempty"`
	Weight                             *DecimalFilterLookup  `json:"weight,omitempty"`
	Weight_unit                        *StrFilterLookup      `json:"weight_unit,omitempty"`
	Description                        *StrFilterLookup      `json:"description,omitempty"`
	Console_port_template_count        *Union                `json:"console_port_template_count,omitempty"`
	Console_server_port_template_count *Union                `json:"console_server_port_template_count,omitempty"`
	Power_port_template_count          *Union                `json:"power_port_template_count,omitempty"`
	Power_outlet_template_count        *Union                `json:"power_outlet_template_count,omitempty"`
	Interface_template_count           *Union                `json:"interface_template_count,omitempty"`
	Front_port_template_count          *Union                `json:"front_port_template_count,omitempty"`
	Rear_port_template_count           *Union                `json:"rear_port_template_count,omitempty"`
	Device_bay_template_count          *Union                `json:"device_bay_template_count,omitempty"`
	Module_bay_template_count          *Union                `json:"module_bay_template_count,omitempty"`
	Inventory_item_template_count      *Union                `json:"inventory_item_template_count,omitempty"`
	Created                            *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated                       *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request                 *string               `json:"created_by_request,omitempty"`
	Updated_by_request                 *string               `json:"updated_by_request,omitempty"`
	Modified_by_request                *string               `json:"modified_by_request,omitempty"`
	Q                                  *string               `json:"q,omitempty"`
	Tag                                []string              `json:"tag,omitempty"`
	Manufacturer_id                    []string              `json:"manufacturer_id,omitempty"`
	Manufacturer                       []string              `json:"manufacturer,omitempty"`
	Default_platform_id                []string              `json:"default_platform_id,omitempty"`
	Default_platform                   []string              `json:"default_platform,omitempty"`
	Has_front_image                    *bool                 `json:"has_front_image,omitempty"`
	Has_rear_image                     *bool                 `json:"has_rear_image,omitempty"`
	Console_ports                      *bool                 `json:"console_ports,omitempty"`
	Console_server_ports               *bool                 `json:"console_server_ports,omitempty"`
	Power_ports                        *bool                 `json:"power_ports,omitempty"`
	Power_outlets                      *bool                 `json:"power_outlets,omitempty"`
	Interfaces                         *bool                 `json:"interfaces,omitempty"`
	Pass_through_ports                 *bool                 `json:"pass_through_ports,omitempty"`
	Module_bays                        *bool                 `json:"module_bays,omitempty"`
	Device_bays                        *bool                 `json:"device_bays,omitempty"`
	Inventory_items                    *bool                 `json:"inventory_items,omitempty"`
	AND                                *DeviceTypeFilter     `json:"AND,omitempty"`
	OR                                 *DeviceTypeFilter     `json:"OR,omitempty"`
	NOT                                *DeviceTypeFilter     `json:"NOT,omitempty"`
	DISTINCT                           *bool                 `json:"DISTINCT,omitempty"`
}

// A DeviceType represents a particular make (Manufacturer) and model of device. It specifies rack height and depth, as
// well as high-level functional role(s).
//
// Each DeviceType can have an arbitrary number of component templates assigned to it, which define console, power, and
// interface objects. For example, a Juniper EX4300-48T DeviceType would have:
//
//   - 1 ConsolePortTemplate
//   - 2 PowerPortTemplates
//   - 48 InterfaceTemplates
//
// When a new Device of this type is created, the appropriate console, power, and interface objects (as defined by the
// DeviceType) are automatically created as well.
type DeviceTypeType struct {
	Changelog                          []ObjectChangeType              `json:"changelog"`
	Display                            string                          `json:"display"`
	Class_type                         string                          `json:"class_type"`
	Tags                               []TagType                       `json:"tags"`
	Journal_entries                    []JournalEntryType              `json:"journal_entries"`
	Custom_fields                      JSON                            `json:"custom_fields"`
	Console_port_template_count        Union                           `json:"console_port_template_count"`
	Console_server_port_template_count Union                           `json:"console_server_port_template_count"`
	Power_port_template_count          Union                           `json:"power_port_template_count"`
	Power_outlet_template_count        Union                           `json:"power_outlet_template_count"`
	Interface_template_count           Union                           `json:"interface_template_count"`
	Front_port_template_count          Union                           `json:"front_port_template_count"`
	Rear_port_template_count           Union                           `json:"rear_port_template_count"`
	Device_bay_template_count          Union                           `json:"device_bay_template_count"`
	Module_bay_template_count          Union                           `json:"module_bay_template_count"`
	Inventory_item_template_count      Union                           `json:"inventory_item_template_count"`
	Front_image                        *DjangoImageType                `json:"front_image,omitempty"`
	Rear_image                         *DjangoImageType                `json:"rear_image,omitempty"`
	Manufacturer                       *ManufacturerType               `json:"manufacturer"`
	Default_platform                   *PlatformType                   `json:"default_platform,omitempty"`
	Frontporttemplates                 []FrontPortTemplateType         `json:"frontporttemplates"`
	Modulebaytemplates                 []ModuleBayTemplateType         `json:"modulebaytemplates"`
	Instances                          []DeviceType                    `json:"instances"`
	Poweroutlettemplates               []PowerOutletTemplateType       `json:"poweroutlettemplates"`
	Powerporttemplates                 []PowerPortTemplateType         `json:"powerporttemplates"`
	Inventoryitemtemplates             []InventoryItemTemplateType     `json:"inventoryitemtemplates"`
	Rearporttemplates                  []RearPortTemplateType          `json:"rearporttemplates"`
	Consoleserverporttemplates         []ConsoleServerPortTemplateType `json:"consoleserverporttemplates"`
	Interfacetemplates                 []InterfaceTemplateType         `json:"interfacetemplates"`
	Devicebaytemplates                 []DeviceBayTemplateType         `json:"devicebaytemplates"`
	Consoleporttemplates               []ConsolePortTemplateType       `json:"consoleporttemplates"`
	Id                                 string                          `json:"id"`
	Created                            *DateTime                       `json:"created,omitempty"`
	Last_updated                       *DateTime                       `json:"last_updated,omitempty"`
	Custom_field_data                  JSON                            `json:"custom_field_data"`
	Description                        string                          `json:"description"`
	Comments                           string                          `json:"comments"`
	Weight                             *Decimal                        `json:"weight,omitempty"`
	Weight_unit                        *string                         `json:"weight_unit,omitempty"`
	_abs_weight                        *int32                          `json:"_abs_weight,omitempty"`
	Model                              string                          `json:"model"`
	Slug                               string                          `json:"slug"`
	Part_number                        string                          `json:"part_number"`
	U_height                           Decimal                         `json:"u_height"`
	Exclude_from_utilization           bool                            `json:"exclude_from_utilization"`
	Is_full_depth                      bool                            `json:"is_full_depth"`
	Subdevice_role                     *string                         `json:"subdevice_role,omitempty"`
	Airflow                            *string                         `json:"airflow,omitempty"`
}

type DjangoImageType struct {
	Name   string `json:"name"`
	Path   string `json:"path"`
	Size   int32  `json:"size"`
	Url    string `json:"url"`
	Width  int32  `json:"width"`
	Height int32  `json:"height"`
}

type DjangoModelFilterInput struct {
	Id string `json:"id"`
}

type DjangoModelType struct {
	Pk string `json:"pk"`
}

// An EventRule defines an action to be taken automatically in response to a specific set of events, such as when a
// specific type of object is created, modified, or deleted. The action to be taken might entail transmitting a
// webhook or executing a custom script.
type EventRuleFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Enabled             *bool                 `json:"enabled,omitempty"`
	Action_type         *StrFilterLookup      `json:"action_type,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Object_type_id      []string              `json:"object_type_id,omitempty"`
	Object_type         *string               `json:"object_type,omitempty"`
	Event_type          *StrFilterLookup      `json:"event_type,omitempty"`
	Action_object_type  *string               `json:"action_object_type,omitempty"`
	Action_object_id    []string              `json:"action_object_id,omitempty"`
	AND                 *EventRuleFilter      `json:"AND,omitempty"`
	OR                  *EventRuleFilter      `json:"OR,omitempty"`
	NOT                 *EventRuleFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An EventRule defines an action to be taken automatically in response to a specific set of events, such as when a
// specific type of object is created, modified, or deleted. The action to be taken might entail transmitting a
// webhook or executing a custom script.
type EventRuleType struct {
	Changelog          []ObjectChangeType `json:"changelog"`
	Display            string             `json:"display"`
	Class_type         string             `json:"class_type"`
	Tags               []TagType          `json:"tags"`
	Custom_fields      JSON               `json:"custom_fields"`
	Action_object_type *ContentTypeType   `json:"action_object_type,omitempty"`
	Id                 string             `json:"id"`
	Created            *DateTime          `json:"created,omitempty"`
	Last_updated       *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data  JSON               `json:"custom_field_data"`
	Name               string             `json:"name"`
	Description        string             `json:"description"`
	Event_types        []string           `json:"event_types"`
	Enabled            bool               `json:"enabled"`
	Conditions         *JSON              `json:"conditions,omitempty"`
	Action_type        string             `json:"action_type"`
	Action_object_id   *int32             `json:"action_object_id,omitempty"`
	Action_data        *JSON              `json:"action_data,omitempty"`
	Comments           string             `json:"comments"`
}

// ExportTemplate(id, created, last_updated, data_source, data_file, data_path, auto_sync_enabled, data_synced, name, description, template_code, mime_type, file_extension, as_attachment)
type ExportTemplateFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Mime_type           *StrFilterLookup      `json:"mime_type,omitempty"`
	File_extension      *StrFilterLookup      `json:"file_extension,omitempty"`
	As_attachment       *bool                 `json:"as_attachment,omitempty"`
	Auto_sync_enabled   *bool                 `json:"auto_sync_enabled,omitempty"`
	Data_synced         *DatetimeFilterLookup `json:"data_synced,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Object_type_id      []string              `json:"object_type_id,omitempty"`
	Object_type         *string               `json:"object_type,omitempty"`
	Data_source_id      []string              `json:"data_source_id,omitempty"`
	Data_file_id        []string              `json:"data_file_id,omitempty"`
	AND                 *ExportTemplateFilter `json:"AND,omitempty"`
	OR                  *ExportTemplateFilter `json:"OR,omitempty"`
	NOT                 *ExportTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// ExportTemplate(id, created, last_updated, data_source, data_file, data_path, auto_sync_enabled, data_synced, name, description, template_code, mime_type, file_extension, as_attachment)
type ExportTemplateType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Data_source       *DataSourceType    `json:"data_source,omitempty"`
	Data_file         *DataFileType      `json:"data_file,omitempty"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Data_path         string             `json:"data_path"`
	Auto_sync_enabled bool               `json:"auto_sync_enabled"`
	Data_synced       *DateTime          `json:"data_synced,omitempty"`
	Name              string             `json:"name"`
	Description       string             `json:"description"`
	Template_code     string             `json:"template_code"`
	Mime_type         string             `json:"mime_type"`
	File_extension    string             `json:"file_extension"`
	As_attachment     bool               `json:"as_attachment"`
}

// FHRPGroupAssignment(id, created, last_updated, interface_type, interface_id, group, priority)
type FHRPGroupAssignmentFilter struct {
	Id                  *IDFilterLookup            `json:"id,omitempty"`
	Group_id            *IDFilterLookup            `json:"group_id,omitempty"`
	Interface_type      *DjangoModelFilterInput    `json:"interface_type,omitempty"`
	Interface_id        *IntFilterLookup           `json:"interface_id,omitempty"`
	Priority            *IntFilterLookup           `json:"priority,omitempty"`
	Created             *DatetimeFilterLookup      `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup      `json:"last_updated,omitempty"`
	Created_by_request  *string                    `json:"created_by_request,omitempty"`
	Updated_by_request  *string                    `json:"updated_by_request,omitempty"`
	Modified_by_request *string                    `json:"modified_by_request,omitempty"`
	Device              *StrFilterLookup           `json:"device,omitempty"`
	Device_id           []string                   `json:"device_id,omitempty"`
	Virtual_machine     *StrFilterLookup           `json:"virtual_machine,omitempty"`
	Virtual_machine_id  []string                   `json:"virtual_machine_id,omitempty"`
	AND                 *FHRPGroupAssignmentFilter `json:"AND,omitempty"`
	OR                  *FHRPGroupAssignmentFilter `json:"OR,omitempty"`
	NOT                 *FHRPGroupAssignmentFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                      `json:"DISTINCT,omitempty"`
}

// FHRPGroupAssignment(id, created, last_updated, interface_type, interface_id, group, priority)
type FHRPGroupAssignmentType struct {
	Display      string                 `json:"display"`
	Class_type   string                 `json:"class_type"`
	Group        *FHRPGroupType         `json:"group"`
	Id           string                 `json:"id"`
	Created      *DateTime              `json:"created,omitempty"`
	Last_updated *DateTime              `json:"last_updated,omitempty"`
	Priority     int32                  `json:"priority"`
	Interface    FHRPGroupInterfaceType `json:"interface"`
}

// A grouping of next hope resolution protocol (FHRP) peers. (For instance, VRRP or HSRP.)
type FHRPGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Group_id            *IntFilterLookup      `json:"group_id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Auth_key            *StrFilterLookup      `json:"auth_key,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Protocol            *string               `json:"protocol,omitempty"`
	Auth_type           *string               `json:"auth_type,omitempty"`
	Related_ip          []string              `json:"related_ip,omitempty"`
	AND                 *FHRPGroupFilter      `json:"AND,omitempty"`
	OR                  *FHRPGroupFilter      `json:"OR,omitempty"`
	NOT                 *FHRPGroupFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

type FHRPGroupInterfaceType struct {
	// Underlying value of the GraphQL union
	Value FHRPGroupInterfaceTypeValue `json:"-"`
}

func (base *FHRPGroupInterfaceType) UnmarshalJSON(b []byte) error {
	type Raw FHRPGroupInterfaceType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "VMInterfaceType":
		base.Value = new(VMInterfaceType)
	case "":
		return fmt.Errorf("gqlclient: union FHRPGroupInterfaceType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union FHRPGroupInterfaceType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// FHRPGroupInterfaceTypeValue is one of: InterfaceType | VMInterfaceType
type FHRPGroupInterfaceTypeValue interface {
	isFHRPGroupInterfaceType()
}

// A grouping of next hope resolution protocol (FHRP) peers. (For instance, VRRP or HSRP.)
type FHRPGroupType struct {
	Changelog               []ObjectChangeType        `json:"changelog"`
	Ip_addresses            []IPAddressType           `json:"ip_addresses"`
	Display                 string                    `json:"display"`
	Class_type              string                    `json:"class_type"`
	Tags                    []TagType                 `json:"tags"`
	Journal_entries         []JournalEntryType        `json:"journal_entries"`
	Custom_fields           JSON                      `json:"custom_fields"`
	Fhrpgroupassignment_set []FHRPGroupAssignmentType `json:"fhrpgroupassignment_set"`
	Id                      string                    `json:"id"`
	Created                 *DateTime                 `json:"created,omitempty"`
	Last_updated            *DateTime                 `json:"last_updated,omitempty"`
	Custom_field_data       JSON                      `json:"custom_field_data"`
	Description             string                    `json:"description"`
	Comments                string                    `json:"comments"`
	Group_id                int32                     `json:"group_id"`
	Name                    string                    `json:"name"`
	Protocol                string                    `json:"protocol"`
	Auth_type               *string                   `json:"auth_type,omitempty"`
	Auth_key                string                    `json:"auth_key"`
}

func (*FHRPGroupType) isIPAddressAssignmentType() {}

// A pass-through port on the front of a Device.
type FrontPortFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Type                *StrFilterLookup      `json:"type,omitempty"`
	Color               []string              `json:"color,omitempty"`
	Rear_port_position  *IntFilterLookup      `json:"rear_port_position,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Mark_connected      *bool                 `json:"mark_connected,omitempty"`
	Cable_end           *StrFilterLookup      `json:"cable_end,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Module_id           []string              `json:"module_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Cable_id            []string              `json:"cable_id,omitempty"`
	Cabled              *bool                 `json:"cabled,omitempty"`
	Occupied            *bool                 `json:"occupied,omitempty"`
	Rear_port_id        []string              `json:"rear_port_id,omitempty"`
	AND                 *FrontPortFilter      `json:"AND,omitempty"`
	OR                  *FrontPortFilter      `json:"OR,omitempty"`
	NOT                 *FrontPortFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Template for a pass-through port on the front of a new Device.
type FrontPortTemplateFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Label               *StrFilterLookup         `json:"label,omitempty"`
	Type                *StrFilterLookup         `json:"type,omitempty"`
	Color               []string                 `json:"color,omitempty"`
	Rear_port_position  *IntFilterLookup         `json:"rear_port_position,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Device_type_id      []string                 `json:"device_type_id,omitempty"`
	Module_type_id      []string                 `json:"module_type_id,omitempty"`
	Rear_port_id        []string                 `json:"rear_port_id,omitempty"`
	AND                 *FrontPortTemplateFilter `json:"AND,omitempty"`
	OR                  *FrontPortTemplateFilter `json:"OR,omitempty"`
	NOT                 *FrontPortTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// Template for a pass-through port on the front of a new Device.
type FrontPortTemplateType struct {
	Changelog          []ObjectChangeType    `json:"changelog"`
	Display            string                `json:"display"`
	Class_type         string                `json:"class_type"`
	Device_type        *DeviceTypeType       `json:"device_type,omitempty"`
	Module_type        *ModuleTypeType       `json:"module_type,omitempty"`
	Color              string                `json:"color"`
	Rear_port          *RearPortTemplateType `json:"rear_port"`
	Id                 string                `json:"id"`
	Created            *DateTime             `json:"created,omitempty"`
	Last_updated       *DateTime             `json:"last_updated,omitempty"`
	Name               string                `json:"name"`
	Label              string                `json:"label"`
	Description        string                `json:"description"`
	Type               string                `json:"type"`
	Rear_port_position int32                 `json:"rear_port_position"`
}

// A pass-through port on the front of a Device.
type FrontPortType struct {
	Changelog          []ObjectChangeType `json:"changelog"`
	Custom_fields      JSON               `json:"custom_fields"`
	Tags               []TagType          `json:"tags"`
	Display            string             `json:"display"`
	Class_type         string             `json:"class_type"`
	Device             *DeviceType        `json:"device"`
	Module             *ModuleType        `json:"module,omitempty"`
	Cable              *CableType         `json:"cable,omitempty"`
	Link_peers         []LinkPeerType     `json:"link_peers"`
	Color              string             `json:"color"`
	Rear_port          *RearPortType      `json:"rear_port"`
	Id                 string             `json:"id"`
	Created            *DateTime          `json:"created,omitempty"`
	Last_updated       *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data  JSON               `json:"custom_field_data"`
	Name               string             `json:"name"`
	Label              string             `json:"label"`
	Description        string             `json:"description"`
	Cable_end          *string            `json:"cable_end,omitempty"`
	Mark_connected     bool               `json:"mark_connected"`
	Type               string             `json:"type"`
	Rear_port_position int32              `json:"rear_port_position"`
}

func (*FrontPortType) isLinkPeerType() {}

func (*FrontPortType) isInventoryItemComponentType() {}

func (*FrontPortType) isConnectedEndpointType() {}

func (*FrontPortType) isInventoryItemTemplateComponentType() {}

func (*FrontPortType) isCableTerminationTerminationType() {}

// Group(id, name, description)
type GroupFilter struct {
	Id                    *IDFilterLookup  `json:"id,omitempty"`
	Name                  *StrFilterLookup `json:"name,omitempty"`
	Description           *StrFilterLookup `json:"description,omitempty"`
	Q                     *string          `json:"q,omitempty"`
	User_id               []string         `json:"user_id,omitempty"`
	Permission_id         []string         `json:"permission_id,omitempty"`
	Notification_group_id []string         `json:"notification_group_id,omitempty"`
	AND                   *GroupFilter     `json:"AND,omitempty"`
	OR                    *GroupFilter     `json:"OR,omitempty"`
	NOT                   *GroupFilter     `json:"NOT,omitempty"`
	DISTINCT              *bool            `json:"DISTINCT,omitempty"`
}

// Group(id, name, description)
type GroupType struct {
	Display    string `json:"display"`
	Class_type string `json:"class_type"`
	Id         string `json:"id"`
	Name       string `json:"name"`
}

type IDFilterLookup struct {
	Exact         string   `json:"exact,omitempty"`
	I_exact       string   `json:"i_exact,omitempty"`
	Contains      string   `json:"contains,omitempty"`
	I_contains    string   `json:"i_contains,omitempty"`
	In_list       []string `json:"in_list,omitempty"`
	Gt            string   `json:"gt,omitempty"`
	Gte           string   `json:"gte,omitempty"`
	Lt            string   `json:"lt,omitempty"`
	Lte           string   `json:"lte,omitempty"`
	Starts_with   string   `json:"starts_with,omitempty"`
	I_starts_with string   `json:"i_starts_with,omitempty"`
	Ends_with     string   `json:"ends_with,omitempty"`
	I_ends_with   string   `json:"i_ends_with,omitempty"`
	Range         []string `json:"range,omitempty"`
	Is_null       *bool    `json:"is_null,omitempty"`
	Regex         *string  `json:"regex,omitempty"`
	I_regex       *string  `json:"i_regex,omitempty"`
}

// IKEPolicy(id, created, last_updated, custom_field_data, description, comments, name, version, mode, preshared_key)
type IKEPolicyFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Preshared_key       *StrFilterLookup      `json:"preshared_key,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Version             *string               `json:"version,omitempty"`
	Mode                *string               `json:"mode,omitempty"`
	Ike_proposal_id     []string              `json:"ike_proposal_id,omitempty"`
	Ike_proposal        []string              `json:"ike_proposal,omitempty"`
	AND                 *IKEPolicyFilter      `json:"AND,omitempty"`
	OR                  *IKEPolicyFilter      `json:"OR,omitempty"`
	NOT                 *IKEPolicyFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// IKEPolicy(id, created, last_updated, custom_field_data, description, comments, name, version, mode, preshared_key)
type IKEPolicyType struct {
	Changelog         []ObjectChangeType  `json:"changelog"`
	Display           string              `json:"display"`
	Class_type        string              `json:"class_type"`
	Tags              []TagType           `json:"tags"`
	Custom_fields     JSON                `json:"custom_fields"`
	Proposals         []IKEProposalType   `json:"proposals"`
	Ipsec_profiles    []IPSecProposalType `json:"ipsec_profiles"`
	Id                string              `json:"id"`
	Created           *DateTime           `json:"created,omitempty"`
	Last_updated      *DateTime           `json:"last_updated,omitempty"`
	Custom_field_data JSON                `json:"custom_field_data"`
	Description       string              `json:"description"`
	Comments          string              `json:"comments"`
	Name              string              `json:"name"`
	Version           int32               `json:"version"`
	Mode              *string             `json:"mode,omitempty"`
	Preshared_key     string              `json:"preshared_key"`
}

// IKEProposal(id, created, last_updated, custom_field_data, description, comments, name, authentication_method, encryption_algorithm, authentication_algorithm, group, sa_lifetime)
type IKEProposalFilter struct {
	Id                       *IDFilterLookup       `json:"id,omitempty"`
	Name                     *StrFilterLookup      `json:"name,omitempty"`
	Sa_lifetime              *IntFilterLookup      `json:"sa_lifetime,omitempty"`
	Description              *StrFilterLookup      `json:"description,omitempty"`
	Created                  *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated             *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request       *string               `json:"created_by_request,omitempty"`
	Updated_by_request       *string               `json:"updated_by_request,omitempty"`
	Modified_by_request      *string               `json:"modified_by_request,omitempty"`
	Q                        *string               `json:"q,omitempty"`
	Tag                      []string              `json:"tag,omitempty"`
	Ike_policy_id            []string              `json:"ike_policy_id,omitempty"`
	Ike_policy               []string              `json:"ike_policy,omitempty"`
	Authentication_method    *string               `json:"authentication_method,omitempty"`
	Encryption_algorithm     *string               `json:"encryption_algorithm,omitempty"`
	Authentication_algorithm *string               `json:"authentication_algorithm,omitempty"`
	Group                    *string               `json:"group,omitempty"`
	AND                      *IKEProposalFilter    `json:"AND,omitempty"`
	OR                       *IKEProposalFilter    `json:"OR,omitempty"`
	NOT                      *IKEProposalFilter    `json:"NOT,omitempty"`
	DISTINCT                 *bool                 `json:"DISTINCT,omitempty"`
}

// IKEProposal(id, created, last_updated, custom_field_data, description, comments, name, authentication_method, encryption_algorithm, authentication_algorithm, group, sa_lifetime)
type IKEProposalType struct {
	Changelog                []ObjectChangeType `json:"changelog"`
	Display                  string             `json:"display"`
	Class_type               string             `json:"class_type"`
	Tags                     []TagType          `json:"tags"`
	Custom_fields            JSON               `json:"custom_fields"`
	Ike_policies             []IKEPolicyType    `json:"ike_policies"`
	Id                       string             `json:"id"`
	Created                  *DateTime          `json:"created,omitempty"`
	Last_updated             *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data        JSON               `json:"custom_field_data"`
	Description              string             `json:"description"`
	Comments                 string             `json:"comments"`
	Name                     string             `json:"name"`
	Authentication_method    string             `json:"authentication_method"`
	Encryption_algorithm     string             `json:"encryption_algorithm"`
	Authentication_algorithm *string            `json:"authentication_algorithm,omitempty"`
	Group                    int32              `json:"group"`
	Sa_lifetime              *int32             `json:"sa_lifetime,omitempty"`
}

type IPAddressAssignmentType struct {
	// Underlying value of the GraphQL union
	Value IPAddressAssignmentTypeValue `json:"-"`
}

func (base *IPAddressAssignmentType) UnmarshalJSON(b []byte) error {
	type Raw IPAddressAssignmentType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "FHRPGroupType":
		base.Value = new(FHRPGroupType)
	case "VMInterfaceType":
		base.Value = new(VMInterfaceType)
	case "":
		return fmt.Errorf("gqlclient: union IPAddressAssignmentType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union IPAddressAssignmentType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// IPAddressAssignmentTypeValue is one of: InterfaceType | FHRPGroupType | VMInterfaceType
type IPAddressAssignmentTypeValue interface {
	isIPAddressAssignmentType()
}

type IPAddressFamilyType struct {
	Value int32  `json:"value"`
	Label string `json:"label"`
}

// An IPAddress represents an individual IPv4 or IPv6 address and its mask. The mask length should match what is
// configured in the real world. (Typically, only loopback interfaces are configured with /32 or /128 masks.) Like
// Prefixes, IPAddresses can optionally be assigned to a VRF. An IPAddress can optionally be assigned to an Interface.
// Interfaces can have zero or more IPAddresses assigned to them.
//
// An IPAddress can also optionally point to a NAT inside IP, designating itself as a NAT outside IP. This is useful,
// for example, when mapping public addresses to private addresses. When an Interface has been assigned an IPAddress
// which has a NAT outside IP, that Interface's Device can use either the inside or outside IP as its primary IP.
type IPAddressFilter struct {
	Id                    *IDFilterLookup         `json:"id,omitempty"`
	Dns_name              *StrFilterLookup        `json:"dns_name,omitempty"`
	Description           *StrFilterLookup        `json:"description,omitempty"`
	Assigned_object_type  *DjangoModelFilterInput `json:"assigned_object_type,omitempty"`
	Assigned_object_id    *IntFilterLookup        `json:"assigned_object_id,omitempty"`
	Created               *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated          *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request    *string                 `json:"created_by_request,omitempty"`
	Updated_by_request    *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request   *string                 `json:"modified_by_request,omitempty"`
	Q                     *string                 `json:"q,omitempty"`
	Tag                   []string                `json:"tag,omitempty"`
	Tenant_group_id       []string                `json:"tenant_group_id,omitempty"`
	Tenant_group          []string                `json:"tenant_group,omitempty"`
	Tenant_id             []string                `json:"tenant_id,omitempty"`
	Tenant                []string                `json:"tenant,omitempty"`
	Family                *int32                  `json:"family,omitempty"`
	Parent                *StrFilterLookup        `json:"parent,omitempty"`
	Address               *StrFilterLookup        `json:"address,omitempty"`
	Mask_length           []string                `json:"mask_length,omitempty"`
	Mask_length__gte      *int32                  `json:"mask_length__gte,omitempty"`
	Mask_length__lte      *int32                  `json:"mask_length__lte,omitempty"`
	Vrf_id                []string                `json:"vrf_id,omitempty"`
	Vrf                   []string                `json:"vrf,omitempty"`
	Present_in_vrf_id     *string                 `json:"present_in_vrf_id,omitempty"`
	Present_in_vrf        *string                 `json:"present_in_vrf,omitempty"`
	Device                *StrFilterLookup        `json:"device,omitempty"`
	Device_id             []string                `json:"device_id,omitempty"`
	Virtual_machine       *StrFilterLookup        `json:"virtual_machine,omitempty"`
	Virtual_machine_id    []string                `json:"virtual_machine_id,omitempty"`
	Interface             []string                `json:"interface,omitempty"`
	Interface_id          []string                `json:"interface_id,omitempty"`
	Vminterface           []string                `json:"vminterface,omitempty"`
	Vminterface_id        []string                `json:"vminterface_id,omitempty"`
	Fhrpgroup_id          []string                `json:"fhrpgroup_id,omitempty"`
	Assigned_to_interface *bool                   `json:"assigned_to_interface,omitempty"`
	Assigned              *bool                   `json:"assigned,omitempty"`
	Status                *string                 `json:"status,omitempty"`
	Role                  *string                 `json:"role,omitempty"`
	Service_id            []string                `json:"service_id,omitempty"`
	Nat_inside_id         []string                `json:"nat_inside_id,omitempty"`
	AND                   *IPAddressFilter        `json:"AND,omitempty"`
	OR                    *IPAddressFilter        `json:"OR,omitempty"`
	NOT                   *IPAddressFilter        `json:"NOT,omitempty"`
	DISTINCT              *bool                   `json:"DISTINCT,omitempty"`
}

// An IPAddress represents an individual IPv4 or IPv6 address and its mask. The mask length should match what is
// configured in the real world. (Typically, only loopback interfaces are configured with /32 or /128 masks.) Like
// Prefixes, IPAddresses can optionally be assigned to a VRF. An IPAddress can optionally be assigned to an Interface.
// Interfaces can have zero or more IPAddresses assigned to them.
//
// An IPAddress can also optionally point to a NAT inside IP, designating itself as a NAT outside IP. This is useful,
// for example, when mapping public addresses to private addresses. When an Interface has been assigned an IPAddress
// which has a NAT outside IP, that Interface's Device can use either the inside or outside IP as its primary IP.
type IPAddressType struct {
	Changelog           []ObjectChangeType       `json:"changelog"`
	Family              *IPAddressFamilyType     `json:"family"`
	Display             string                   `json:"display"`
	Class_type          string                   `json:"class_type"`
	Tags                []TagType                `json:"tags"`
	Journal_entries     []JournalEntryType       `json:"journal_entries"`
	Custom_fields       JSON                     `json:"custom_fields"`
	Address             string                   `json:"address"`
	Vrf                 *VRFType                 `json:"vrf,omitempty"`
	Tenant              *TenantType              `json:"tenant,omitempty"`
	Nat_inside          *IPAddressType           `json:"nat_inside,omitempty"`
	Nat_outside         []IPAddressType          `json:"nat_outside"`
	Tunnel_terminations []TunnelTerminationType  `json:"tunnel_terminations"`
	Services            []ServiceType            `json:"services"`
	Id                  string                   `json:"id"`
	Created             *DateTime                `json:"created,omitempty"`
	Last_updated        *DateTime                `json:"last_updated,omitempty"`
	Custom_field_data   JSON                     `json:"custom_field_data"`
	Description         string                   `json:"description"`
	Comments            string                   `json:"comments"`
	Status              string                   `json:"status"`
	Role                *string                  `json:"role,omitempty"`
	Dns_name            string                   `json:"dns_name"`
	Assigned_object     *IPAddressAssignmentType `json:"assigned_object,omitempty"`
}

// A range of IP addresses, defined by start and end addresses.
type IPRangeFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Mark_utilized       *bool                 `json:"mark_utilized,omitempty"`
	Size                *IntFilterLookup      `json:"size,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Family              *int32                `json:"family,omitempty"`
	Start_address       *StrFilterLookup      `json:"start_address,omitempty"`
	End_address         *StrFilterLookup      `json:"end_address,omitempty"`
	Contains            *string               `json:"contains,omitempty"`
	Vrf_id              []string              `json:"vrf_id,omitempty"`
	Vrf                 []string              `json:"vrf,omitempty"`
	Role_id             []string              `json:"role_id,omitempty"`
	Role                []string              `json:"role,omitempty"`
	Status              *string               `json:"status,omitempty"`
	Parent              *StrFilterLookup      `json:"parent,omitempty"`
	AND                 *IPRangeFilter        `json:"AND,omitempty"`
	OR                  *IPRangeFilter        `json:"OR,omitempty"`
	NOT                 *IPRangeFilter        `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A range of IP addresses, defined by start and end addresses.
type IPRangeType struct {
	Changelog         []ObjectChangeType     `json:"changelog"`
	Display           string                 `json:"display"`
	Class_type        string                 `json:"class_type"`
	Tags              []TagType              `json:"tags"`
	Journal_entries   []JournalEntryType     `json:"journal_entries"`
	Custom_fields     map[string]interface{} `json:"custom_fields"`
	Start_address     string                 `json:"start_address"`
	End_address       string                 `json:"end_address"`
	Vrf               *VRFType               `json:"vrf,omitempty"`
	Tenant            *TenantType            `json:"tenant,omitempty"`
	Role              *RoleType              `json:"role,omitempty"`
	Id                string                 `json:"id"`
	Created           *DateTime              `json:"created,omitempty"`
	Last_updated      *DateTime              `json:"last_updated,omitempty"`
	Custom_field_data JSON                   `json:"custom_field_data"`
	Description       string                 `json:"description"`
	Comments          string                 `json:"comments"`
	Size              int32                  `json:"size"`
	Status            string                 `json:"status"`
	Mark_utilized     bool                   `json:"mark_utilized"`
}

// IPSecPolicy(id, created, last_updated, custom_field_data, description, comments, name, pfs_group)
type IPSecPolicyFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Pfs_group           *string               `json:"pfs_group,omitempty"`
	Ipsec_proposal_id   []string              `json:"ipsec_proposal_id,omitempty"`
	Ipsec_proposal      []string              `json:"ipsec_proposal,omitempty"`
	AND                 *IPSecPolicyFilter    `json:"AND,omitempty"`
	OR                  *IPSecPolicyFilter    `json:"OR,omitempty"`
	NOT                 *IPSecPolicyFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// IPSecPolicy(id, created, last_updated, custom_field_data, description, comments, name, pfs_group)
type IPSecPolicyType struct {
	Changelog         []ObjectChangeType  `json:"changelog"`
	Display           string              `json:"display"`
	Class_type        string              `json:"class_type"`
	Tags              []TagType           `json:"tags"`
	Custom_fields     JSON                `json:"custom_fields"`
	Proposals         []IPSecProposalType `json:"proposals"`
	Ipsec_profiles    []IPSecProfileType  `json:"ipsec_profiles"`
	Id                string              `json:"id"`
	Created           *DateTime           `json:"created,omitempty"`
	Last_updated      *DateTime           `json:"last_updated,omitempty"`
	Custom_field_data JSON                `json:"custom_field_data"`
	Description       string              `json:"description"`
	Comments          string              `json:"comments"`
	Name              string              `json:"name"`
	Pfs_group         *int32              `json:"pfs_group,omitempty"`
}

// IPSecProfile(id, created, last_updated, custom_field_data, description, comments, name, mode, ike_policy, ipsec_policy)
type IPSecProfileFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Mode                *string               `json:"mode,omitempty"`
	Ike_policy_id       []string              `json:"ike_policy_id,omitempty"`
	Ike_policy          []string              `json:"ike_policy,omitempty"`
	Ipsec_policy_id     []string              `json:"ipsec_policy_id,omitempty"`
	Ipsec_policy        []string              `json:"ipsec_policy,omitempty"`
	AND                 *IPSecProfileFilter   `json:"AND,omitempty"`
	OR                  *IPSecProfileFilter   `json:"OR,omitempty"`
	NOT                 *IPSecProfileFilter   `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// IPSecProfile(id, created, last_updated, custom_field_data, description, comments, name, mode, ike_policy, ipsec_policy)
type IPSecProfileType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Ike_policy        *IKEPolicyType     `json:"ike_policy"`
	Ipsec_policy      *IPSecPolicyType   `json:"ipsec_policy"`
	Tunnels           []TunnelType       `json:"tunnels"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Name              string             `json:"name"`
	Mode              string             `json:"mode"`
}

// IPSecProposal(id, created, last_updated, custom_field_data, description, comments, name, encryption_algorithm, authentication_algorithm, sa_lifetime_seconds, sa_lifetime_data)
type IPSecProposalFilter struct {
	Id                       *IDFilterLookup       `json:"id,omitempty"`
	Name                     *StrFilterLookup      `json:"name,omitempty"`
	Sa_lifetime_seconds      *IntFilterLookup      `json:"sa_lifetime_seconds,omitempty"`
	Sa_lifetime_data         *IntFilterLookup      `json:"sa_lifetime_data,omitempty"`
	Description              *StrFilterLookup      `json:"description,omitempty"`
	Created                  *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated             *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request       *string               `json:"created_by_request,omitempty"`
	Updated_by_request       *string               `json:"updated_by_request,omitempty"`
	Modified_by_request      *string               `json:"modified_by_request,omitempty"`
	Q                        *string               `json:"q,omitempty"`
	Tag                      []string              `json:"tag,omitempty"`
	Ipsec_policy_id          []string              `json:"ipsec_policy_id,omitempty"`
	Ipsec_policy             []string              `json:"ipsec_policy,omitempty"`
	Encryption_algorithm     *string               `json:"encryption_algorithm,omitempty"`
	Authentication_algorithm *string               `json:"authentication_algorithm,omitempty"`
	AND                      *IPSecProposalFilter  `json:"AND,omitempty"`
	OR                       *IPSecProposalFilter  `json:"OR,omitempty"`
	NOT                      *IPSecProposalFilter  `json:"NOT,omitempty"`
	DISTINCT                 *bool                 `json:"DISTINCT,omitempty"`
}

// IPSecProposal(id, created, last_updated, custom_field_data, description, comments, name, encryption_algorithm, authentication_algorithm, sa_lifetime_seconds, sa_lifetime_data)
type IPSecProposalType struct {
	Changelog                []ObjectChangeType `json:"changelog"`
	Display                  string             `json:"display"`
	Class_type               string             `json:"class_type"`
	Tags                     []TagType          `json:"tags"`
	Custom_fields            JSON               `json:"custom_fields"`
	Ipsec_policies           []IPSecPolicyType  `json:"ipsec_policies"`
	Id                       string             `json:"id"`
	Created                  *DateTime          `json:"created,omitempty"`
	Last_updated             *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data        JSON               `json:"custom_field_data"`
	Description              string             `json:"description"`
	Comments                 string             `json:"comments"`
	Name                     string             `json:"name"`
	Encryption_algorithm     *string            `json:"encryption_algorithm,omitempty"`
	Authentication_algorithm *string            `json:"authentication_algorithm,omitempty"`
	Sa_lifetime_seconds      *int32             `json:"sa_lifetime_seconds,omitempty"`
	Sa_lifetime_data         *int32             `json:"sa_lifetime_data,omitempty"`
}

// An uploaded image which is associated with an object.
type ImageAttachmentFilter struct {
	Id                  *IDFilterLookup        `json:"id,omitempty"`
	Object_type_id      *IDFilterLookup        `json:"object_type_id,omitempty"`
	Object_id           *IntFilterLookup       `json:"object_id,omitempty"`
	Name                *StrFilterLookup       `json:"name,omitempty"`
	Image_width         *IntFilterLookup       `json:"image_width,omitempty"`
	Image_height        *IntFilterLookup       `json:"image_height,omitempty"`
	Created             *DatetimeFilterLookup  `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup  `json:"last_updated,omitempty"`
	Created_by_request  *string                `json:"created_by_request,omitempty"`
	Updated_by_request  *string                `json:"updated_by_request,omitempty"`
	Modified_by_request *string                `json:"modified_by_request,omitempty"`
	Q                   *string                `json:"q,omitempty"`
	Object_type         *string                `json:"object_type,omitempty"`
	AND                 *ImageAttachmentFilter `json:"AND,omitempty"`
	OR                  *ImageAttachmentFilter `json:"OR,omitempty"`
	NOT                 *ImageAttachmentFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                  `json:"DISTINCT,omitempty"`
}

// An uploaded image which is associated with an object.
type ImageAttachmentType struct {
	Display      string           `json:"display"`
	Class_type   string           `json:"class_type"`
	Object_type  *ContentTypeType `json:"object_type,omitempty"`
	Id           string           `json:"id"`
	Created      *DateTime        `json:"created,omitempty"`
	Last_updated *DateTime        `json:"last_updated,omitempty"`
	Object_id    int32            `json:"object_id"`
	Image        *DjangoImageType `json:"image"`
	Image_height int32            `json:"image_height"`
	Image_width  int32            `json:"image_width"`
	Name         string           `json:"name"`
}

type IntFilterLookup struct {
	Exact         *int32  `json:"exact,omitempty"`
	I_exact       *int32  `json:"i_exact,omitempty"`
	Contains      *int32  `json:"contains,omitempty"`
	I_contains    *int32  `json:"i_contains,omitempty"`
	In_list       []int32 `json:"in_list,omitempty"`
	Gt            *int32  `json:"gt,omitempty"`
	Gte           *int32  `json:"gte,omitempty"`
	Lt            *int32  `json:"lt,omitempty"`
	Lte           *int32  `json:"lte,omitempty"`
	Starts_with   *int32  `json:"starts_with,omitempty"`
	I_starts_with *int32  `json:"i_starts_with,omitempty"`
	Ends_with     *int32  `json:"ends_with,omitempty"`
	I_ends_with   *int32  `json:"i_ends_with,omitempty"`
	Range         []int32 `json:"range,omitempty"`
	Is_null       *bool   `json:"is_null,omitempty"`
	Regex         *string `json:"regex,omitempty"`
	I_regex       *string `json:"i_regex,omitempty"`
}

// A network interface within a Device. A physical Interface can connect to exactly one other Interface.
type InterfaceFilter struct {
	Id                             *IDFilterLookup       `json:"id,omitempty"`
	Name                           *StrFilterLookup      `json:"name,omitempty"`
	Label                          *StrFilterLookup      `json:"label,omitempty"`
	Type                           *StrFilterLookup      `json:"type,omitempty"`
	Enabled                        *bool                 `json:"enabled,omitempty"`
	Mtu                            *IntFilterLookup      `json:"mtu,omitempty"`
	Mgmt_only                      *bool                 `json:"mgmt_only,omitempty"`
	Poe_mode                       *StrFilterLookup      `json:"poe_mode,omitempty"`
	Poe_type                       *StrFilterLookup      `json:"poe_type,omitempty"`
	Mode                           *StrFilterLookup      `json:"mode,omitempty"`
	Rf_role                        *StrFilterLookup      `json:"rf_role,omitempty"`
	Rf_channel                     *StrFilterLookup      `json:"rf_channel,omitempty"`
	Rf_channel_frequency           *DecimalFilterLookup  `json:"rf_channel_frequency,omitempty"`
	Rf_channel_width               *DecimalFilterLookup  `json:"rf_channel_width,omitempty"`
	Tx_power                       *IntFilterLookup      `json:"tx_power,omitempty"`
	Description                    *StrFilterLookup      `json:"description,omitempty"`
	Mark_connected                 *bool                 `json:"mark_connected,omitempty"`
	Cable_id                       *IDFilterLookup       `json:"cable_id,omitempty"`
	Cable_end                      *StrFilterLookup      `json:"cable_end,omitempty"`
	Q                              *string               `json:"q,omitempty"`
	Region_id                      []string              `json:"region_id,omitempty"`
	Region                         []string              `json:"region,omitempty"`
	Site_group_id                  []string              `json:"site_group_id,omitempty"`
	Site_group                     []string              `json:"site_group,omitempty"`
	Site_id                        []string              `json:"site_id,omitempty"`
	Site                           []string              `json:"site,omitempty"`
	Location_id                    []string              `json:"location_id,omitempty"`
	Location                       []string              `json:"location,omitempty"`
	Rack_id                        []string              `json:"rack_id,omitempty"`
	Rack                           []string              `json:"rack,omitempty"`
	Device_id                      []string              `json:"device_id,omitempty"`
	Device                         []string              `json:"device,omitempty"`
	Device_type_id                 []string              `json:"device_type_id,omitempty"`
	Device_type                    []string              `json:"device_type,omitempty"`
	Device_role_id                 []string              `json:"device_role_id,omitempty"`
	Device_role                    []string              `json:"device_role,omitempty"`
	Virtual_chassis_id             []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis                []string              `json:"virtual_chassis,omitempty"`
	Device_status                  *string               `json:"device_status,omitempty"`
	Module_id                      []string              `json:"module_id,omitempty"`
	Created                        *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated                   *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request             *string               `json:"created_by_request,omitempty"`
	Updated_by_request             *string               `json:"updated_by_request,omitempty"`
	Modified_by_request            *string               `json:"modified_by_request,omitempty"`
	Tag                            []string              `json:"tag,omitempty"`
	Cabled                         *bool                 `json:"cabled,omitempty"`
	Occupied                       *bool                 `json:"occupied,omitempty"`
	Connected                      *bool                 `json:"connected,omitempty"`
	Vlan_id                        *string               `json:"vlan_id,omitempty"`
	Vlan                           *string               `json:"vlan,omitempty"`
	Vrf_id                         []string              `json:"vrf_id,omitempty"`
	Vrf                            []string              `json:"vrf,omitempty"`
	L2vpn_id                       []string              `json:"l2vpn_id,omitempty"`
	L2vpn                          []string              `json:"l2vpn,omitempty"`
	Vlan_translation_policy_id     []string              `json:"vlan_translation_policy_id,omitempty"`
	Vlan_translation_policy        []string              `json:"vlan_translation_policy,omitempty"`
	Virtual_chassis_member         *StrFilterLookup      `json:"virtual_chassis_member,omitempty"`
	Virtual_chassis_member_id      []string              `json:"virtual_chassis_member_id,omitempty"`
	Kind                           *string               `json:"kind,omitempty"`
	Parent_id                      []string              `json:"parent_id,omitempty"`
	Bridge_id                      []string              `json:"bridge_id,omitempty"`
	Lag_id                         []string              `json:"lag_id,omitempty"`
	Speed                          []string              `json:"speed,omitempty"`
	Duplex                         *string               `json:"duplex,omitempty"`
	Mac_address                    []string              `json:"mac_address,omitempty"`
	Primary_mac_address_id         []string              `json:"primary_mac_address_id,omitempty"`
	Primary_mac_address            []string              `json:"primary_mac_address,omitempty"`
	Wwn                            []string              `json:"wwn,omitempty"`
	Vdc_id                         []string              `json:"vdc_id,omitempty"`
	Vdc_identifier                 []string              `json:"vdc_identifier,omitempty"`
	Vdc                            []string              `json:"vdc,omitempty"`
	Wireless_lan_id                []string              `json:"wireless_lan_id,omitempty"`
	Wireless_link_id               []string              `json:"wireless_link_id,omitempty"`
	Virtual_circuit_id             []string              `json:"virtual_circuit_id,omitempty"`
	Virtual_circuit_termination_id []string              `json:"virtual_circuit_termination_id,omitempty"`
	AND                            *InterfaceFilter      `json:"AND,omitempty"`
	OR                             *InterfaceFilter      `json:"OR,omitempty"`
	NOT                            *InterfaceFilter      `json:"NOT,omitempty"`
	DISTINCT                       *bool                 `json:"DISTINCT,omitempty"`
}

// A template for a physical data interface on a new Device.
type InterfaceTemplateFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Label               *StrFilterLookup         `json:"label,omitempty"`
	Type                *StrFilterLookup         `json:"type,omitempty"`
	Enabled             *bool                    `json:"enabled,omitempty"`
	Mgmt_only           *bool                    `json:"mgmt_only,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Device_type_id      []string                 `json:"device_type_id,omitempty"`
	Module_type_id      []string                 `json:"module_type_id,omitempty"`
	Bridge_id           []string                 `json:"bridge_id,omitempty"`
	Poe_mode            *string                  `json:"poe_mode,omitempty"`
	Poe_type            *string                  `json:"poe_type,omitempty"`
	Rf_role             *string                  `json:"rf_role,omitempty"`
	AND                 *InterfaceTemplateFilter `json:"AND,omitempty"`
	OR                  *InterfaceTemplateFilter `json:"OR,omitempty"`
	NOT                 *InterfaceTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// A template for a physical data interface on a new Device.
type InterfaceTemplateType struct {
	Changelog         []ObjectChangeType      `json:"changelog"`
	Display           string                  `json:"display"`
	Class_type        string                  `json:"class_type"`
	Device_type       *DeviceTypeType         `json:"device_type,omitempty"`
	Module_type       *ModuleTypeType         `json:"module_type,omitempty"`
	_name             string                  `json:"_name"`
	Bridge            *InterfaceTemplateType  `json:"bridge,omitempty"`
	Bridge_interfaces []InterfaceTemplateType `json:"bridge_interfaces"`
	Id                string                  `json:"id"`
	Created           *DateTime               `json:"created,omitempty"`
	Last_updated      *DateTime               `json:"last_updated,omitempty"`
	Name              string                  `json:"name"`
	Label             string                  `json:"label"`
	Description       string                  `json:"description"`
	Type              string                  `json:"type"`
	Enabled           bool                    `json:"enabled"`
	Mgmt_only         bool                    `json:"mgmt_only"`
	Poe_mode          *string                 `json:"poe_mode,omitempty"`
	Poe_type          *string                 `json:"poe_type,omitempty"`
	Rf_role           *string                 `json:"rf_role,omitempty"`
}

// A network interface within a Device. A physical Interface can connect to exactly one other Interface.
type InterfaceType struct {
	Ip_addresses            []IPAddressType            `json:"ip_addresses"`
	Changelog               []ObjectChangeType         `json:"changelog"`
	Custom_fields           JSON                       `json:"custom_fields"`
	Tags                    []TagType                  `json:"tags"`
	Display                 string                     `json:"display"`
	Class_type              string                     `json:"class_type"`
	Device                  *DeviceType                `json:"device"`
	Module                  *ModuleType                `json:"module,omitempty"`
	Cable                   *CableType                 `json:"cable,omitempty"`
	Link_peers              []LinkPeerType             `json:"link_peers"`
	Connected_endpoints     []ConnectedEndpointType    `json:"connected_endpoints"`
	_name                   string                     `json:"_name"`
	Wwn                     *string                    `json:"wwn,omitempty"`
	Parent                  *InterfaceType             `json:"parent,omitempty"`
	Bridge                  *InterfaceType             `json:"bridge,omitempty"`
	Lag                     *InterfaceType             `json:"lag,omitempty"`
	Wireless_link           *WirelessLinkType          `json:"wireless_link,omitempty"`
	Untagged_vlan           *VLANType                  `json:"untagged_vlan,omitempty"`
	Vrf                     *VRFType                   `json:"vrf,omitempty"`
	Primary_mac_address     *MACAddressType            `json:"primary_mac_address,omitempty"`
	Qinq_svlan              *VLANType                  `json:"qinq_svlan,omitempty"`
	Vlan_translation_policy *VLANTranslationPolicyType `json:"vlan_translation_policy,omitempty"`
	Vdcs                    []VirtualDeviceContextType `json:"vdcs"`
	Tagged_vlans            []VLANType                 `json:"tagged_vlans"`
	Bridge_interfaces       []InterfaceType            `json:"bridge_interfaces"`
	Wireless_lans           []WirelessLANType          `json:"wireless_lans"`
	Member_interfaces       []InterfaceType            `json:"member_interfaces"`
	Child_interfaces        []InterfaceType            `json:"child_interfaces"`
	Mac_addresses           []MACAddressType           `json:"mac_addresses"`
	Id                      string                     `json:"id"`
	Created                 *DateTime                  `json:"created,omitempty"`
	Last_updated            *DateTime                  `json:"last_updated,omitempty"`
	Custom_field_data       JSON                       `json:"custom_field_data"`
	Name                    string                     `json:"name"`
	Label                   string                     `json:"label"`
	Description             string                     `json:"description"`
	Cable_end               *string                    `json:"cable_end,omitempty"`
	Mark_connected          bool                       `json:"mark_connected"`
	Enabled                 bool                       `json:"enabled"`
	Mtu                     *int32                     `json:"mtu,omitempty"`
	Mode                    *string                    `json:"mode,omitempty"`
	Type                    string                     `json:"type"`
	Mgmt_only               bool                       `json:"mgmt_only"`
	Speed                   *int32                     `json:"speed,omitempty"`
	Duplex                  *string                    `json:"duplex,omitempty"`
	Rf_role                 *string                    `json:"rf_role,omitempty"`
	Rf_channel              *string                    `json:"rf_channel,omitempty"`
	Rf_channel_frequency    *Decimal                   `json:"rf_channel_frequency,omitempty"`
	Rf_channel_width        *Decimal                   `json:"rf_channel_width,omitempty"`
	Tx_power                *int32                     `json:"tx_power,omitempty"`
	Poe_mode                *string                    `json:"poe_mode,omitempty"`
	Poe_type                *string                    `json:"poe_type,omitempty"`
}

func (*InterfaceType) isLinkPeerType() {}

func (*InterfaceType) isInventoryItemComponentType() {}

func (*InterfaceType) isConnectedEndpointType() {}

func (*InterfaceType) isInventoryItemTemplateComponentType() {}

func (*InterfaceType) isCableTerminationTerminationType() {}

func (*InterfaceType) isMACAddressAssignmentType() {}

func (*InterfaceType) isIPAddressAssignmentType() {}

func (*InterfaceType) isFHRPGroupInterfaceType() {}

func (*InterfaceType) isL2VPNAssignmentType() {}

type InventoryItemComponentType struct {
	// Underlying value of the GraphQL union
	Value InventoryItemComponentTypeValue `json:"-"`
}

func (base *InventoryItemComponentType) UnmarshalJSON(b []byte) error {
	type Raw InventoryItemComponentType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "ConsolePortType":
		base.Value = new(ConsolePortType)
	case "ConsoleServerPortType":
		base.Value = new(ConsoleServerPortType)
	case "FrontPortType":
		base.Value = new(FrontPortType)
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "PowerOutletType":
		base.Value = new(PowerOutletType)
	case "PowerPortType":
		base.Value = new(PowerPortType)
	case "RearPortType":
		base.Value = new(RearPortType)
	case "":
		return fmt.Errorf("gqlclient: union InventoryItemComponentType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union InventoryItemComponentType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// InventoryItemComponentTypeValue is one of: ConsolePortType | ConsoleServerPortType | FrontPortType | InterfaceType | PowerOutletType | PowerPortType | RearPortType
type InventoryItemComponentTypeValue interface {
	isInventoryItemComponentType()
}

// An InventoryItem represents a serialized piece of hardware within a Device, such as a line card or power supply.
// InventoryItems are used only for inventory purposes.
type InventoryItemFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Part_id             *StrFilterLookup      `json:"part_id,omitempty"`
	Asset_tag           *StrFilterLookup      `json:"asset_tag,omitempty"`
	Status              *StrFilterLookup      `json:"status,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Discovered          *bool                 `json:"discovered,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Parent_id           []string              `json:"parent_id,omitempty"`
	Manufacturer_id     []string              `json:"manufacturer_id,omitempty"`
	Manufacturer        []string              `json:"manufacturer,omitempty"`
	Role_id             []string              `json:"role_id,omitempty"`
	Role                []string              `json:"role,omitempty"`
	Component_type      *string               `json:"component_type,omitempty"`
	Component_id        []string              `json:"component_id,omitempty"`
	Serial              *StrFilterLookup      `json:"serial,omitempty"`
	AND                 *InventoryItemFilter  `json:"AND,omitempty"`
	OR                  *InventoryItemFilter  `json:"OR,omitempty"`
	NOT                 *InventoryItemFilter  `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Inventory items may optionally be assigned a functional role.
type InventoryItemRoleFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Slug                *StrFilterLookup         `json:"slug,omitempty"`
	Color               []string                 `json:"color,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Tag                 []string                 `json:"tag,omitempty"`
	AND                 *InventoryItemRoleFilter `json:"AND,omitempty"`
	OR                  *InventoryItemRoleFilter `json:"OR,omitempty"`
	NOT                 *InventoryItemRoleFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// Inventory items may optionally be assigned a functional role.
type InventoryItemRoleType struct {
	Changelog                []ObjectChangeType          `json:"changelog"`
	Display                  string                      `json:"display"`
	Class_type               string                      `json:"class_type"`
	Tags                     []TagType                   `json:"tags"`
	Custom_fields            JSON                        `json:"custom_fields"`
	Color                    string                      `json:"color"`
	Inventory_items          []InventoryItemType         `json:"inventory_items"`
	Inventory_item_templates []InventoryItemTemplateType `json:"inventory_item_templates"`
	Id                       string                      `json:"id"`
	Created                  *DateTime                   `json:"created,omitempty"`
	Last_updated             *DateTime                   `json:"last_updated,omitempty"`
	Custom_field_data        JSON                        `json:"custom_field_data"`
	Name                     string                      `json:"name"`
	Slug                     string                      `json:"slug"`
	Description              string                      `json:"description"`
}

type InventoryItemTemplateComponentType struct {
	// Underlying value of the GraphQL union
	Value InventoryItemTemplateComponentTypeValue `json:"-"`
}

func (base *InventoryItemTemplateComponentType) UnmarshalJSON(b []byte) error {
	type Raw InventoryItemTemplateComponentType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "ConsolePortType":
		base.Value = new(ConsolePortType)
	case "ConsoleServerPortType":
		base.Value = new(ConsoleServerPortType)
	case "FrontPortType":
		base.Value = new(FrontPortType)
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "PowerOutletType":
		base.Value = new(PowerOutletType)
	case "PowerPortType":
		base.Value = new(PowerPortType)
	case "RearPortType":
		base.Value = new(RearPortType)
	case "":
		return fmt.Errorf("gqlclient: union InventoryItemTemplateComponentType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union InventoryItemTemplateComponentType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// InventoryItemTemplateComponentTypeValue is one of: ConsolePortType | ConsoleServerPortType | FrontPortType | InterfaceType | PowerOutletType | PowerPortType | RearPortType
type InventoryItemTemplateComponentTypeValue interface {
	isInventoryItemTemplateComponentType()
}

// A template for an InventoryItem to be created for a new parent Device.
type InventoryItemTemplateFilter struct {
	Id                  *IDFilterLookup              `json:"id,omitempty"`
	Name                *StrFilterLookup             `json:"name,omitempty"`
	Label               *StrFilterLookup             `json:"label,omitempty"`
	Part_id             *StrFilterLookup             `json:"part_id,omitempty"`
	Description         *StrFilterLookup             `json:"description,omitempty"`
	Created             *DatetimeFilterLookup        `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup        `json:"last_updated,omitempty"`
	Created_by_request  *string                      `json:"created_by_request,omitempty"`
	Updated_by_request  *string                      `json:"updated_by_request,omitempty"`
	Modified_by_request *string                      `json:"modified_by_request,omitempty"`
	Q                   *string                      `json:"q,omitempty"`
	Device_type_id      []string                     `json:"device_type_id,omitempty"`
	Parent_id           []string                     `json:"parent_id,omitempty"`
	Manufacturer_id     []string                     `json:"manufacturer_id,omitempty"`
	Manufacturer        []string                     `json:"manufacturer,omitempty"`
	Role_id             []string                     `json:"role_id,omitempty"`
	Role                []string                     `json:"role,omitempty"`
	Component_type      *string                      `json:"component_type,omitempty"`
	Component_id        []string                     `json:"component_id,omitempty"`
	AND                 *InventoryItemTemplateFilter `json:"AND,omitempty"`
	OR                  *InventoryItemTemplateFilter `json:"OR,omitempty"`
	NOT                 *InventoryItemTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                        `json:"DISTINCT,omitempty"`
}

// A template for an InventoryItem to be created for a new parent Device.
type InventoryItemTemplateType struct {
	Changelog    []ObjectChangeType                  `json:"changelog"`
	Display      string                              `json:"display"`
	Class_type   string                              `json:"class_type"`
	Device_type  *DeviceTypeType                     `json:"device_type"`
	Role         *InventoryItemRoleType              `json:"role,omitempty"`
	Manufacturer *ManufacturerType                   `json:"manufacturer"`
	Child_items  []InventoryItemTemplateType         `json:"child_items"`
	Component    *InventoryItemTemplateComponentType `json:"component,omitempty"`
	Id           string                              `json:"id"`
	Created      *DateTime                           `json:"created,omitempty"`
	Last_updated *DateTime                           `json:"last_updated,omitempty"`
	Name         string                              `json:"name"`
	Label        string                              `json:"label"`
	Description  string                              `json:"description"`
	Part_id      string                              `json:"part_id"`
	Lft          int32                               `json:"lft"`
	Rght         int32                               `json:"rght"`
	Tree_id      int32                               `json:"tree_id"`
	Level        int32                               `json:"level"`
	Parent       *InventoryItemTemplateType          `json:"parent,omitempty"`
}

// An InventoryItem represents a serialized piece of hardware within a Device, such as a line card or power supply.
// InventoryItems are used only for inventory purposes.
type InventoryItemType struct {
	Changelog         []ObjectChangeType          `json:"changelog"`
	Custom_fields     JSON                        `json:"custom_fields"`
	Tags              []TagType                   `json:"tags"`
	Display           string                      `json:"display"`
	Class_type        string                      `json:"class_type"`
	Device            *DeviceType                 `json:"device"`
	Role              *InventoryItemRoleType      `json:"role,omitempty"`
	Manufacturer      *ManufacturerType           `json:"manufacturer"`
	Child_items       []InventoryItemType         `json:"child_items"`
	Component         *InventoryItemComponentType `json:"component,omitempty"`
	Id                string                      `json:"id"`
	Created           *DateTime                   `json:"created,omitempty"`
	Last_updated      *DateTime                   `json:"last_updated,omitempty"`
	Custom_field_data JSON                        `json:"custom_field_data"`
	Name              string                      `json:"name"`
	Label             string                      `json:"label"`
	Description       string                      `json:"description"`
	Status            string                      `json:"status"`
	Part_id           string                      `json:"part_id"`
	Serial            string                      `json:"serial"`
	Asset_tag         *string                     `json:"asset_tag,omitempty"`
	Discovered        bool                        `json:"discovered"`
	Lft               int32                       `json:"lft"`
	Rght              int32                       `json:"rght"`
	Tree_id           int32                       `json:"tree_id"`
	Level             int32                       `json:"level"`
	Parent            *InventoryItemType          `json:"parent,omitempty"`
}

// The `JSON` scalar type represents JSON values as specified by [ECMA-404](https://ecma-international.org/wp-content/uploads/ECMA-404_2nd_edition_december_2017.pdf).
type JSON string

// A historical remark concerning an object; collectively, these form an object's journal. The journal is used to
// preserve historical context around an object, and complements NetBox's built-in change logging. For example, you
// might record a new journal entry when a device undergoes maintenance, or when a prefix is expanded.
type JournalEntryFilter struct {
	Id                      *IDFilterLookup       `json:"id,omitempty"`
	Assigned_object_type_id *IDFilterLookup       `json:"assigned_object_type_id,omitempty"`
	Assigned_object_id      *IntFilterLookup      `json:"assigned_object_id,omitempty"`
	Created                 *DatetimeFilterLookup `json:"created,omitempty"`
	Kind                    *StrFilterLookup      `json:"kind,omitempty"`
	Last_updated            *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request      *string               `json:"created_by_request,omitempty"`
	Updated_by_request      *string               `json:"updated_by_request,omitempty"`
	Modified_by_request     *string               `json:"modified_by_request,omitempty"`
	Q                       *string               `json:"q,omitempty"`
	Tag                     []string              `json:"tag,omitempty"`
	Assigned_object_type    *string               `json:"assigned_object_type,omitempty"`
	Created_by_id           []string              `json:"created_by_id,omitempty"`
	Created_by              []string              `json:"created_by,omitempty"`
	AND                     *JournalEntryFilter   `json:"AND,omitempty"`
	OR                      *JournalEntryFilter   `json:"OR,omitempty"`
	NOT                     *JournalEntryFilter   `json:"NOT,omitempty"`
	DISTINCT                *bool                 `json:"DISTINCT,omitempty"`
}

// A historical remark concerning an object; collectively, these form an object's journal. The journal is used to
// preserve historical context around an object, and complements NetBox's built-in change logging. For example, you
// might record a new journal entry when a device undergoes maintenance, or when a prefix is expanded.
type JournalEntryType struct {
	Custom_fields        JSON               `json:"custom_fields"`
	Tags                 []TagType          `json:"tags"`
	Changelog            []ObjectChangeType `json:"changelog"`
	Display              string             `json:"display"`
	Class_type           string             `json:"class_type"`
	Assigned_object_type *ContentTypeType   `json:"assigned_object_type,omitempty"`
	Created_by           *UserType          `json:"created_by,omitempty"`
	Id                   string             `json:"id"`
	Created              *DateTime          `json:"created,omitempty"`
	Last_updated         *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data    JSON               `json:"custom_field_data"`
	Assigned_object_id   int32              `json:"assigned_object_id"`
	Kind                 string             `json:"kind"`
	Comments             string             `json:"comments"`
}

type L2VPNAssignmentType struct {
	// Underlying value of the GraphQL union
	Value L2VPNAssignmentTypeValue `json:"-"`
}

func (base *L2VPNAssignmentType) UnmarshalJSON(b []byte) error {
	type Raw L2VPNAssignmentType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "VLANType":
		base.Value = new(VLANType)
	case "VMInterfaceType":
		base.Value = new(VMInterfaceType)
	case "":
		return fmt.Errorf("gqlclient: union L2VPNAssignmentType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union L2VPNAssignmentType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// L2VPNAssignmentTypeValue is one of: InterfaceType | VLANType | VMInterfaceType
type L2VPNAssignmentTypeValue interface {
	isL2VPNAssignmentType()
}

// L2VPN(id, created, last_updated, custom_field_data, description, comments, name, slug, type, identifier, tenant)
type L2VPNFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Identifier          *IntFilterLookup      `json:"identifier,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Type                *StrFilterLookup      `json:"type,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Import_target_id    []string              `json:"import_target_id,omitempty"`
	Import_target       []string              `json:"import_target,omitempty"`
	Export_target_id    []string              `json:"export_target_id,omitempty"`
	Export_target       []string              `json:"export_target,omitempty"`
	AND                 *L2VPNFilter          `json:"AND,omitempty"`
	OR                  *L2VPNFilter          `json:"OR,omitempty"`
	NOT                 *L2VPNFilter          `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// L2VPNTermination(id, created, last_updated, custom_field_data, l2vpn, assigned_object_type, assigned_object_id)
type L2VPNTerminationFilter struct {
	Id                   *IDFilterLookup         `json:"id,omitempty"`
	Assigned_object_id   *IntFilterLookup        `json:"assigned_object_id,omitempty"`
	Created              *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated         *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request   *string                 `json:"created_by_request,omitempty"`
	Updated_by_request   *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request  *string                 `json:"modified_by_request,omitempty"`
	Q                    *string                 `json:"q,omitempty"`
	Tag                  []string                `json:"tag,omitempty"`
	L2vpn_id             []string                `json:"l2vpn_id,omitempty"`
	L2vpn                []string                `json:"l2vpn,omitempty"`
	Region               *StrFilterLookup        `json:"region,omitempty"`
	Region_id            []string                `json:"region_id,omitempty"`
	Site                 *StrFilterLookup        `json:"site,omitempty"`
	Site_id              []string                `json:"site_id,omitempty"`
	Device               []string                `json:"device,omitempty"`
	Device_id            []string                `json:"device_id,omitempty"`
	Virtual_machine      []string                `json:"virtual_machine,omitempty"`
	Virtual_machine_id   []string                `json:"virtual_machine_id,omitempty"`
	Interface            []string                `json:"interface,omitempty"`
	Interface_id         []string                `json:"interface_id,omitempty"`
	Vminterface          []string                `json:"vminterface,omitempty"`
	Vminterface_id       []string                `json:"vminterface_id,omitempty"`
	Vlan                 []string                `json:"vlan,omitempty"`
	Vlan_vid             *int32                  `json:"vlan_vid,omitempty"`
	Vlan_id              []string                `json:"vlan_id,omitempty"`
	Assigned_object_type *string                 `json:"assigned_object_type,omitempty"`
	AND                  *L2VPNTerminationFilter `json:"AND,omitempty"`
	OR                   *L2VPNTerminationFilter `json:"OR,omitempty"`
	NOT                  *L2VPNTerminationFilter `json:"NOT,omitempty"`
	DISTINCT             *bool                   `json:"DISTINCT,omitempty"`
}

// L2VPNTermination(id, created, last_updated, custom_field_data, l2vpn, assigned_object_type, assigned_object_id)
type L2VPNTerminationType struct {
	Changelog         []ObjectChangeType  `json:"changelog"`
	Display           string              `json:"display"`
	Class_type        string              `json:"class_type"`
	Tags              []TagType           `json:"tags"`
	Journal_entries   []JournalEntryType  `json:"journal_entries"`
	Custom_fields     JSON                `json:"custom_fields"`
	L2vpn             *L2VPNType          `json:"l2vpn"`
	Id                string              `json:"id"`
	Created           *DateTime           `json:"created,omitempty"`
	Last_updated      *DateTime           `json:"last_updated,omitempty"`
	Custom_field_data JSON                `json:"custom_field_data"`
	Assigned_object   L2VPNAssignmentType `json:"assigned_object"`
}

// L2VPN(id, created, last_updated, custom_field_data, description, comments, name, slug, type, identifier, tenant)
type L2VPNType struct {
	Contacts          []ContactAssignmentType `json:"contacts"`
	Changelog         []ObjectChangeType      `json:"changelog"`
	Display           string                  `json:"display"`
	Class_type        string                  `json:"class_type"`
	Tags              []TagType               `json:"tags"`
	Journal_entries   []JournalEntryType      `json:"journal_entries"`
	Custom_fields     JSON                    `json:"custom_fields"`
	Tenant            *TenantType             `json:"tenant,omitempty"`
	Export_targets    []RouteTargetType       `json:"export_targets"`
	Terminations      []L2VPNTerminationType  `json:"terminations"`
	Import_targets    []RouteTargetType       `json:"import_targets"`
	Id                string                  `json:"id"`
	Created           *DateTime               `json:"created,omitempty"`
	Last_updated      *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data JSON                    `json:"custom_field_data"`
	Description       string                  `json:"description"`
	Comments          string                  `json:"comments"`
	Name              string                  `json:"name"`
	Slug              string                  `json:"slug"`
	Type              string                  `json:"type"`
	Identifier        *int32                  `json:"identifier,omitempty"`
}

type LinkPeerType struct {
	// Underlying value of the GraphQL union
	Value LinkPeerTypeValue `json:"-"`
}

func (base *LinkPeerType) UnmarshalJSON(b []byte) error {
	type Raw LinkPeerType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "CircuitTerminationType":
		base.Value = new(CircuitTerminationType)
	case "ConsolePortType":
		base.Value = new(ConsolePortType)
	case "ConsoleServerPortType":
		base.Value = new(ConsoleServerPortType)
	case "FrontPortType":
		base.Value = new(FrontPortType)
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "PowerFeedType":
		base.Value = new(PowerFeedType)
	case "PowerOutletType":
		base.Value = new(PowerOutletType)
	case "PowerPortType":
		base.Value = new(PowerPortType)
	case "RearPortType":
		base.Value = new(RearPortType)
	case "":
		return fmt.Errorf("gqlclient: union LinkPeerType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union LinkPeerType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// LinkPeerTypeValue is one of: CircuitTerminationType | ConsolePortType | ConsoleServerPortType | FrontPortType | InterfaceType | PowerFeedType | PowerOutletType | PowerPortType | RearPortType
type LinkPeerTypeValue interface {
	isLinkPeerType()
}

// A Location represents a subgroup of Racks and/or Devices within a Site. A Location may represent a building within a
// site, or a room within a building, for example.
type LocationFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Facility            *StrFilterLookup      `json:"facility,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Parent_id           []string              `json:"parent_id,omitempty"`
	Parent              []string              `json:"parent,omitempty"`
	Ancestor_id         []string              `json:"ancestor_id,omitempty"`
	Ancestor            []string              `json:"ancestor,omitempty"`
	Status              *string               `json:"status,omitempty"`
	AND                 *LocationFilter       `json:"AND,omitempty"`
	OR                  *LocationFilter       `json:"OR,omitempty"`
	NOT                 *LocationFilter       `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A Location represents a subgroup of Racks and/or Devices within a Site. A Location may represent a building within a
// site, or a room within a building, for example.
type LocationType struct {
	Vlan_groups          []VLANGroupType          `json:"vlan_groups"`
	Image_attachments    []ImageAttachmentType    `json:"image_attachments"`
	Contacts             []ContactAssignmentType  `json:"contacts"`
	Changelog            []ObjectChangeType       `json:"changelog"`
	Display              string                   `json:"display"`
	Class_type           string                   `json:"class_type"`
	Tags                 []TagType                `json:"tags"`
	Custom_fields        JSON                     `json:"custom_fields"`
	Site                 *SiteType                `json:"site"`
	Tenant               *TenantType              `json:"tenant,omitempty"`
	Parent               *LocationType            `json:"parent,omitempty"`
	Powerpanel_set       []PowerPanelType         `json:"powerpanel_set"`
	Cabletermination_set []CableTerminationType   `json:"cabletermination_set"`
	Racks                []RackType               `json:"racks"`
	Devices              []DeviceType             `json:"devices"`
	Children             []LocationType           `json:"children"`
	Id                   string                   `json:"id"`
	Created              *DateTime                `json:"created,omitempty"`
	Last_updated         *DateTime                `json:"last_updated,omitempty"`
	Custom_field_data    JSON                     `json:"custom_field_data"`
	Name                 string                   `json:"name"`
	Slug                 string                   `json:"slug"`
	Description          string                   `json:"description"`
	Status               string                   `json:"status"`
	Facility             string                   `json:"facility"`
	Lft                  int32                    `json:"lft"`
	Rght                 int32                    `json:"rght"`
	Tree_id              int32                    `json:"tree_id"`
	Level                int32                    `json:"level"`
	Clusters             []ClusterType            `json:"clusters"`
	Circuit_terminations []CircuitTerminationType `json:"circuit_terminations"`
}

func (*LocationType) isClusterScopeType() {}

func (*LocationType) isWirelessLANScopeType() {}

func (*LocationType) isPrefixScopeType() {}

func (*LocationType) isVLANGroupScopeType() {}

func (*LocationType) isCircuitTerminationTerminationType() {}

type MACAddressAssignmentType struct {
	// Underlying value of the GraphQL union
	Value MACAddressAssignmentTypeValue `json:"-"`
}

func (base *MACAddressAssignmentType) UnmarshalJSON(b []byte) error {
	type Raw MACAddressAssignmentType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "InterfaceType":
		base.Value = new(InterfaceType)
	case "VMInterfaceType":
		base.Value = new(VMInterfaceType)
	case "":
		return fmt.Errorf("gqlclient: union MACAddressAssignmentType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union MACAddressAssignmentType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// MACAddressAssignmentTypeValue is one of: InterfaceType | VMInterfaceType
type MACAddressAssignmentTypeValue interface {
	isMACAddressAssignmentType()
}

// MACAddress(id, created, last_updated, custom_field_data, description, comments, mac_address, assigned_object_type, assigned_object_id)
type MACAddressFilter struct {
	Id                   *IDFilterLookup         `json:"id,omitempty"`
	Description          *StrFilterLookup        `json:"description,omitempty"`
	Assigned_object_type *DjangoModelFilterInput `json:"assigned_object_type,omitempty"`
	Assigned_object_id   *IntFilterLookup        `json:"assigned_object_id,omitempty"`
	Created              *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated         *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request   *string                 `json:"created_by_request,omitempty"`
	Updated_by_request   *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request  *string                 `json:"modified_by_request,omitempty"`
	Q                    *string                 `json:"q,omitempty"`
	Tag                  []string                `json:"tag,omitempty"`
	Mac_address          []string                `json:"mac_address,omitempty"`
	Device               *StrFilterLookup        `json:"device,omitempty"`
	Device_id            []string                `json:"device_id,omitempty"`
	Virtual_machine      *StrFilterLookup        `json:"virtual_machine,omitempty"`
	Virtual_machine_id   []string                `json:"virtual_machine_id,omitempty"`
	Interface            []string                `json:"interface,omitempty"`
	Interface_id         []string                `json:"interface_id,omitempty"`
	Vminterface          []string                `json:"vminterface,omitempty"`
	Vminterface_id       []string                `json:"vminterface_id,omitempty"`
	AND                  *MACAddressFilter       `json:"AND,omitempty"`
	OR                   *MACAddressFilter       `json:"OR,omitempty"`
	NOT                  *MACAddressFilter       `json:"NOT,omitempty"`
	DISTINCT             *bool                   `json:"DISTINCT,omitempty"`
}

// MACAddress(id, created, last_updated, custom_field_data, description, comments, mac_address, assigned_object_type, assigned_object_id)
type MACAddressType struct {
	Changelog         []ObjectChangeType        `json:"changelog"`
	Display           string                    `json:"display"`
	Class_type        string                    `json:"class_type"`
	Tags              []TagType                 `json:"tags"`
	Journal_entries   []JournalEntryType        `json:"journal_entries"`
	Custom_fields     JSON                      `json:"custom_fields"`
	Mac_address       string                    `json:"mac_address"`
	Id                string                    `json:"id"`
	Created           *DateTime                 `json:"created,omitempty"`
	Last_updated      *DateTime                 `json:"last_updated,omitempty"`
	Custom_field_data JSON                      `json:"custom_field_data"`
	Description       string                    `json:"description"`
	Comments          string                    `json:"comments"`
	Assigned_object   *MACAddressAssignmentType `json:"assigned_object,omitempty"`
}

// A Manufacturer represents a company which produces hardware devices; for example, Juniper or Dell.
type ManufacturerFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	AND                 *ManufacturerFilter   `json:"AND,omitempty"`
	OR                  *ManufacturerFilter   `json:"OR,omitempty"`
	NOT                 *ManufacturerFilter   `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A Manufacturer represents a company which produces hardware devices; for example, Juniper or Dell.
type ManufacturerType struct {
	Changelog                []ObjectChangeType          `json:"changelog"`
	Contacts                 []ContactAssignmentType     `json:"contacts"`
	Display                  string                      `json:"display"`
	Class_type               string                      `json:"class_type"`
	Tags                     []TagType                   `json:"tags"`
	Custom_fields            JSON                        `json:"custom_fields"`
	Platforms                []PlatformType              `json:"platforms"`
	Device_types             []DeviceType                `json:"device_types"`
	Inventory_item_templates []InventoryItemTemplateType `json:"inventory_item_templates"`
	Inventory_items          []InventoryItemType         `json:"inventory_items"`
	Module_types             []ModuleType                `json:"module_types"`
	Id                       string                      `json:"id"`
	Created                  *DateTime                   `json:"created,omitempty"`
	Last_updated             *DateTime                   `json:"last_updated,omitempty"`
	Custom_field_data        JSON                        `json:"custom_field_data"`
	Name                     string                      `json:"name"`
	Slug                     string                      `json:"slug"`
	Description              string                      `json:"description"`
}

// An empty space within a Device which can house a child device
type ModuleBayFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Position            *StrFilterLookup      `json:"position,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Module_id           []string              `json:"module_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Parent_id           []string              `json:"parent_id,omitempty"`
	Installed_module_id []string              `json:"installed_module_id,omitempty"`
	AND                 *ModuleBayFilter      `json:"AND,omitempty"`
	OR                  *ModuleBayFilter      `json:"OR,omitempty"`
	NOT                 *ModuleBayFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A template for a ModuleBay to be created for a new parent Device.
type ModuleBayTemplateFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Label               *StrFilterLookup         `json:"label,omitempty"`
	Position            *StrFilterLookup         `json:"position,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Device_type_id      []string                 `json:"device_type_id,omitempty"`
	Module_type_id      []string                 `json:"module_type_id,omitempty"`
	AND                 *ModuleBayTemplateFilter `json:"AND,omitempty"`
	OR                  *ModuleBayTemplateFilter `json:"OR,omitempty"`
	NOT                 *ModuleBayTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// A template for a ModuleBay to be created for a new parent Device.
type ModuleBayTemplateType struct {
	Changelog    []ObjectChangeType `json:"changelog"`
	Display      string             `json:"display"`
	Class_type   string             `json:"class_type"`
	Device_type  *DeviceTypeType    `json:"device_type,omitempty"`
	Module_type  *ModuleTypeType    `json:"module_type,omitempty"`
	Id           string             `json:"id"`
	Created      *DateTime          `json:"created,omitempty"`
	Last_updated *DateTime          `json:"last_updated,omitempty"`
	Name         string             `json:"name"`
	Label        string             `json:"label"`
	Description  string             `json:"description"`
	Position     string             `json:"position"`
}

// An empty space within a Device which can house a child device
type ModuleBayType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Custom_fields     JSON               `json:"custom_fields"`
	Tags              []TagType          `json:"tags"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Device            *DeviceType        `json:"device"`
	Module            *ModuleType        `json:"module,omitempty"`
	Installed_module  *ModuleType        `json:"installed_module,omitempty"`
	Children          []ModuleBayType    `json:"children"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Label             string             `json:"label"`
	Description       string             `json:"description"`
	Position          string             `json:"position"`
	Lft               int32              `json:"lft"`
	Rght              int32              `json:"rght"`
	Tree_id           int32              `json:"tree_id"`
	Level             int32              `json:"level"`
	Parent            *ModuleBayType     `json:"parent,omitempty"`
}

// A Module represents a field-installable component within a Device which may itself hold multiple device components
// (for example, a line card within a chassis switch). Modules are instantiated from ModuleTypes.
type ModuleFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Status              *StrFilterLookup      `json:"status,omitempty"`
	Asset_tag           *StrFilterLookup      `json:"asset_tag,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Manufacturer_id     []string              `json:"manufacturer_id,omitempty"`
	Manufacturer        []string              `json:"manufacturer,omitempty"`
	Module_type_id      []string              `json:"module_type_id,omitempty"`
	Module_type         []string              `json:"module_type,omitempty"`
	Module_bay_id       []string              `json:"module_bay_id,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Serial              *StrFilterLookup      `json:"serial,omitempty"`
	AND                 *ModuleFilter         `json:"AND,omitempty"`
	OR                  *ModuleFilter         `json:"OR,omitempty"`
	NOT                 *ModuleFilter         `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A Module represents a field-installable component within a Device which may itself hold multiple device components
// (for example, a line card within a chassis switch). Modules are instantiated from ModuleTypes.
type ModuleType struct {
	Changelog          []ObjectChangeType      `json:"changelog"`
	Display            string                  `json:"display"`
	Class_type         string                  `json:"class_type"`
	Tags               []TagType               `json:"tags"`
	Journal_entries    []JournalEntryType      `json:"journal_entries"`
	Custom_fields      JSON                    `json:"custom_fields"`
	Device             *DeviceType             `json:"device"`
	Module_bay         *ModuleBayType          `json:"module_bay"`
	Module_type        *ModuleTypeType         `json:"module_type"`
	Interfaces         []InterfaceType         `json:"interfaces"`
	Powerports         []PowerPortType         `json:"powerports"`
	Consoleserverports []ConsoleServerPortType `json:"consoleserverports"`
	Consoleports       []ConsolePortType       `json:"consoleports"`
	Poweroutlets       []PowerOutletType       `json:"poweroutlets"`
	Rearports          []RearPortType          `json:"rearports"`
	Frontports         []FrontPortType         `json:"frontports"`
	Id                 string                  `json:"id"`
	Created            *DateTime               `json:"created,omitempty"`
	Last_updated       *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data  JSON                    `json:"custom_field_data"`
	Description        string                  `json:"description"`
	Comments           string                  `json:"comments"`
	Local_context_data *JSON                   `json:"local_context_data,omitempty"`
	Status             string                  `json:"status"`
	Serial             string                  `json:"serial"`
	Asset_tag          *string                 `json:"asset_tag,omitempty"`
}

// A ModuleType represents a hardware element that can be installed within a device and which houses additional
// components; for example, a line card within a chassis-based switch such as the Cisco Catalyst 6500. Like a
// DeviceType, each ModuleType can have console, power, interface, and pass-through port templates assigned to it. It
// cannot, however house device bays or module bays.
type ModuleTypeFilter struct {
	Id                   *IDFilterLookup       `json:"id,omitempty"`
	Model                *StrFilterLookup      `json:"model,omitempty"`
	Part_number          *StrFilterLookup      `json:"part_number,omitempty"`
	Airflow              *StrFilterLookup      `json:"airflow,omitempty"`
	Weight               *DecimalFilterLookup  `json:"weight,omitempty"`
	Weight_unit          *StrFilterLookup      `json:"weight_unit,omitempty"`
	Description          *StrFilterLookup      `json:"description,omitempty"`
	Created              *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated         *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request   *string               `json:"created_by_request,omitempty"`
	Updated_by_request   *string               `json:"updated_by_request,omitempty"`
	Modified_by_request  *string               `json:"modified_by_request,omitempty"`
	Q                    *string               `json:"q,omitempty"`
	Tag                  []string              `json:"tag,omitempty"`
	Manufacturer_id      []string              `json:"manufacturer_id,omitempty"`
	Manufacturer         []string              `json:"manufacturer,omitempty"`
	Console_ports        *bool                 `json:"console_ports,omitempty"`
	Console_server_ports *bool                 `json:"console_server_ports,omitempty"`
	Power_ports          *bool                 `json:"power_ports,omitempty"`
	Power_outlets        *bool                 `json:"power_outlets,omitempty"`
	Interfaces           *bool                 `json:"interfaces,omitempty"`
	Pass_through_ports   *bool                 `json:"pass_through_ports,omitempty"`
	AND                  *ModuleTypeFilter     `json:"AND,omitempty"`
	OR                   *ModuleTypeFilter     `json:"OR,omitempty"`
	NOT                  *ModuleTypeFilter     `json:"NOT,omitempty"`
	DISTINCT             *bool                 `json:"DISTINCT,omitempty"`
}

// A ModuleType represents a hardware element that can be installed within a device and which houses additional
// components; for example, a line card within a chassis-based switch such as the Cisco Catalyst 6500. Like a
// DeviceType, each ModuleType can have console, power, interface, and pass-through port templates assigned to it. It
// cannot, however house device bays or module bays.
type ModuleTypeType struct {
	Changelog                  []ObjectChangeType              `json:"changelog"`
	Display                    string                          `json:"display"`
	Class_type                 string                          `json:"class_type"`
	Tags                       []TagType                       `json:"tags"`
	Journal_entries            []JournalEntryType              `json:"journal_entries"`
	Custom_fields              JSON                            `json:"custom_fields"`
	Manufacturer               *ManufacturerType               `json:"manufacturer"`
	Frontporttemplates         []FrontPortTemplateType         `json:"frontporttemplates"`
	Consoleserverporttemplates []ConsoleServerPortTemplateType `json:"consoleserverporttemplates"`
	Interfacetemplates         []InterfaceTemplateType         `json:"interfacetemplates"`
	Powerporttemplates         []PowerOutletTemplateType       `json:"powerporttemplates"`
	Poweroutlettemplates       []PowerOutletTemplateType       `json:"poweroutlettemplates"`
	Rearporttemplates          []RearPortTemplateType          `json:"rearporttemplates"`
	Instances                  []InterfaceType                 `json:"instances"`
	Consoleporttemplates       []ModuleType                    `json:"consoleporttemplates"`
	Id                         string                          `json:"id"`
	Created                    *DateTime                       `json:"created,omitempty"`
	Last_updated               *DateTime                       `json:"last_updated,omitempty"`
	Custom_field_data          JSON                            `json:"custom_field_data"`
	Description                string                          `json:"description"`
	Comments                   string                          `json:"comments"`
	Weight                     *Decimal                        `json:"weight,omitempty"`
	Weight_unit                *string                         `json:"weight_unit,omitempty"`
	_abs_weight                *int32                          `json:"_abs_weight,omitempty"`
	Model                      string                          `json:"model"`
	Part_number                string                          `json:"part_number"`
	Airflow                    *string                         `json:"airflow,omitempty"`
}

// A collection of users and/or groups to be informed for certain notifications.
type NotificationGroupFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	User_id             []string                 `json:"user_id,omitempty"`
	User                []string                 `json:"user,omitempty"`
	Group_id            []string                 `json:"group_id,omitempty"`
	Group               []string                 `json:"group,omitempty"`
	AND                 *NotificationGroupFilter `json:"AND,omitempty"`
	OR                  *NotificationGroupFilter `json:"OR,omitempty"`
	NOT                 *NotificationGroupFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// A collection of users and/or groups to be informed for certain notifications.
type NotificationGroupType struct {
	Changelog  []ObjectChangeType `json:"changelog"`
	Display    string             `json:"display"`
	Class_type string             `json:"class_type"`
	Users      []UserType         `json:"users"`
	Groups     []GroupType        `json:"groups"`
}

// A notification message for a User relating to a specific object in NetBox.
type NotificationType struct {
	Changelog  []ObjectChangeType `json:"changelog"`
	Display    string             `json:"display"`
	Class_type string             `json:"class_type"`
	User       *UserType          `json:"user,omitempty"`
}

// Record a change to an object and the user account associated with that change. A change record may optionally
// indicate an object related to the one being changed. For example, a change to an interface may also indicate the
// parent device. This will ensure changes made to component models appear in the parent model's changelog.
type ObjectChangeType struct {
	Display             string           `json:"display"`
	Class_type          string           `json:"class_type"`
	Id                  string           `json:"id"`
	Time                DateTime         `json:"time"`
	User                *DjangoModelType `json:"user,omitempty"`
	User_name           string           `json:"user_name"`
	Request_id          UUID             `json:"request_id"`
	Action              string           `json:"action"`
	Changed_object_type *DjangoModelType `json:"changed_object_type"`
	Changed_object_id   int32            `json:"changed_object_id"`
	Related_object_type *DjangoModelType `json:"related_object_type,omitempty"`
	Related_object_id   *int32           `json:"related_object_id,omitempty"`
	Object_repr         string           `json:"object_repr"`
	Prechange_data      *JSON            `json:"prechange_data,omitempty"`
	Postchange_data     *JSON            `json:"postchange_data,omitempty"`
}

// Platform refers to the software or firmware running on a Device. For example, "Cisco IOS-XR" or "Juniper Junos". A
// Platform may optionally be associated with a particular Manufacturer.
type PlatformFilter struct {
	Id                        *IDFilterLookup       `json:"id,omitempty"`
	Name                      *StrFilterLookup      `json:"name,omitempty"`
	Slug                      *StrFilterLookup      `json:"slug,omitempty"`
	Description               *StrFilterLookup      `json:"description,omitempty"`
	Created                   *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated              *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request        *string               `json:"created_by_request,omitempty"`
	Updated_by_request        *string               `json:"updated_by_request,omitempty"`
	Modified_by_request       *string               `json:"modified_by_request,omitempty"`
	Q                         *string               `json:"q,omitempty"`
	Tag                       []string              `json:"tag,omitempty"`
	Manufacturer_id           []string              `json:"manufacturer_id,omitempty"`
	Manufacturer              []string              `json:"manufacturer,omitempty"`
	Available_for_device_type *string               `json:"available_for_device_type,omitempty"`
	Config_template_id        []string              `json:"config_template_id,omitempty"`
	AND                       *PlatformFilter       `json:"AND,omitempty"`
	OR                        *PlatformFilter       `json:"OR,omitempty"`
	NOT                       *PlatformFilter       `json:"NOT,omitempty"`
	DISTINCT                  *bool                 `json:"DISTINCT,omitempty"`
}

// Platform refers to the software or firmware running on a Device. For example, "Cisco IOS-XR" or "Juniper Junos". A
// Platform may optionally be associated with a particular Manufacturer.
type PlatformType struct {
	Changelog         []ObjectChangeType   `json:"changelog"`
	Display           string               `json:"display"`
	Class_type        string               `json:"class_type"`
	Tags              []TagType            `json:"tags"`
	Custom_fields     JSON                 `json:"custom_fields"`
	Manufacturer      *ManufacturerType    `json:"manufacturer,omitempty"`
	Config_template   *ConfigTemplateType  `json:"config_template,omitempty"`
	Virtual_machines  []VirtualMachineType `json:"virtual_machines"`
	Devices           []DeviceType         `json:"devices"`
	Id                string               `json:"id"`
	Created           *DateTime            `json:"created,omitempty"`
	Last_updated      *DateTime            `json:"last_updated,omitempty"`
	Custom_field_data JSON                 `json:"custom_field_data"`
	Name              string               `json:"name"`
	Slug              string               `json:"slug"`
	Description       string               `json:"description"`
}

// An electrical circuit delivered from a PowerPanel.
type PowerFeedFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Status              *StrFilterLookup      `json:"status,omitempty"`
	Type                *StrFilterLookup      `json:"type,omitempty"`
	Supply              *StrFilterLookup      `json:"supply,omitempty"`
	Phase               *StrFilterLookup      `json:"phase,omitempty"`
	Voltage             *IntFilterLookup      `json:"voltage,omitempty"`
	Amperage            *IntFilterLookup      `json:"amperage,omitempty"`
	Max_utilization     *IntFilterLookup      `json:"max_utilization,omitempty"`
	Available_power     *IntFilterLookup      `json:"available_power,omitempty"`
	Mark_connected      *bool                 `json:"mark_connected,omitempty"`
	Cable_end           *StrFilterLookup      `json:"cable_end,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Cable_id            []string              `json:"cable_id,omitempty"`
	Cabled              *bool                 `json:"cabled,omitempty"`
	Occupied            *bool                 `json:"occupied,omitempty"`
	Connected           *bool                 `json:"connected,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Power_panel_id      []string              `json:"power_panel_id,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	AND                 *PowerFeedFilter      `json:"AND,omitempty"`
	OR                  *PowerFeedFilter      `json:"OR,omitempty"`
	NOT                 *PowerFeedFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An electrical circuit delivered from a PowerPanel.
type PowerFeedType struct {
	Changelog           []ObjectChangeType      `json:"changelog"`
	Cable               *CableType              `json:"cable,omitempty"`
	Link_peers          []LinkPeerType          `json:"link_peers"`
	Connected_endpoints []ConnectedEndpointType `json:"connected_endpoints"`
	Display             string                  `json:"display"`
	Class_type          string                  `json:"class_type"`
	Tags                []TagType               `json:"tags"`
	Journal_entries     []JournalEntryType      `json:"journal_entries"`
	Custom_fields       JSON                    `json:"custom_fields"`
	Power_panel         *PowerPanelType         `json:"power_panel"`
	Rack                *RackType               `json:"rack,omitempty"`
	Tenant              *TenantType             `json:"tenant,omitempty"`
	Id                  string                  `json:"id"`
	Created             *DateTime               `json:"created,omitempty"`
	Last_updated        *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data   JSON                    `json:"custom_field_data"`
	Description         string                  `json:"description"`
	Comments            string                  `json:"comments"`
	Cable_end           *string                 `json:"cable_end,omitempty"`
	Mark_connected      bool                    `json:"mark_connected"`
	Name                string                  `json:"name"`
	Status              string                  `json:"status"`
	Type                string                  `json:"type"`
	Supply              string                  `json:"supply"`
	Phase               string                  `json:"phase"`
	Voltage             int32                   `json:"voltage"`
	Amperage            int32                   `json:"amperage"`
	Max_utilization     int32                   `json:"max_utilization"`
	Available_power     int32                   `json:"available_power"`
}

func (*PowerFeedType) isLinkPeerType() {}

func (*PowerFeedType) isConnectedEndpointType() {}

func (*PowerFeedType) isCableTerminationTerminationType() {}

// A physical power outlet (output) within a Device which provides power to a PowerPort.
type PowerOutletFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Feed_leg            *StrFilterLookup      `json:"feed_leg,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Color               []string              `json:"color,omitempty"`
	Mark_connected      *bool                 `json:"mark_connected,omitempty"`
	Cable_end           *StrFilterLookup      `json:"cable_end,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Module_id           []string              `json:"module_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Cable_id            []string              `json:"cable_id,omitempty"`
	Cabled              *bool                 `json:"cabled,omitempty"`
	Occupied            *bool                 `json:"occupied,omitempty"`
	Connected           *bool                 `json:"connected,omitempty"`
	Type                *string               `json:"type,omitempty"`
	Power_port_id       []string              `json:"power_port_id,omitempty"`
	AND                 *PowerOutletFilter    `json:"AND,omitempty"`
	OR                  *PowerOutletFilter    `json:"OR,omitempty"`
	NOT                 *PowerOutletFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A template for a PowerOutlet to be created for a new Device.
type PowerOutletTemplateFilter struct {
	Id                  *IDFilterLookup            `json:"id,omitempty"`
	Name                *StrFilterLookup           `json:"name,omitempty"`
	Label               *StrFilterLookup           `json:"label,omitempty"`
	Type                *StrFilterLookup           `json:"type,omitempty"`
	Feed_leg            *StrFilterLookup           `json:"feed_leg,omitempty"`
	Description         *StrFilterLookup           `json:"description,omitempty"`
	Created             *DatetimeFilterLookup      `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup      `json:"last_updated,omitempty"`
	Created_by_request  *string                    `json:"created_by_request,omitempty"`
	Updated_by_request  *string                    `json:"updated_by_request,omitempty"`
	Modified_by_request *string                    `json:"modified_by_request,omitempty"`
	Q                   *string                    `json:"q,omitempty"`
	Device_type_id      []string                   `json:"device_type_id,omitempty"`
	Module_type_id      []string                   `json:"module_type_id,omitempty"`
	Power_port_id       []string                   `json:"power_port_id,omitempty"`
	AND                 *PowerOutletTemplateFilter `json:"AND,omitempty"`
	OR                  *PowerOutletTemplateFilter `json:"OR,omitempty"`
	NOT                 *PowerOutletTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                      `json:"DISTINCT,omitempty"`
}

// A template for a PowerOutlet to be created for a new Device.
type PowerOutletTemplateType struct {
	Changelog    []ObjectChangeType     `json:"changelog"`
	Display      string                 `json:"display"`
	Class_type   string                 `json:"class_type"`
	Device_type  *DeviceTypeType        `json:"device_type,omitempty"`
	Module_type  *ModuleTypeType        `json:"module_type,omitempty"`
	Power_port   *PowerPortTemplateType `json:"power_port,omitempty"`
	Id           string                 `json:"id"`
	Created      *DateTime              `json:"created,omitempty"`
	Last_updated *DateTime              `json:"last_updated,omitempty"`
	Name         string                 `json:"name"`
	Label        string                 `json:"label"`
	Description  string                 `json:"description"`
	Type         *string                `json:"type,omitempty"`
	Feed_leg     *string                `json:"feed_leg,omitempty"`
}

// A physical power outlet (output) within a Device which provides power to a PowerPort.
type PowerOutletType struct {
	Changelog           []ObjectChangeType      `json:"changelog"`
	Custom_fields       JSON                    `json:"custom_fields"`
	Tags                []TagType               `json:"tags"`
	Display             string                  `json:"display"`
	Class_type          string                  `json:"class_type"`
	Device              *DeviceType             `json:"device"`
	Module              *ModuleType             `json:"module,omitempty"`
	Cable               *CableType              `json:"cable,omitempty"`
	Link_peers          []LinkPeerType          `json:"link_peers"`
	Connected_endpoints []ConnectedEndpointType `json:"connected_endpoints"`
	Power_port          *PowerPortType          `json:"power_port,omitempty"`
	Color               string                  `json:"color"`
	Id                  string                  `json:"id"`
	Created             *DateTime               `json:"created,omitempty"`
	Last_updated        *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data   JSON                    `json:"custom_field_data"`
	Name                string                  `json:"name"`
	Label               string                  `json:"label"`
	Description         string                  `json:"description"`
	Cable_end           *string                 `json:"cable_end,omitempty"`
	Mark_connected      bool                    `json:"mark_connected"`
	Type                *string                 `json:"type,omitempty"`
	Feed_leg            *string                 `json:"feed_leg,omitempty"`
}

func (*PowerOutletType) isLinkPeerType() {}

func (*PowerOutletType) isInventoryItemComponentType() {}

func (*PowerOutletType) isConnectedEndpointType() {}

func (*PowerOutletType) isInventoryItemTemplateComponentType() {}

func (*PowerOutletType) isCableTerminationTerminationType() {}

// A distribution point for electrical power; e.g. a data center RPP.
type PowerPanelFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	AND                 *PowerPanelFilter     `json:"AND,omitempty"`
	OR                  *PowerPanelFilter     `json:"OR,omitempty"`
	NOT                 *PowerPanelFilter     `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A distribution point for electrical power; e.g. a data center RPP.
type PowerPanelType struct {
	Changelog         []ObjectChangeType      `json:"changelog"`
	Contacts          []ContactAssignmentType `json:"contacts"`
	Display           string                  `json:"display"`
	Class_type        string                  `json:"class_type"`
	Tags              []TagType               `json:"tags"`
	Journal_entries   []JournalEntryType      `json:"journal_entries"`
	Custom_fields     JSON                    `json:"custom_fields"`
	Site              *SiteType               `json:"site"`
	Location          *LocationType           `json:"location,omitempty"`
	Powerfeeds        []PowerFeedType         `json:"powerfeeds"`
	Id                string                  `json:"id"`
	Created           *DateTime               `json:"created,omitempty"`
	Last_updated      *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data JSON                    `json:"custom_field_data"`
	Description       string                  `json:"description"`
	Comments          string                  `json:"comments"`
	Name              string                  `json:"name"`
}

// A physical power supply (intake) port within a Device. PowerPorts connect to PowerOutlets.
type PowerPortFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Maximum_draw        *IntFilterLookup      `json:"maximum_draw,omitempty"`
	Allocated_draw      *IntFilterLookup      `json:"allocated_draw,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Mark_connected      *bool                 `json:"mark_connected,omitempty"`
	Cable_end           *StrFilterLookup      `json:"cable_end,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Module_id           []string              `json:"module_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Cable_id            []string              `json:"cable_id,omitempty"`
	Cabled              *bool                 `json:"cabled,omitempty"`
	Occupied            *bool                 `json:"occupied,omitempty"`
	Connected           *bool                 `json:"connected,omitempty"`
	Type                *string               `json:"type,omitempty"`
	AND                 *PowerPortFilter      `json:"AND,omitempty"`
	OR                  *PowerPortFilter      `json:"OR,omitempty"`
	NOT                 *PowerPortFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A template for a PowerPort to be created for a new Device.
type PowerPortTemplateFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Name                *StrFilterLookup         `json:"name,omitempty"`
	Label               *StrFilterLookup         `json:"label,omitempty"`
	Type                *StrFilterLookup         `json:"type,omitempty"`
	Maximum_draw        *IntFilterLookup         `json:"maximum_draw,omitempty"`
	Allocated_draw      *IntFilterLookup         `json:"allocated_draw,omitempty"`
	Description         *StrFilterLookup         `json:"description,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Device_type_id      []string                 `json:"device_type_id,omitempty"`
	Module_type_id      []string                 `json:"module_type_id,omitempty"`
	AND                 *PowerPortTemplateFilter `json:"AND,omitempty"`
	OR                  *PowerPortTemplateFilter `json:"OR,omitempty"`
	NOT                 *PowerPortTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// A template for a PowerPort to be created for a new Device.
type PowerPortTemplateType struct {
	Changelog             []ObjectChangeType        `json:"changelog"`
	Display               string                    `json:"display"`
	Class_type            string                    `json:"class_type"`
	Device_type           *DeviceTypeType           `json:"device_type,omitempty"`
	Module_type           *ModuleTypeType           `json:"module_type,omitempty"`
	Poweroutlet_templates []PowerOutletTemplateType `json:"poweroutlet_templates"`
	Id                    string                    `json:"id"`
	Created               *DateTime                 `json:"created,omitempty"`
	Last_updated          *DateTime                 `json:"last_updated,omitempty"`
	Name                  string                    `json:"name"`
	Label                 string                    `json:"label"`
	Description           string                    `json:"description"`
	Type                  *string                   `json:"type,omitempty"`
	Maximum_draw          *int32                    `json:"maximum_draw,omitempty"`
	Allocated_draw        *int32                    `json:"allocated_draw,omitempty"`
}

// A physical power supply (intake) port within a Device. PowerPorts connect to PowerOutlets.
type PowerPortType struct {
	Changelog           []ObjectChangeType      `json:"changelog"`
	Custom_fields       JSON                    `json:"custom_fields"`
	Tags                []TagType               `json:"tags"`
	Display             string                  `json:"display"`
	Class_type          string                  `json:"class_type"`
	Device              *DeviceType             `json:"device"`
	Module              *ModuleType             `json:"module,omitempty"`
	Cable               *CableType              `json:"cable,omitempty"`
	Link_peers          []LinkPeerType          `json:"link_peers"`
	Connected_endpoints []ConnectedEndpointType `json:"connected_endpoints"`
	Poweroutlets        []PowerOutletType       `json:"poweroutlets"`
	Id                  string                  `json:"id"`
	Created             *DateTime               `json:"created,omitempty"`
	Last_updated        *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data   JSON                    `json:"custom_field_data"`
	Name                string                  `json:"name"`
	Label               string                  `json:"label"`
	Description         string                  `json:"description"`
	Cable_end           *string                 `json:"cable_end,omitempty"`
	Mark_connected      bool                    `json:"mark_connected"`
	Type                *string                 `json:"type,omitempty"`
	Maximum_draw        *int32                  `json:"maximum_draw,omitempty"`
	Allocated_draw      *int32                  `json:"allocated_draw,omitempty"`
}

func (*PowerPortType) isLinkPeerType() {}

func (*PowerPortType) isInventoryItemComponentType() {}

func (*PowerPortType) isConnectedEndpointType() {}

func (*PowerPortType) isInventoryItemTemplateComponentType() {}

func (*PowerPortType) isCableTerminationTerminationType() {}

// A Prefix represents an IPv4 or IPv6 network, including mask length. Prefixes can optionally be scoped to certain
// areas and/or assigned to VRFs. A Prefix must be assigned a status and may optionally be assigned a used-define Role.
// A Prefix can also be assigned to a VLAN where appropriate.
type PrefixFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Scope_id            *IntFilterLookup      `json:"scope_id,omitempty"`
	Is_pool             *bool                 `json:"is_pool,omitempty"`
	Mark_utilized       *bool                 `json:"mark_utilized,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Scope_type          *string               `json:"scope_type,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Family              *int32                `json:"family,omitempty"`
	Prefix              *StrFilterLookup      `json:"prefix,omitempty"`
	Within              *string               `json:"within,omitempty"`
	Within_include      *string               `json:"within_include,omitempty"`
	Contains            *string               `json:"contains,omitempty"`
	Depth               []string              `json:"depth,omitempty"`
	Children            []string              `json:"children,omitempty"`
	Mask_length         []string              `json:"mask_length,omitempty"`
	Mask_length__gte    *int32                `json:"mask_length__gte,omitempty"`
	Mask_length__lte    *int32                `json:"mask_length__lte,omitempty"`
	Vrf_id              []string              `json:"vrf_id,omitempty"`
	Vrf                 []string              `json:"vrf,omitempty"`
	Present_in_vrf_id   *string               `json:"present_in_vrf_id,omitempty"`
	Present_in_vrf      *string               `json:"present_in_vrf,omitempty"`
	Vlan_id             []string              `json:"vlan_id,omitempty"`
	Vlan_vid            *int32                `json:"vlan_vid,omitempty"`
	Role_id             []string              `json:"role_id,omitempty"`
	Role                []string              `json:"role,omitempty"`
	Status              *string               `json:"status,omitempty"`
	AND                 *PrefixFilter         `json:"AND,omitempty"`
	OR                  *PrefixFilter         `json:"OR,omitempty"`
	NOT                 *PrefixFilter         `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

type PrefixScopeType struct {
	// Underlying value of the GraphQL union
	Value PrefixScopeTypeValue `json:"-"`
}

func (base *PrefixScopeType) UnmarshalJSON(b []byte) error {
	type Raw PrefixScopeType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "LocationType":
		base.Value = new(LocationType)
	case "RegionType":
		base.Value = new(RegionType)
	case "SiteGroupType":
		base.Value = new(SiteGroupType)
	case "SiteType":
		base.Value = new(SiteType)
	case "":
		return fmt.Errorf("gqlclient: union PrefixScopeType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union PrefixScopeType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// PrefixScopeTypeValue is one of: LocationType | RegionType | SiteGroupType | SiteType
type PrefixScopeTypeValue interface {
	isPrefixScopeType()
}

// A Prefix represents an IPv4 or IPv6 network, including mask length. Prefixes can optionally be scoped to certain
// areas and/or assigned to VRFs. A Prefix must be assigned a status and may optionally be assigned a used-define Role.
// A Prefix can also be assigned to a VLAN where appropriate.
type PrefixType struct {
	Changelog         []ObjectChangeType   `json:"changelog"`
	Family            *IPAddressFamilyType `json:"family"`
	Display           string               `json:"display"`
	Class_type        string               `json:"class_type"`
	Tags              []TagType            `json:"tags"`
	Journal_entries   []JournalEntryType   `json:"journal_entries"`
	Custom_fields     JSON                 `json:"custom_fields"`
	Prefix            string               `json:"prefix"`
	Vrf               *VRFType             `json:"vrf,omitempty"`
	Tenant            *TenantType          `json:"tenant,omitempty"`
	Vlan              *VLANType            `json:"vlan,omitempty"`
	Role              *RoleType            `json:"role,omitempty"`
	Id                string               `json:"id"`
	Created           *DateTime            `json:"created,omitempty"`
	Last_updated      *DateTime            `json:"last_updated,omitempty"`
	Custom_field_data JSON                 `json:"custom_field_data"`
	Description       string               `json:"description"`
	Comments          string               `json:"comments"`
	Status            string               `json:"status"`
	Is_pool           bool                 `json:"is_pool"`
	Mark_utilized     bool                 `json:"mark_utilized"`
	_depth            int32                `json:"_depth"`
	_children         int32                `json:"_children"`
	Scope             *PrefixScopeType     `json:"scope,omitempty"`
}

// This is a discrete account within a provider.  Each Circuit belongs to a Provider Account.
type ProviderAccountFilter struct {
	Id                  *IDFilterLookup        `json:"id,omitempty"`
	Name                *StrFilterLookup       `json:"name,omitempty"`
	Account             *StrFilterLookup       `json:"account,omitempty"`
	Description         *StrFilterLookup       `json:"description,omitempty"`
	Created             *DatetimeFilterLookup  `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup  `json:"last_updated,omitempty"`
	Created_by_request  *string                `json:"created_by_request,omitempty"`
	Updated_by_request  *string                `json:"updated_by_request,omitempty"`
	Modified_by_request *string                `json:"modified_by_request,omitempty"`
	Q                   *string                `json:"q,omitempty"`
	Tag                 []string               `json:"tag,omitempty"`
	Provider_id         []string               `json:"provider_id,omitempty"`
	Provider            []string               `json:"provider,omitempty"`
	AND                 *ProviderAccountFilter `json:"AND,omitempty"`
	OR                  *ProviderAccountFilter `json:"OR,omitempty"`
	NOT                 *ProviderAccountFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                  `json:"DISTINCT,omitempty"`
}

// This is a discrete account within a provider.  Each Circuit belongs to a Provider Account.
type ProviderAccountType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Provider          *ProviderType      `json:"provider"`
	Circuits          []CircuitType      `json:"circuits"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Account           string             `json:"account"`
	Name              string             `json:"name"`
}

// Each Circuit belongs to a Provider. This is usually a telecommunications company or similar organization. This model
// stores information pertinent to the user's relationship with the Provider.
type ProviderFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Asn_id              []string              `json:"asn_id,omitempty"`
	Asn                 []string              `json:"asn,omitempty"`
	AND                 *ProviderFilter       `json:"AND,omitempty"`
	OR                  *ProviderFilter       `json:"OR,omitempty"`
	NOT                 *ProviderFilter       `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// This represents a provider network which exists outside of NetBox, the details of which are unknown or
// unimportant to the user.
type ProviderNetworkFilter struct {
	Id                  *IDFilterLookup        `json:"id,omitempty"`
	Name                *StrFilterLookup       `json:"name,omitempty"`
	Service_id          *StrFilterLookup       `json:"service_id,omitempty"`
	Description         *StrFilterLookup       `json:"description,omitempty"`
	Created             *DatetimeFilterLookup  `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup  `json:"last_updated,omitempty"`
	Created_by_request  *string                `json:"created_by_request,omitempty"`
	Updated_by_request  *string                `json:"updated_by_request,omitempty"`
	Modified_by_request *string                `json:"modified_by_request,omitempty"`
	Q                   *string                `json:"q,omitempty"`
	Tag                 []string               `json:"tag,omitempty"`
	Provider_id         []string               `json:"provider_id,omitempty"`
	Provider            []string               `json:"provider,omitempty"`
	AND                 *ProviderNetworkFilter `json:"AND,omitempty"`
	OR                  *ProviderNetworkFilter `json:"OR,omitempty"`
	NOT                 *ProviderNetworkFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                  `json:"DISTINCT,omitempty"`
}

// This represents a provider network which exists outside of NetBox, the details of which are unknown or
// unimportant to the user.
type ProviderNetworkType struct {
	Changelog            []ObjectChangeType       `json:"changelog"`
	Display              string                   `json:"display"`
	Class_type           string                   `json:"class_type"`
	Tags                 []TagType                `json:"tags"`
	Journal_entries      []JournalEntryType       `json:"journal_entries"`
	Custom_fields        JSON                     `json:"custom_fields"`
	Provider             *ProviderType            `json:"provider"`
	Circuit_terminations []CircuitTerminationType `json:"circuit_terminations"`
	Id                   string                   `json:"id"`
	Created              *DateTime                `json:"created,omitempty"`
	Last_updated         *DateTime                `json:"last_updated,omitempty"`
	Custom_field_data    JSON                     `json:"custom_field_data"`
	Description          string                   `json:"description"`
	Comments             string                   `json:"comments"`
	Name                 string                   `json:"name"`
	Service_id           string                   `json:"service_id"`
}

func (*ProviderNetworkType) isConnectedEndpointType() {}

func (*ProviderNetworkType) isCircuitTerminationTerminationType() {}

// Each Circuit belongs to a Provider. This is usually a telecommunications company or similar organization. This model
// stores information pertinent to the user's relationship with the Provider.
type ProviderType struct {
	Changelog         []ObjectChangeType      `json:"changelog"`
	Contacts          []ContactAssignmentType `json:"contacts"`
	Display           string                  `json:"display"`
	Class_type        string                  `json:"class_type"`
	Tags              []TagType               `json:"tags"`
	Journal_entries   []JournalEntryType      `json:"journal_entries"`
	Custom_fields     JSON                    `json:"custom_fields"`
	Networks          []ProviderNetworkType   `json:"networks"`
	Circuits          []CircuitType           `json:"circuits"`
	Asns              []ASNType               `json:"asns"`
	Accounts          []ProviderAccountType   `json:"accounts"`
	Id                string                  `json:"id"`
	Created           *DateTime               `json:"created,omitempty"`
	Last_updated      *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data JSON                    `json:"custom_field_data"`
	Description       string                  `json:"description"`
	Comments          string                  `json:"comments"`
	Name              string                  `json:"name"`
	Slug              string                  `json:"slug"`
}

// A Regional Internet Registry (RIR) is responsible for the allocation of a large portion of the global IP address
// space. This can be an organization like ARIN or RIPE, or a governing standard such as RFC 1918.
type RIRFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Is_private          *bool                 `json:"is_private,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *RIRFilter            `json:"AND,omitempty"`
	OR                  *RIRFilter            `json:"OR,omitempty"`
	NOT                 *RIRFilter            `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A Regional Internet Registry (RIR) is responsible for the allocation of a large portion of the global IP address
// space. This can be an organization like ARIN or RIPE, or a governing standard such as RFC 1918.
type RIRType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Asn_ranges        []ASNRangeType     `json:"asn_ranges"`
	Asns              []ASNType          `json:"asns"`
	Aggregates        []AggregateType    `json:"aggregates"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
	Is_private        bool               `json:"is_private"`
}

// Devices are housed within Racks. Each rack has a defined height measured in rack units, and a front and rear face.
// Each Rack is assigned to a Site and (optionally) a Location.
type RackFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Facility_id         *StrFilterLookup      `json:"facility_id,omitempty"`
	Asset_tag           *StrFilterLookup      `json:"asset_tag,omitempty"`
	U_height            *IntFilterLookup      `json:"u_height,omitempty"`
	Starting_unit       *IntFilterLookup      `json:"starting_unit,omitempty"`
	Desc_units          *bool                 `json:"desc_units,omitempty"`
	Outer_width         *IntFilterLookup      `json:"outer_width,omitempty"`
	Outer_depth         *IntFilterLookup      `json:"outer_depth,omitempty"`
	Outer_unit          *StrFilterLookup      `json:"outer_unit,omitempty"`
	Mounting_depth      *IntFilterLookup      `json:"mounting_depth,omitempty"`
	Airflow             *StrFilterLookup      `json:"airflow,omitempty"`
	Weight              *DecimalFilterLookup  `json:"weight,omitempty"`
	Max_weight          *IntFilterLookup      `json:"max_weight,omitempty"`
	Weight_unit         *StrFilterLookup      `json:"weight_unit,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Manufacturer_id     []string              `json:"manufacturer_id,omitempty"`
	Manufacturer        []string              `json:"manufacturer,omitempty"`
	Rack_type           []string              `json:"rack_type,omitempty"`
	Rack_type_id        []string              `json:"rack_type_id,omitempty"`
	Status              *string               `json:"status,omitempty"`
	Form_factor         *string               `json:"form_factor,omitempty"`
	Width               *string               `json:"width,omitempty"`
	Role_id             []string              `json:"role_id,omitempty"`
	Role                []string              `json:"role,omitempty"`
	Serial              *StrFilterLookup      `json:"serial,omitempty"`
	AND                 *RackFilter           `json:"AND,omitempty"`
	OR                  *RackFilter           `json:"OR,omitempty"`
	NOT                 *RackFilter           `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// One or more reserved units within a Rack.
type RackReservationFilter struct {
	Id                  *IDFilterLookup        `json:"id,omitempty"`
	Created             *DatetimeFilterLookup  `json:"created,omitempty"`
	Description         *StrFilterLookup       `json:"description,omitempty"`
	Last_updated        *DatetimeFilterLookup  `json:"last_updated,omitempty"`
	Created_by_request  *string                `json:"created_by_request,omitempty"`
	Updated_by_request  *string                `json:"updated_by_request,omitempty"`
	Modified_by_request *string                `json:"modified_by_request,omitempty"`
	Q                   *string                `json:"q,omitempty"`
	Tag                 []string               `json:"tag,omitempty"`
	Tenant_group_id     []string               `json:"tenant_group_id,omitempty"`
	Tenant_group        []string               `json:"tenant_group,omitempty"`
	Tenant_id           []string               `json:"tenant_id,omitempty"`
	Tenant              []string               `json:"tenant,omitempty"`
	Rack_id             []string               `json:"rack_id,omitempty"`
	Site_id             []string               `json:"site_id,omitempty"`
	Site                []string               `json:"site,omitempty"`
	Region_id           []string               `json:"region_id,omitempty"`
	Region              []string               `json:"region,omitempty"`
	Site_group_id       []string               `json:"site_group_id,omitempty"`
	Site_group          []string               `json:"site_group,omitempty"`
	Location_id         []string               `json:"location_id,omitempty"`
	Location            []string               `json:"location,omitempty"`
	User_id             []string               `json:"user_id,omitempty"`
	User                []string               `json:"user,omitempty"`
	Unit                *int32                 `json:"unit,omitempty"`
	AND                 *RackReservationFilter `json:"AND,omitempty"`
	OR                  *RackReservationFilter `json:"OR,omitempty"`
	NOT                 *RackReservationFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                  `json:"DISTINCT,omitempty"`
}

// One or more reserved units within a Rack.
type RackReservationType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Units             []int32            `json:"units"`
	Rack              *RackType          `json:"rack"`
	Tenant            *TenantType        `json:"tenant,omitempty"`
	User              *UserType          `json:"user"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Comments          string             `json:"comments"`
	Description       string             `json:"description"`
}

// Racks can be organized by functional role, similar to Devices.
type RackRoleFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Color               []string              `json:"color,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *RackRoleFilter       `json:"AND,omitempty"`
	OR                  *RackRoleFilter       `json:"OR,omitempty"`
	NOT                 *RackRoleFilter       `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Racks can be organized by functional role, similar to Devices.
type RackRoleType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Color             string             `json:"color"`
	Racks             []RackType         `json:"racks"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
}

// Devices are housed within Racks. Each rack has a defined height measured in rack units, and a front and rear face.
// Each Rack is assigned to a Site and (optionally) a Location.
type RackType struct {
	Vlan_groups          []VLANGroupType         `json:"vlan_groups"`
	Image_attachments    []ImageAttachmentType   `json:"image_attachments"`
	Contacts             []ContactAssignmentType `json:"contacts"`
	Changelog            []ObjectChangeType      `json:"changelog"`
	Display              string                  `json:"display"`
	Class_type           string                  `json:"class_type"`
	Tags                 []TagType               `json:"tags"`
	Journal_entries      []JournalEntryType      `json:"journal_entries"`
	Custom_fields        JSON                    `json:"custom_fields"`
	Site                 *SiteType               `json:"site"`
	Location             *LocationType           `json:"location,omitempty"`
	Tenant               *TenantType             `json:"tenant,omitempty"`
	Role                 *RackRoleType           `json:"role,omitempty"`
	Rack_type            *RackTypeType           `json:"rack_type,omitempty"`
	Reservations         []RackReservationType   `json:"reservations"`
	Devices              []DeviceType            `json:"devices"`
	Powerfeeds           []PowerFeedType         `json:"powerfeeds"`
	Cabletermination_set []CableTerminationType  `json:"cabletermination_set"`
	Id                   string                  `json:"id"`
	Created              *DateTime               `json:"created,omitempty"`
	Last_updated         *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data    JSON                    `json:"custom_field_data"`
	Description          string                  `json:"description"`
	Comments             string                  `json:"comments"`
	Weight               *Decimal                `json:"weight,omitempty"`
	Weight_unit          *string                 `json:"weight_unit,omitempty"`
	_abs_weight          *int32                  `json:"_abs_weight,omitempty"`
	Width                int32                   `json:"width"`
	U_height             int32                   `json:"u_height"`
	Starting_unit        int32                   `json:"starting_unit"`
	Desc_units           bool                    `json:"desc_units"`
	Outer_width          *int32                  `json:"outer_width,omitempty"`
	Outer_depth          *int32                  `json:"outer_depth,omitempty"`
	Outer_unit           *string                 `json:"outer_unit,omitempty"`
	Mounting_depth       *int32                  `json:"mounting_depth,omitempty"`
	Max_weight           *int32                  `json:"max_weight,omitempty"`
	_abs_max_weight      *int32                  `json:"_abs_max_weight,omitempty"`
	Form_factor          *string                 `json:"form_factor,omitempty"`
	Name                 string                  `json:"name"`
	Facility_id          *string                 `json:"facility_id,omitempty"`
	Status               string                  `json:"status"`
	Serial               string                  `json:"serial"`
	Asset_tag            *string                 `json:"asset_tag,omitempty"`
	Airflow              *string                 `json:"airflow,omitempty"`
}

func (*RackType) isVLANGroupScopeType() {}

// Devices are housed within Racks. Each rack has a defined height measured in rack units, and a front and rear face.
// Each Rack is assigned to a Site and (optionally) a Location.
type RackTypeFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Model               *StrFilterLookup      `json:"model,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	U_height            *IntFilterLookup      `json:"u_height,omitempty"`
	Starting_unit       *IntFilterLookup      `json:"starting_unit,omitempty"`
	Desc_units          *bool                 `json:"desc_units,omitempty"`
	Outer_width         *IntFilterLookup      `json:"outer_width,omitempty"`
	Outer_depth         *IntFilterLookup      `json:"outer_depth,omitempty"`
	Outer_unit          *StrFilterLookup      `json:"outer_unit,omitempty"`
	Mounting_depth      *IntFilterLookup      `json:"mounting_depth,omitempty"`
	Weight              *DecimalFilterLookup  `json:"weight,omitempty"`
	Max_weight          *IntFilterLookup      `json:"max_weight,omitempty"`
	Weight_unit         *StrFilterLookup      `json:"weight_unit,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Manufacturer_id     []string              `json:"manufacturer_id,omitempty"`
	Manufacturer        []string              `json:"manufacturer,omitempty"`
	Form_factor         *string               `json:"form_factor,omitempty"`
	Width               *string               `json:"width,omitempty"`
	AND                 *RackTypeFilter       `json:"AND,omitempty"`
	OR                  *RackTypeFilter       `json:"OR,omitempty"`
	NOT                 *RackTypeFilter       `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Devices are housed within Racks. Each rack has a defined height measured in rack units, and a front and rear face.
// Each Rack is assigned to a Site and (optionally) a Location.
type RackTypeType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Manufacturer      *ManufacturerType  `json:"manufacturer"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Weight            *Decimal           `json:"weight,omitempty"`
	Weight_unit       *string            `json:"weight_unit,omitempty"`
	_abs_weight       *int32             `json:"_abs_weight,omitempty"`
	Width             int32              `json:"width"`
	U_height          int32              `json:"u_height"`
	Starting_unit     int32              `json:"starting_unit"`
	Desc_units        bool               `json:"desc_units"`
	Outer_width       *int32             `json:"outer_width,omitempty"`
	Outer_depth       *int32             `json:"outer_depth,omitempty"`
	Outer_unit        *string            `json:"outer_unit,omitempty"`
	Mounting_depth    *int32             `json:"mounting_depth,omitempty"`
	Max_weight        *int32             `json:"max_weight,omitempty"`
	_abs_max_weight   *int32             `json:"_abs_max_weight,omitempty"`
	Form_factor       string             `json:"form_factor"`
	Model             string             `json:"model"`
	Slug              string             `json:"slug"`
}

// A pass-through port on the rear of a Device.
type RearPortFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Label               *StrFilterLookup      `json:"label,omitempty"`
	Type                *StrFilterLookup      `json:"type,omitempty"`
	Color               []string              `json:"color,omitempty"`
	Positions           *IntFilterLookup      `json:"positions,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Mark_connected      *bool                 `json:"mark_connected,omitempty"`
	Cable_end           *StrFilterLookup      `json:"cable_end,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Rack_id             []string              `json:"rack_id,omitempty"`
	Rack                []string              `json:"rack,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Device_type_id      []string              `json:"device_type_id,omitempty"`
	Device_type         []string              `json:"device_type,omitempty"`
	Device_role_id      []string              `json:"device_role_id,omitempty"`
	Device_role         []string              `json:"device_role,omitempty"`
	Virtual_chassis_id  []string              `json:"virtual_chassis_id,omitempty"`
	Virtual_chassis     []string              `json:"virtual_chassis,omitempty"`
	Device_status       *string               `json:"device_status,omitempty"`
	Module_id           []string              `json:"module_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Cable_id            []string              `json:"cable_id,omitempty"`
	Cabled              *bool                 `json:"cabled,omitempty"`
	Occupied            *bool                 `json:"occupied,omitempty"`
	AND                 *RearPortFilter       `json:"AND,omitempty"`
	OR                  *RearPortFilter       `json:"OR,omitempty"`
	NOT                 *RearPortFilter       `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// Template for a pass-through port on the rear of a new Device.
type RearPortTemplateFilter struct {
	Id                  *IDFilterLookup         `json:"id,omitempty"`
	Name                *StrFilterLookup        `json:"name,omitempty"`
	Label               *StrFilterLookup        `json:"label,omitempty"`
	Type                *StrFilterLookup        `json:"type,omitempty"`
	Color               []string                `json:"color,omitempty"`
	Positions           *IntFilterLookup        `json:"positions,omitempty"`
	Description         *StrFilterLookup        `json:"description,omitempty"`
	Created             *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request  *string                 `json:"created_by_request,omitempty"`
	Updated_by_request  *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request *string                 `json:"modified_by_request,omitempty"`
	Q                   *string                 `json:"q,omitempty"`
	Device_type_id      []string                `json:"device_type_id,omitempty"`
	Module_type_id      []string                `json:"module_type_id,omitempty"`
	AND                 *RearPortTemplateFilter `json:"AND,omitempty"`
	OR                  *RearPortTemplateFilter `json:"OR,omitempty"`
	NOT                 *RearPortTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                   `json:"DISTINCT,omitempty"`
}

// Template for a pass-through port on the rear of a new Device.
type RearPortTemplateType struct {
	Changelog           []ObjectChangeType      `json:"changelog"`
	Display             string                  `json:"display"`
	Class_type          string                  `json:"class_type"`
	Device_type         *DeviceTypeType         `json:"device_type,omitempty"`
	Module_type         *ModuleTypeType         `json:"module_type,omitempty"`
	Color               string                  `json:"color"`
	Frontport_templates []FrontPortTemplateType `json:"frontport_templates"`
	Id                  string                  `json:"id"`
	Created             *DateTime               `json:"created,omitempty"`
	Last_updated        *DateTime               `json:"last_updated,omitempty"`
	Name                string                  `json:"name"`
	Label               string                  `json:"label"`
	Description         string                  `json:"description"`
	Type                string                  `json:"type"`
	Positions           int32                   `json:"positions"`
}

// A pass-through port on the rear of a Device.
type RearPortType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Custom_fields     JSON               `json:"custom_fields"`
	Tags              []TagType          `json:"tags"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Device            *DeviceType        `json:"device"`
	Module            *ModuleType        `json:"module,omitempty"`
	Cable             *CableType         `json:"cable,omitempty"`
	Link_peers        []LinkPeerType     `json:"link_peers"`
	Color             string             `json:"color"`
	Frontports        []FrontPortType    `json:"frontports"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Label             string             `json:"label"`
	Description       string             `json:"description"`
	Cable_end         *string            `json:"cable_end,omitempty"`
	Mark_connected    bool               `json:"mark_connected"`
	Type              string             `json:"type"`
	Positions         int32              `json:"positions"`
}

func (*RearPortType) isLinkPeerType() {}

func (*RearPortType) isInventoryItemComponentType() {}

func (*RearPortType) isConnectedEndpointType() {}

func (*RearPortType) isInventoryItemTemplateComponentType() {}

func (*RearPortType) isCableTerminationTerminationType() {}

// A region represents a geographic collection of sites. For example, you might create regions representing countries,
// states, and/or cities. Regions are recursively nested into a hierarchy: all sites belonging to a child region are
// also considered to be members of its parent and ancestor region(s).
type RegionFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Parent_id           []string              `json:"parent_id,omitempty"`
	Parent              []string              `json:"parent,omitempty"`
	Ancestor_id         []string              `json:"ancestor_id,omitempty"`
	Ancestor            []string              `json:"ancestor,omitempty"`
	AND                 *RegionFilter         `json:"AND,omitempty"`
	OR                  *RegionFilter         `json:"OR,omitempty"`
	NOT                 *RegionFilter         `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A region represents a geographic collection of sites. For example, you might create regions representing countries,
// states, and/or cities. Regions are recursively nested into a hierarchy: all sites belonging to a child region are
// also considered to be members of its parent and ancestor region(s).
type RegionType struct {
	Vlan_groups          []VLANGroupType          `json:"vlan_groups"`
	Contacts             []ContactAssignmentType  `json:"contacts"`
	Changelog            []ObjectChangeType       `json:"changelog"`
	Display              string                   `json:"display"`
	Class_type           string                   `json:"class_type"`
	Tags                 []TagType                `json:"tags"`
	Custom_fields        JSON                     `json:"custom_fields"`
	Sites                []SiteType               `json:"sites"`
	Children             []RegionType             `json:"children"`
	Id                   string                   `json:"id"`
	Created              *DateTime                `json:"created,omitempty"`
	Last_updated         *DateTime                `json:"last_updated,omitempty"`
	Custom_field_data    JSON                     `json:"custom_field_data"`
	Name                 string                   `json:"name"`
	Slug                 string                   `json:"slug"`
	Description          string                   `json:"description"`
	Lft                  int32                    `json:"lft"`
	Rght                 int32                    `json:"rght"`
	Tree_id              int32                    `json:"tree_id"`
	Level                int32                    `json:"level"`
	Parent               *RegionType              `json:"parent,omitempty"`
	Clusters             []ClusterType            `json:"clusters"`
	Circuit_terminations []CircuitTerminationType `json:"circuit_terminations"`
}

func (*RegionType) isClusterScopeType() {}

func (*RegionType) isWirelessLANScopeType() {}

func (*RegionType) isPrefixScopeType() {}

func (*RegionType) isVLANGroupScopeType() {}

func (*RegionType) isCircuitTerminationTerminationType() {}

// A Role represents the functional role of a Prefix or VLAN; for example, "Customer," "Infrastructure," or
// "Management."
type RoleFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Weight              *IntFilterLookup      `json:"weight,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *RoleFilter           `json:"AND,omitempty"`
	OR                  *RoleFilter           `json:"OR,omitempty"`
	NOT                 *RoleFilter           `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A Role represents the functional role of a Prefix or VLAN; for example, "Customer," "Infrastructure," or
// "Management."
type RoleType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Prefixes          []PrefixType       `json:"prefixes"`
	Ip_ranges         []IPRangeType      `json:"ip_ranges"`
	Vlans             []VLANType         `json:"vlans"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
	Weight            int32              `json:"weight"`
}

// A BGP extended community used to control the redistribution of routes among VRFs, as defined in RFC 4364.
type RouteTargetFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Importing_vrf_id    []string              `json:"importing_vrf_id,omitempty"`
	Importing_vrf       []string              `json:"importing_vrf,omitempty"`
	Exporting_vrf_id    []string              `json:"exporting_vrf_id,omitempty"`
	Exporting_vrf       []string              `json:"exporting_vrf,omitempty"`
	Importing_l2vpn_id  []string              `json:"importing_l2vpn_id,omitempty"`
	Importing_l2vpn     []string              `json:"importing_l2vpn,omitempty"`
	Exporting_l2vpn_id  []string              `json:"exporting_l2vpn_id,omitempty"`
	Exporting_l2vpn     []string              `json:"exporting_l2vpn,omitempty"`
	AND                 *RouteTargetFilter    `json:"AND,omitempty"`
	OR                  *RouteTargetFilter    `json:"OR,omitempty"`
	NOT                 *RouteTargetFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A BGP extended community used to control the redistribution of routes among VRFs, as defined in RFC 4364.
type RouteTargetType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Tenant            *TenantType        `json:"tenant,omitempty"`
	Importing_l2vpns  []L2VPNType        `json:"importing_l2vpns"`
	Exporting_l2vpns  []L2VPNType        `json:"exporting_l2vpns"`
	Importing_vrfs    []VRFType          `json:"importing_vrfs"`
	Exporting_vrfs    []VRFType          `json:"exporting_vrfs"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Name              string             `json:"name"`
}

// A set of predefined keyword parameters that can be reused to filter for specific objects.
type SavedFilterFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Enabled             *bool                 `json:"enabled,omitempty"`
	Shared              *bool                 `json:"shared,omitempty"`
	Weight              *IntFilterLookup      `json:"weight,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Object_type_id      []string              `json:"object_type_id,omitempty"`
	Object_type         *string               `json:"object_type,omitempty"`
	User_id             []string              `json:"user_id,omitempty"`
	User                []string              `json:"user,omitempty"`
	Usable              *bool                 `json:"usable,omitempty"`
	AND                 *SavedFilterFilter    `json:"AND,omitempty"`
	OR                  *SavedFilterFilter    `json:"OR,omitempty"`
	NOT                 *SavedFilterFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A set of predefined keyword parameters that can be reused to filter for specific objects.
type SavedFilterType struct {
	Changelog    []ObjectChangeType `json:"changelog"`
	Display      string             `json:"display"`
	Class_type   string             `json:"class_type"`
	User         *UserType          `json:"user,omitempty"`
	Id           string             `json:"id"`
	Created      *DateTime          `json:"created,omitempty"`
	Last_updated *DateTime          `json:"last_updated,omitempty"`
	Name         string             `json:"name"`
	Slug         string             `json:"slug"`
	Description  string             `json:"description"`
	Weight       int32              `json:"weight"`
	Enabled      bool               `json:"enabled"`
	Shared       bool               `json:"shared"`
	Parameters   JSON               `json:"parameters"`
}

// A Service represents a layer-four service (e.g. HTTP or SSH) running on a Device or VirtualMachine. A Service may
// optionally be tied to one or more specific IPAddresses belonging to its parent.
type ServiceFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Protocol            *StrFilterLookup      `json:"protocol,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Device_id           []string              `json:"device_id,omitempty"`
	Device              []string              `json:"device,omitempty"`
	Virtual_machine_id  []string              `json:"virtual_machine_id,omitempty"`
	Virtual_machine     []string              `json:"virtual_machine,omitempty"`
	Ip_address_id       []string              `json:"ip_address_id,omitempty"`
	Ip_address          []string              `json:"ip_address,omitempty"`
	Port                *int32                `json:"port,omitempty"`
	AND                 *ServiceFilter        `json:"AND,omitempty"`
	OR                  *ServiceFilter        `json:"OR,omitempty"`
	NOT                 *ServiceFilter        `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A template for a Service to be applied to a device or virtual machine.
type ServiceTemplateFilter struct {
	Id                  *IDFilterLookup        `json:"id,omitempty"`
	Name                *StrFilterLookup       `json:"name,omitempty"`
	Protocol            *StrFilterLookup       `json:"protocol,omitempty"`
	Description         *StrFilterLookup       `json:"description,omitempty"`
	Created             *DatetimeFilterLookup  `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup  `json:"last_updated,omitempty"`
	Created_by_request  *string                `json:"created_by_request,omitempty"`
	Updated_by_request  *string                `json:"updated_by_request,omitempty"`
	Modified_by_request *string                `json:"modified_by_request,omitempty"`
	Q                   *string                `json:"q,omitempty"`
	Tag                 []string               `json:"tag,omitempty"`
	Port                *int32                 `json:"port,omitempty"`
	AND                 *ServiceTemplateFilter `json:"AND,omitempty"`
	OR                  *ServiceTemplateFilter `json:"OR,omitempty"`
	NOT                 *ServiceTemplateFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                  `json:"DISTINCT,omitempty"`
}

// A template for a Service to be applied to a device or virtual machine.
type ServiceTemplateType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Ports             []int32            `json:"ports"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Protocol          string             `json:"protocol"`
	Name              string             `json:"name"`
}

// A Service represents a layer-four service (e.g. HTTP or SSH) running on a Device or VirtualMachine. A Service may
// optionally be tied to one or more specific IPAddresses belonging to its parent.
type ServiceType struct {
	Changelog         []ObjectChangeType  `json:"changelog"`
	Display           string              `json:"display"`
	Class_type        string              `json:"class_type"`
	Tags              []TagType           `json:"tags"`
	Journal_entries   []JournalEntryType  `json:"journal_entries"`
	Custom_fields     JSON                `json:"custom_fields"`
	Ports             []int32             `json:"ports"`
	Device            *DeviceType         `json:"device,omitempty"`
	Virtual_machine   *VirtualMachineType `json:"virtual_machine,omitempty"`
	Ipaddresses       []IPAddressType     `json:"ipaddresses"`
	Id                string              `json:"id"`
	Created           *DateTime           `json:"created,omitempty"`
	Last_updated      *DateTime           `json:"last_updated,omitempty"`
	Custom_field_data JSON                `json:"custom_field_data"`
	Description       string              `json:"description"`
	Comments          string              `json:"comments"`
	Protocol          string              `json:"protocol"`
	Name              string              `json:"name"`
}

// A Site represents a geographic location within a network; typically a building or campus. The optional facility
// field can be used to include an external designation, such as a data center name (e.g. Equinix SV6).
type SiteFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Facility            *StrFilterLookup      `json:"facility,omitempty"`
	Latitude            *DecimalFilterLookup  `json:"latitude,omitempty"`
	Longitude           *DecimalFilterLookup  `json:"longitude,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Status              *string               `json:"status,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Group_id            []string              `json:"group_id,omitempty"`
	Group               []string              `json:"group,omitempty"`
	Asn                 []string              `json:"asn,omitempty"`
	Asn_id              []string              `json:"asn_id,omitempty"`
	Time_zone           *StrFilterLookup      `json:"time_zone,omitempty"`
	AND                 *SiteFilter           `json:"AND,omitempty"`
	OR                  *SiteFilter           `json:"OR,omitempty"`
	NOT                 *SiteFilter           `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A site group is an arbitrary grouping of sites. For example, you might have corporate sites and customer sites; and
// within corporate sites you might distinguish between offices and data centers. Like regions, site groups can be
// nested recursively to form a hierarchy.
type SiteGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Parent_id           []string              `json:"parent_id,omitempty"`
	Parent              []string              `json:"parent,omitempty"`
	Ancestor_id         []string              `json:"ancestor_id,omitempty"`
	Ancestor            []string              `json:"ancestor,omitempty"`
	AND                 *SiteGroupFilter      `json:"AND,omitempty"`
	OR                  *SiteGroupFilter      `json:"OR,omitempty"`
	NOT                 *SiteGroupFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A site group is an arbitrary grouping of sites. For example, you might have corporate sites and customer sites; and
// within corporate sites you might distinguish between offices and data centers. Like regions, site groups can be
// nested recursively to form a hierarchy.
type SiteGroupType struct {
	Vlan_groups          []VLANGroupType          `json:"vlan_groups"`
	Contacts             []ContactAssignmentType  `json:"contacts"`
	Changelog            []ObjectChangeType       `json:"changelog"`
	Display              string                   `json:"display"`
	Class_type           string                   `json:"class_type"`
	Tags                 []TagType                `json:"tags"`
	Custom_fields        JSON                     `json:"custom_fields"`
	Sites                []SiteType               `json:"sites"`
	Children             []SiteGroupType          `json:"children"`
	Id                   string                   `json:"id"`
	Created              *DateTime                `json:"created,omitempty"`
	Last_updated         *DateTime                `json:"last_updated,omitempty"`
	Custom_field_data    JSON                     `json:"custom_field_data"`
	Name                 string                   `json:"name"`
	Slug                 string                   `json:"slug"`
	Description          string                   `json:"description"`
	Lft                  int32                    `json:"lft"`
	Rght                 int32                    `json:"rght"`
	Tree_id              int32                    `json:"tree_id"`
	Level                int32                    `json:"level"`
	Parent               *SiteGroupType           `json:"parent,omitempty"`
	Clusters             []ClusterType            `json:"clusters"`
	Circuit_terminations []CircuitTerminationType `json:"circuit_terminations"`
}

func (*SiteGroupType) isClusterScopeType() {}

func (*SiteGroupType) isWirelessLANScopeType() {}

func (*SiteGroupType) isPrefixScopeType() {}

func (*SiteGroupType) isVLANGroupScopeType() {}

func (*SiteGroupType) isCircuitTerminationTerminationType() {}

// A Site represents a geographic location within a network; typically a building or campus. The optional facility
// field can be used to include an external designation, such as a data center name (e.g. Equinix SV6).
type SiteType struct {
	Vlan_groups          []VLANGroupType          `json:"vlan_groups"`
	Image_attachments    []ImageAttachmentType    `json:"image_attachments"`
	Contacts             []ContactAssignmentType  `json:"contacts"`
	Changelog            []ObjectChangeType       `json:"changelog"`
	Display              string                   `json:"display"`
	Class_type           string                   `json:"class_type"`
	Tags                 []TagType                `json:"tags"`
	Journal_entries      []JournalEntryType       `json:"journal_entries"`
	Custom_fields        JSON                     `json:"custom_fields"`
	Time_zone            *string                  `json:"time_zone,omitempty"`
	Region               *RegionType              `json:"region,omitempty"`
	Group                *SiteGroupType           `json:"group,omitempty"`
	Tenant               *TenantType              `json:"tenant,omitempty"`
	Prefixes             []PrefixType             `json:"prefixes"`
	Virtual_machines     []VirtualMachineType     `json:"virtual_machines"`
	Racks                []RackType               `json:"racks"`
	Cabletermination_set []CableTerminationType   `json:"cabletermination_set"`
	Powerpanel_set       []PowerPanelType         `json:"powerpanel_set"`
	Devices              []DeviceType             `json:"devices"`
	Locations            []LocationType           `json:"locations"`
	Asns                 []ASNType                `json:"asns"`
	Circuit_terminations []CircuitTerminationType `json:"circuit_terminations"`
	Clusters             []ClusterType            `json:"clusters"`
	Vlans                []VLANType               `json:"vlans"`
	Id                   string                   `json:"id"`
	Created              *DateTime                `json:"created,omitempty"`
	Last_updated         *DateTime                `json:"last_updated,omitempty"`
	Custom_field_data    JSON                     `json:"custom_field_data"`
	Description          string                   `json:"description"`
	Comments             string                   `json:"comments"`
	Name                 string                   `json:"name"`
	Slug                 string                   `json:"slug"`
	Status               string                   `json:"status"`
	Facility             string                   `json:"facility"`
	Physical_address     string                   `json:"physical_address"`
	Shipping_address     string                   `json:"shipping_address"`
	Latitude             *Decimal                 `json:"latitude,omitempty"`
	Longitude            *Decimal                 `json:"longitude,omitempty"`
}

func (*SiteType) isClusterScopeType() {}

func (*SiteType) isWirelessLANScopeType() {}

func (*SiteType) isPrefixScopeType() {}

func (*SiteType) isVLANGroupScopeType() {}

func (*SiteType) isCircuitTerminationTerminationType() {}

type StrFilterLookup struct {
	Exact         *string  `json:"exact,omitempty"`
	I_exact       *string  `json:"i_exact,omitempty"`
	Contains      *string  `json:"contains,omitempty"`
	I_contains    *string  `json:"i_contains,omitempty"`
	In_list       []string `json:"in_list,omitempty"`
	Gt            *string  `json:"gt,omitempty"`
	Gte           *string  `json:"gte,omitempty"`
	Lt            *string  `json:"lt,omitempty"`
	Lte           *string  `json:"lte,omitempty"`
	Starts_with   *string  `json:"starts_with,omitempty"`
	I_starts_with *string  `json:"i_starts_with,omitempty"`
	Ends_with     *string  `json:"ends_with,omitempty"`
	I_ends_with   *string  `json:"i_ends_with,omitempty"`
	Range         []string `json:"range,omitempty"`
	Is_null       *bool    `json:"is_null,omitempty"`
	Regex         *string  `json:"regex,omitempty"`
	I_regex       *string  `json:"i_regex,omitempty"`
}

// A User's subscription to a particular object, to be notified of changes.
type SubscriptionType struct {
	Changelog  []ObjectChangeType `json:"changelog"`
	Display    string             `json:"display"`
	Class_type string             `json:"class_type"`
	User       *UserType          `json:"user,omitempty"`
}

// Tag(name, slug, created, last_updated, id, color, description)
type TagFilter struct {
	Id                  *IDFilterLookup         `json:"id,omitempty"`
	Name                *StrFilterLookup        `json:"name,omitempty"`
	Slug                *StrFilterLookup        `json:"slug,omitempty"`
	Color               []string                `json:"color,omitempty"`
	Description         *StrFilterLookup        `json:"description,omitempty"`
	Object_types        *DjangoModelFilterInput `json:"object_types,omitempty"`
	Created             *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request  *string                 `json:"created_by_request,omitempty"`
	Updated_by_request  *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request *string                 `json:"modified_by_request,omitempty"`
	Q                   *string                 `json:"q,omitempty"`
	Content_type        *StrFilterLookup        `json:"content_type,omitempty"`
	Content_type_id     []string                `json:"content_type_id,omitempty"`
	For_object_type_id  []string                `json:"for_object_type_id,omitempty"`
	AND                 *TagFilter              `json:"AND,omitempty"`
	OR                  *TagFilter              `json:"OR,omitempty"`
	NOT                 *TagFilter              `json:"NOT,omitempty"`
	DISTINCT            *bool                   `json:"DISTINCT,omitempty"`
}

// Tag(name, slug, created, last_updated, id, color, description)
type TagType struct {
	Changelog    []ObjectChangeType `json:"changelog"`
	Display      string             `json:"display"`
	Class_type   string             `json:"class_type"`
	Color        string             `json:"color"`
	Object_types []ContentTypeType  `json:"object_types"`
	Name         string             `json:"name"`
	Slug         string             `json:"slug"`
	Created      *DateTime          `json:"created,omitempty"`
	Last_updated *DateTime          `json:"last_updated,omitempty"`
	Id           string             `json:"id"`
	Description  string             `json:"description"`
}

// A Tenant represents an organization served by the NetBox owner. This is typically a customer or an internal
// department.
type TenantFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Contact             []string              `json:"contact,omitempty"`
	Contact_role        []string              `json:"contact_role,omitempty"`
	Contact_group       []string              `json:"contact_group,omitempty"`
	Group_id            []string              `json:"group_id,omitempty"`
	Group               []string              `json:"group,omitempty"`
	AND                 *TenantFilter         `json:"AND,omitempty"`
	OR                  *TenantFilter         `json:"OR,omitempty"`
	NOT                 *TenantFilter         `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An arbitrary collection of Tenants.
type TenantGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Parent_id           []string              `json:"parent_id,omitempty"`
	Parent              []string              `json:"parent,omitempty"`
	Ancestor_id         []string              `json:"ancestor_id,omitempty"`
	Ancestor            []string              `json:"ancestor,omitempty"`
	AND                 *TenantGroupFilter    `json:"AND,omitempty"`
	OR                  *TenantGroupFilter    `json:"OR,omitempty"`
	NOT                 *TenantGroupFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An arbitrary collection of Tenants.
type TenantGroupType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Parent            *TenantGroupType   `json:"parent,omitempty"`
	Tenants           []TenantType       `json:"tenants"`
	Children          []TenantGroupType  `json:"children"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Lft               int32              `json:"lft"`
	Rght              int32              `json:"rght"`
	Tree_id           int32              `json:"tree_id"`
	Level             int32              `json:"level"`
}

// A Tenant represents an organization served by the NetBox owner. This is typically a customer or an internal
// department.
type TenantType struct {
	Changelog         []ObjectChangeType         `json:"changelog"`
	Display           string                     `json:"display"`
	Class_type        string                     `json:"class_type"`
	Tags              []TagType                  `json:"tags"`
	Journal_entries   []JournalEntryType         `json:"journal_entries"`
	Custom_fields     JSON                       `json:"custom_fields"`
	Group             *TenantGroupType           `json:"group,omitempty"`
	Asns              []ASNType                  `json:"asns"`
	Circuits          []CircuitType              `json:"circuits"`
	Sites             []SiteType                 `json:"sites"`
	Vlans             []VLANType                 `json:"vlans"`
	Wireless_lans     []WirelessLANType          `json:"wireless_lans"`
	Route_targets     []RouteTargetType          `json:"route_targets"`
	Locations         []LocationType             `json:"locations"`
	Ip_ranges         []IPRangeType              `json:"ip_ranges"`
	Rackreservations  []RackReservationType      `json:"rackreservations"`
	Racks             []RackType                 `json:"racks"`
	Vdcs              []VirtualDeviceContextType `json:"vdcs"`
	Prefixes          []PrefixType               `json:"prefixes"`
	Cables            []CableType                `json:"cables"`
	Virtual_machines  []VirtualMachineType       `json:"virtual_machines"`
	Vrfs              []VRFType                  `json:"vrfs"`
	Asn_ranges        []ASNRangeType             `json:"asn_ranges"`
	Wireless_links    []WirelessLinkType         `json:"wireless_links"`
	Aggregates        []AggregateType            `json:"aggregates"`
	Power_feeds       []PowerFeedType            `json:"power_feeds"`
	Devices           []DeviceType               `json:"devices"`
	Tunnels           []TunnelType               `json:"tunnels"`
	Ip_addresses      []IPAddressType            `json:"ip_addresses"`
	Clusters          []ClusterType              `json:"clusters"`
	L2vpns            []L2VPNType                `json:"l2vpns"`
	Id                string                     `json:"id"`
	Created           *DateTime                  `json:"created,omitempty"`
	Last_updated      *DateTime                  `json:"last_updated,omitempty"`
	Custom_field_data JSON                       `json:"custom_field_data"`
	Description       string                     `json:"description"`
	Comments          string                     `json:"comments"`
	Name              string                     `json:"name"`
	Slug              string                     `json:"slug"`
}

// Tunnel(id, created, last_updated, custom_field_data, description, comments, name, status, group, encapsulation, ipsec_profile, tenant, tunnel_id)
type TunnelFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Tunnel_id           *IntFilterLookup      `json:"tunnel_id,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Status              *string               `json:"status,omitempty"`
	Group_id            []string              `json:"group_id,omitempty"`
	Group               []string              `json:"group,omitempty"`
	Encapsulation       *string               `json:"encapsulation,omitempty"`
	Ipsec_profile_id    []string              `json:"ipsec_profile_id,omitempty"`
	Ipsec_profile       []string              `json:"ipsec_profile,omitempty"`
	AND                 *TunnelFilter         `json:"AND,omitempty"`
	OR                  *TunnelFilter         `json:"OR,omitempty"`
	NOT                 *TunnelFilter         `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An administrative grouping of Tunnels. This can be used to correlate peer-to-peer tunnels which form a mesh,
// for example.
type TunnelGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *TunnelGroupFilter    `json:"AND,omitempty"`
	OR                  *TunnelGroupFilter    `json:"OR,omitempty"`
	NOT                 *TunnelGroupFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// An administrative grouping of Tunnels. This can be used to correlate peer-to-peer tunnels which form a mesh,
// for example.
type TunnelGroupType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Custom_fields     JSON               `json:"custom_fields"`
	Tunnels           []TunnelType       `json:"tunnels"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Name              string             `json:"name"`
	Slug              string             `json:"slug"`
	Description       string             `json:"description"`
}

// TunnelTermination(id, created, last_updated, custom_field_data, tunnel, role, termination_type, termination_id, outside_ip)
type TunnelTerminationFilter struct {
	Id                  *IDFilterLookup          `json:"id,omitempty"`
	Termination_id      *IntFilterLookup         `json:"termination_id,omitempty"`
	Created             *DatetimeFilterLookup    `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup    `json:"last_updated,omitempty"`
	Created_by_request  *string                  `json:"created_by_request,omitempty"`
	Updated_by_request  *string                  `json:"updated_by_request,omitempty"`
	Modified_by_request *string                  `json:"modified_by_request,omitempty"`
	Q                   *string                  `json:"q,omitempty"`
	Tag                 []string                 `json:"tag,omitempty"`
	Tunnel_id           []string                 `json:"tunnel_id,omitempty"`
	Tunnel              []string                 `json:"tunnel,omitempty"`
	Role                *string                  `json:"role,omitempty"`
	Termination_type    *string                  `json:"termination_type,omitempty"`
	Interface           []string                 `json:"interface,omitempty"`
	Interface_id        []string                 `json:"interface_id,omitempty"`
	Vminterface         []string                 `json:"vminterface,omitempty"`
	Vminterface_id      []string                 `json:"vminterface_id,omitempty"`
	Outside_ip_id       []string                 `json:"outside_ip_id,omitempty"`
	AND                 *TunnelTerminationFilter `json:"AND,omitempty"`
	OR                  *TunnelTerminationFilter `json:"OR,omitempty"`
	NOT                 *TunnelTerminationFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                    `json:"DISTINCT,omitempty"`
}

// TunnelTermination(id, created, last_updated, custom_field_data, tunnel, role, termination_type, termination_id, outside_ip)
type TunnelTerminationType struct {
	Custom_fields     JSON               `json:"custom_fields"`
	Tags              []TagType          `json:"tags"`
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tunnel            *TunnelType        `json:"tunnel"`
	Termination_type  *ContentTypeType   `json:"termination_type,omitempty"`
	Outside_ip        *IPAddressType     `json:"outside_ip,omitempty"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Role              string             `json:"role"`
	Termination_id    *int32             `json:"termination_id,omitempty"`
}

// Tunnel(id, created, last_updated, custom_field_data, description, comments, name, status, group, encapsulation, ipsec_profile, tenant, tunnel_id)
type TunnelType struct {
	Changelog         []ObjectChangeType      `json:"changelog"`
	Display           string                  `json:"display"`
	Class_type        string                  `json:"class_type"`
	Tags              []TagType               `json:"tags"`
	Journal_entries   []JournalEntryType      `json:"journal_entries"`
	Custom_fields     JSON                    `json:"custom_fields"`
	Group             *TunnelGroupType        `json:"group,omitempty"`
	Ipsec_profile     *IPSecProfileType       `json:"ipsec_profile,omitempty"`
	Tenant            *TenantType             `json:"tenant,omitempty"`
	Terminations      []TunnelTerminationType `json:"terminations"`
	Id                string                  `json:"id"`
	Created           *DateTime               `json:"created,omitempty"`
	Last_updated      *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data JSON                    `json:"custom_field_data"`
	Description       string                  `json:"description"`
	Comments          string                  `json:"comments"`
	Name              string                  `json:"name"`
	Status            string                  `json:"status"`
	Encapsulation     string                  `json:"encapsulation"`
	Tunnel_id         *int32                  `json:"tunnel_id,omitempty"`
}

type UUID string

// BigInt field
type Union string

// User(id, password, last_login, is_superuser, username, first_name, last_name, email, is_staff, is_active, date_joined)
type UserFilter struct {
	Id                    *IDFilterLookup       `json:"id,omitempty"`
	Username              *StrFilterLookup      `json:"username,omitempty"`
	First_name            *StrFilterLookup      `json:"first_name,omitempty"`
	Last_name             *StrFilterLookup      `json:"last_name,omitempty"`
	Email                 *StrFilterLookup      `json:"email,omitempty"`
	Date_joined           *DatetimeFilterLookup `json:"date_joined,omitempty"`
	Last_login            *DatetimeFilterLookup `json:"last_login,omitempty"`
	Is_staff              *bool                 `json:"is_staff,omitempty"`
	Is_active             *bool                 `json:"is_active,omitempty"`
	Is_superuser          *bool                 `json:"is_superuser,omitempty"`
	Q                     *string               `json:"q,omitempty"`
	Group_id              []string              `json:"group_id,omitempty"`
	Group                 []string              `json:"group,omitempty"`
	Permission_id         []string              `json:"permission_id,omitempty"`
	Notification_group_id []string              `json:"notification_group_id,omitempty"`
	AND                   *UserFilter           `json:"AND,omitempty"`
	OR                    *UserFilter           `json:"OR,omitempty"`
	NOT                   *UserFilter           `json:"NOT,omitempty"`
	DISTINCT              *bool                 `json:"DISTINCT,omitempty"`
}

// User(id, password, last_login, is_superuser, username, first_name, last_name, email, is_staff, is_active, date_joined)
type UserType struct {
	Display     string      `json:"display"`
	Class_type  string      `json:"class_type"`
	Groups      []GroupType `json:"groups"`
	Id          string      `json:"id"`
	Username    string      `json:"username"`
	First_name  string      `json:"first_name"`
	Last_name   string      `json:"last_name"`
	Email       string      `json:"email"`
	Is_staff    bool        `json:"is_staff"`
	Is_active   bool        `json:"is_active"`
	Date_joined DateTime    `json:"date_joined"`
}

// A VLAN is a distinct layer two forwarding domain identified by a 12-bit integer (1-4094). Each VLAN must be assigned
// to a Site, however VLAN IDs need not be unique within a Site. A VLAN may optionally be assigned to a VLANGroup,
// within which all VLAN IDs and names but be unique.
//
// Like Prefixes, each VLAN is assigned an operational status and optionally a user-defined Role. A VLAN can have zero
// or more Prefixes assigned to it.
type VLANFilter struct {
	Id                          *IDFilterLookup       `json:"id,omitempty"`
	Vid                         *IntFilterLookup      `json:"vid,omitempty"`
	Name                        *StrFilterLookup      `json:"name,omitempty"`
	Description                 *StrFilterLookup      `json:"description,omitempty"`
	Created                     *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated                *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request          *string               `json:"created_by_request,omitempty"`
	Updated_by_request          *string               `json:"updated_by_request,omitempty"`
	Modified_by_request         *string               `json:"modified_by_request,omitempty"`
	Q                           *string               `json:"q,omitempty"`
	Tag                         []string              `json:"tag,omitempty"`
	Tenant_group_id             []string              `json:"tenant_group_id,omitempty"`
	Tenant_group                []string              `json:"tenant_group,omitempty"`
	Tenant_id                   []string              `json:"tenant_id,omitempty"`
	Tenant                      []string              `json:"tenant,omitempty"`
	Region_id                   []string              `json:"region_id,omitempty"`
	Region                      []string              `json:"region,omitempty"`
	Site_group_id               []string              `json:"site_group_id,omitempty"`
	Site_group                  []string              `json:"site_group,omitempty"`
	Site_id                     []string              `json:"site_id,omitempty"`
	Site                        []string              `json:"site,omitempty"`
	Group_id                    []string              `json:"group_id,omitempty"`
	Group                       []string              `json:"group,omitempty"`
	Role_id                     []string              `json:"role_id,omitempty"`
	Role                        []string              `json:"role,omitempty"`
	Status                      *string               `json:"status,omitempty"`
	Available_at_site           *string               `json:"available_at_site,omitempty"`
	Available_on_device         *string               `json:"available_on_device,omitempty"`
	Available_on_virtualmachine *string               `json:"available_on_virtualmachine,omitempty"`
	Qinq_role                   *string               `json:"qinq_role,omitempty"`
	Qinq_svlan_id               []string              `json:"qinq_svlan_id,omitempty"`
	Qinq_svlan_vid              []string              `json:"qinq_svlan_vid,omitempty"`
	L2vpn_id                    []string              `json:"l2vpn_id,omitempty"`
	L2vpn                       []string              `json:"l2vpn,omitempty"`
	Interface_id                *string               `json:"interface_id,omitempty"`
	Vminterface_id              *string               `json:"vminterface_id,omitempty"`
	AND                         *VLANFilter           `json:"AND,omitempty"`
	OR                          *VLANFilter           `json:"OR,omitempty"`
	NOT                         *VLANFilter           `json:"NOT,omitempty"`
	DISTINCT                    *bool                 `json:"DISTINCT,omitempty"`
}

// A VLAN group is an arbitrary collection of VLANs within which VLAN IDs and names must be unique. Each group must
//
//	define one or more ranges of valid VLAN IDs, and may be assigned a specific scope.
type VLANGroupFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Slug                *StrFilterLookup      `json:"slug,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Scope_id            *IntFilterLookup      `json:"scope_id,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Scope_type          *string               `json:"scope_type,omitempty"`
	Region              *int32                `json:"region,omitempty"`
	Site_group          *int32                `json:"site_group,omitempty"`
	Site                *int32                `json:"site,omitempty"`
	Location            *int32                `json:"location,omitempty"`
	Rack                *int32                `json:"rack,omitempty"`
	Cluster_group       *int32                `json:"cluster_group,omitempty"`
	Cluster             *int32                `json:"cluster,omitempty"`
	Contains_vid        *int32                `json:"contains_vid,omitempty"`
	AND                 *VLANGroupFilter      `json:"AND,omitempty"`
	OR                  *VLANGroupFilter      `json:"OR,omitempty"`
	NOT                 *VLANGroupFilter      `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

type VLANGroupScopeType struct {
	// Underlying value of the GraphQL union
	Value VLANGroupScopeTypeValue `json:"-"`
}

func (base *VLANGroupScopeType) UnmarshalJSON(b []byte) error {
	type Raw VLANGroupScopeType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "ClusterType":
		base.Value = new(ClusterType)
	case "ClusterGroupType":
		base.Value = new(ClusterGroupType)
	case "LocationType":
		base.Value = new(LocationType)
	case "RackType":
		base.Value = new(RackType)
	case "RegionType":
		base.Value = new(RegionType)
	case "SiteType":
		base.Value = new(SiteType)
	case "SiteGroupType":
		base.Value = new(SiteGroupType)
	case "":
		return fmt.Errorf("gqlclient: union VLANGroupScopeType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union VLANGroupScopeType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// VLANGroupScopeTypeValue is one of: ClusterType | ClusterGroupType | LocationType | RackType | RegionType | SiteType | SiteGroupType
type VLANGroupScopeTypeValue interface {
	isVLANGroupScopeType()
}

// A VLAN group is an arbitrary collection of VLANs within which VLAN IDs and names must be unique. Each group must
//
//	define one or more ranges of valid VLAN IDs, and may be assigned a specific scope.
type VLANGroupType struct {
	Changelog         []ObjectChangeType  `json:"changelog"`
	Display           string              `json:"display"`
	Class_type        string              `json:"class_type"`
	Tags              []TagType           `json:"tags"`
	Custom_fields     JSON                `json:"custom_fields"`
	Vlans             []VLANType          `json:"vlans"`
	Vid_ranges        []string            `json:"vid_ranges"`
	Id                string              `json:"id"`
	Created           *DateTime           `json:"created,omitempty"`
	Last_updated      *DateTime           `json:"last_updated,omitempty"`
	Custom_field_data JSON                `json:"custom_field_data"`
	Description       string              `json:"description"`
	Name              string              `json:"name"`
	Slug              string              `json:"slug"`
	_total_vlan_ids   int32               `json:"_total_vlan_ids"`
	Scope             *VLANGroupScopeType `json:"scope,omitempty"`
}

// VLANTranslationPolicy(id, created, last_updated, custom_field_data, description, comments, name)
type VLANTranslationPolicyFilter struct {
	Id                  *IDFilterLookup              `json:"id,omitempty"`
	Name                *StrFilterLookup             `json:"name,omitempty"`
	Description         *StrFilterLookup             `json:"description,omitempty"`
	Created             *DatetimeFilterLookup        `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup        `json:"last_updated,omitempty"`
	Created_by_request  *string                      `json:"created_by_request,omitempty"`
	Updated_by_request  *string                      `json:"updated_by_request,omitempty"`
	Modified_by_request *string                      `json:"modified_by_request,omitempty"`
	Q                   *string                      `json:"q,omitempty"`
	Tag                 []string                     `json:"tag,omitempty"`
	AND                 *VLANTranslationPolicyFilter `json:"AND,omitempty"`
	OR                  *VLANTranslationPolicyFilter `json:"OR,omitempty"`
	NOT                 *VLANTranslationPolicyFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                        `json:"DISTINCT,omitempty"`
}

// VLANTranslationPolicy(id, created, last_updated, custom_field_data, description, comments, name)
type VLANTranslationPolicyType struct {
	Changelog         []ObjectChangeType        `json:"changelog"`
	Display           string                    `json:"display"`
	Class_type        string                    `json:"class_type"`
	Tags              []TagType                 `json:"tags"`
	Journal_entries   []JournalEntryType        `json:"journal_entries"`
	Custom_fields     JSON                      `json:"custom_fields"`
	Rules             []VLANTranslationRuleType `json:"rules"`
	Id                string                    `json:"id"`
	Created           *DateTime                 `json:"created,omitempty"`
	Last_updated      *DateTime                 `json:"last_updated,omitempty"`
	Custom_field_data JSON                      `json:"custom_field_data"`
	Description       string                    `json:"description"`
	Comments          string                    `json:"comments"`
	Name              string                    `json:"name"`
}

// VLANTranslationRule(id, created, last_updated, custom_field_data, policy, description, local_vid, remote_vid)
type VLANTranslationRuleFilter struct {
	Id                  *IDFilterLookup            `json:"id,omitempty"`
	Policy_id           *IDFilterLookup            `json:"policy_id,omitempty"`
	Policy              *DjangoModelFilterInput    `json:"policy,omitempty"`
	Local_vid           *IntFilterLookup           `json:"local_vid,omitempty"`
	Remote_vid          *IntFilterLookup           `json:"remote_vid,omitempty"`
	Description         *StrFilterLookup           `json:"description,omitempty"`
	Created             *DatetimeFilterLookup      `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup      `json:"last_updated,omitempty"`
	Created_by_request  *string                    `json:"created_by_request,omitempty"`
	Updated_by_request  *string                    `json:"updated_by_request,omitempty"`
	Modified_by_request *string                    `json:"modified_by_request,omitempty"`
	Q                   *string                    `json:"q,omitempty"`
	Tag                 []string                   `json:"tag,omitempty"`
	AND                 *VLANTranslationRuleFilter `json:"AND,omitempty"`
	OR                  *VLANTranslationRuleFilter `json:"OR,omitempty"`
	NOT                 *VLANTranslationRuleFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                      `json:"DISTINCT,omitempty"`
}

// VLANTranslationRule(id, created, last_updated, custom_field_data, policy, description, local_vid, remote_vid)
type VLANTranslationRuleType struct {
	Changelog         []ObjectChangeType         `json:"changelog"`
	Display           string                     `json:"display"`
	Class_type        string                     `json:"class_type"`
	Tags              []TagType                  `json:"tags"`
	Journal_entries   []JournalEntryType         `json:"journal_entries"`
	Custom_fields     JSON                       `json:"custom_fields"`
	Policy            *VLANTranslationPolicyType `json:"policy"`
	Id                string                     `json:"id"`
	Created           *DateTime                  `json:"created,omitempty"`
	Last_updated      *DateTime                  `json:"last_updated,omitempty"`
	Custom_field_data JSON                       `json:"custom_field_data"`
	Description       string                     `json:"description"`
	Local_vid         int32                      `json:"local_vid"`
	Remote_vid        int32                      `json:"remote_vid"`
}

// A VLAN is a distinct layer two forwarding domain identified by a 12-bit integer (1-4094). Each VLAN must be assigned
// to a Site, however VLAN IDs need not be unique within a Site. A VLAN may optionally be assigned to a VLANGroup,
// within which all VLAN IDs and names but be unique.
//
// Like Prefixes, each VLAN is assigned an operational status and optionally a user-defined Role. A VLAN can have zero
// or more Prefixes assigned to it.
type VLANType struct {
	Changelog                []ObjectChangeType `json:"changelog"`
	Display                  string             `json:"display"`
	Class_type               string             `json:"class_type"`
	Tags                     []TagType          `json:"tags"`
	Journal_entries          []JournalEntryType `json:"journal_entries"`
	Custom_fields            JSON               `json:"custom_fields"`
	Site                     *SiteType          `json:"site,omitempty"`
	Group                    *VLANGroupType     `json:"group,omitempty"`
	Tenant                   *TenantType        `json:"tenant,omitempty"`
	Role                     *RoleType          `json:"role,omitempty"`
	Interfaces_as_untagged   []InterfaceType    `json:"interfaces_as_untagged"`
	Vminterfaces_as_untagged []VMInterfaceType  `json:"vminterfaces_as_untagged"`
	Wirelesslan_set          []WirelessLANType  `json:"wirelesslan_set"`
	Prefixes                 []PrefixType       `json:"prefixes"`
	Interfaces_as_tagged     []InterfaceType    `json:"interfaces_as_tagged"`
	Vminterfaces_as_tagged   []VMInterfaceType  `json:"vminterfaces_as_tagged"`
	Id                       string             `json:"id"`
	Created                  *DateTime          `json:"created,omitempty"`
	Last_updated             *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data        JSON               `json:"custom_field_data"`
	Description              string             `json:"description"`
	Comments                 string             `json:"comments"`
	Vid                      int32              `json:"vid"`
	Name                     string             `json:"name"`
	Status                   string             `json:"status"`
	Qinq_role                *string            `json:"qinq_role,omitempty"`
	Qinq_svlan               *VLANType          `json:"qinq_svlan,omitempty"`
}

func (*VLANType) isL2VPNAssignmentType() {}

// VMInterface(id, created, last_updated, custom_field_data, enabled, mtu, mode, parent, bridge, untagged_vlan, qinq_svlan, vlan_translation_policy, primary_mac_address, description, name, _name, virtual_machine, vrf)
type VMInterfaceFilter struct {
	Id                         *IDFilterLookup       `json:"id,omitempty"`
	Name                       *StrFilterLookup      `json:"name,omitempty"`
	Enabled                    *bool                 `json:"enabled,omitempty"`
	Mtu                        *IntFilterLookup      `json:"mtu,omitempty"`
	Mode                       *StrFilterLookup      `json:"mode,omitempty"`
	Description                *StrFilterLookup      `json:"description,omitempty"`
	Created                    *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated               *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request         *string               `json:"created_by_request,omitempty"`
	Updated_by_request         *string               `json:"updated_by_request,omitempty"`
	Modified_by_request        *string               `json:"modified_by_request,omitempty"`
	Q                          *string               `json:"q,omitempty"`
	Tag                        []string              `json:"tag,omitempty"`
	Vlan_id                    *string               `json:"vlan_id,omitempty"`
	Vlan                       *string               `json:"vlan,omitempty"`
	Vrf_id                     []string              `json:"vrf_id,omitempty"`
	Vrf                        []string              `json:"vrf,omitempty"`
	L2vpn_id                   []string              `json:"l2vpn_id,omitempty"`
	L2vpn                      []string              `json:"l2vpn,omitempty"`
	Vlan_translation_policy_id []string              `json:"vlan_translation_policy_id,omitempty"`
	Vlan_translation_policy    []string              `json:"vlan_translation_policy,omitempty"`
	Cluster_id                 []string              `json:"cluster_id,omitempty"`
	Cluster                    []string              `json:"cluster,omitempty"`
	Virtual_machine_id         []string              `json:"virtual_machine_id,omitempty"`
	Virtual_machine            []string              `json:"virtual_machine,omitempty"`
	Parent_id                  []string              `json:"parent_id,omitempty"`
	Bridge_id                  []string              `json:"bridge_id,omitempty"`
	Mac_address                []string              `json:"mac_address,omitempty"`
	Primary_mac_address_id     []string              `json:"primary_mac_address_id,omitempty"`
	Primary_mac_address        []string              `json:"primary_mac_address,omitempty"`
	AND                        *VMInterfaceFilter    `json:"AND,omitempty"`
	OR                         *VMInterfaceFilter    `json:"OR,omitempty"`
	NOT                        *VMInterfaceFilter    `json:"NOT,omitempty"`
	DISTINCT                   *bool                 `json:"DISTINCT,omitempty"`
}

// VMInterface(id, created, last_updated, custom_field_data, enabled, mtu, mode, parent, bridge, untagged_vlan, qinq_svlan, vlan_translation_policy, primary_mac_address, description, name, _name, virtual_machine, vrf)
type VMInterfaceType struct {
	Ip_addresses            []IPAddressType            `json:"ip_addresses"`
	Changelog               []ObjectChangeType         `json:"changelog"`
	Display                 string                     `json:"display"`
	Class_type              string                     `json:"class_type"`
	Tags                    []TagType                  `json:"tags"`
	Journal_entries         []JournalEntryType         `json:"journal_entries"`
	Custom_fields           JSON                       `json:"custom_fields"`
	Virtual_machine         *VirtualMachineType        `json:"virtual_machine"`
	_name                   string                     `json:"_name"`
	Mac_address             *string                    `json:"mac_address,omitempty"`
	Parent                  *VMInterfaceType           `json:"parent,omitempty"`
	Bridge                  *VMInterfaceType           `json:"bridge,omitempty"`
	Untagged_vlan           *VLANType                  `json:"untagged_vlan,omitempty"`
	Vrf                     *VRFType                   `json:"vrf,omitempty"`
	Primary_mac_address     *MACAddressType            `json:"primary_mac_address,omitempty"`
	Qinq_svlan              *VLANType                  `json:"qinq_svlan,omitempty"`
	Vlan_translation_policy *VLANTranslationPolicyType `json:"vlan_translation_policy,omitempty"`
	Tagged_vlans            []VLANType                 `json:"tagged_vlans"`
	Bridge_interfaces       []VMInterfaceType          `json:"bridge_interfaces"`
	Child_interfaces        []VMInterfaceType          `json:"child_interfaces"`
	Mac_addresses           []MACAddressType           `json:"mac_addresses"`
	Id                      string                     `json:"id"`
	Created                 *DateTime                  `json:"created,omitempty"`
	Last_updated            *DateTime                  `json:"last_updated,omitempty"`
	Custom_field_data       JSON                       `json:"custom_field_data"`
	Enabled                 bool                       `json:"enabled"`
	Mtu                     *int32                     `json:"mtu,omitempty"`
	Mode                    *string                    `json:"mode,omitempty"`
	Description             string                     `json:"description"`
	Name                    string                     `json:"name"`
}

func (*VMInterfaceType) isMACAddressAssignmentType() {}

func (*VMInterfaceType) isIPAddressAssignmentType() {}

func (*VMInterfaceType) isFHRPGroupInterfaceType() {}

func (*VMInterfaceType) isL2VPNAssignmentType() {}

// A virtual routing and forwarding (VRF) table represents a discrete layer three forwarding domain (e.g. a routing
// table). Prefixes and IPAddresses can optionally be assigned to VRFs. (Prefixes and IPAddresses not assigned to a VRF
// are said to exist in the "global" table.)
type VRFFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Rd                  *StrFilterLookup      `json:"rd,omitempty"`
	Enforce_unique      *bool                 `json:"enforce_unique,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Import_target_id    []string              `json:"import_target_id,omitempty"`
	Import_target       []string              `json:"import_target,omitempty"`
	Export_target_id    []string              `json:"export_target_id,omitempty"`
	Export_target       []string              `json:"export_target,omitempty"`
	AND                 *VRFFilter            `json:"AND,omitempty"`
	OR                  *VRFFilter            `json:"OR,omitempty"`
	NOT                 *VRFFilter            `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A virtual routing and forwarding (VRF) table represents a discrete layer three forwarding domain (e.g. a routing
// table). Prefixes and IPAddresses can optionally be assigned to VRFs. (Prefixes and IPAddresses not assigned to a VRF
// are said to exist in the "global" table.)
type VRFType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Tenant            *TenantType        `json:"tenant,omitempty"`
	Interfaces        []InterfaceType    `json:"interfaces"`
	Ip_addresses      []IPAddressType    `json:"ip_addresses"`
	Vminterfaces      []VMInterfaceType  `json:"vminterfaces"`
	Ip_ranges         []IPRangeType      `json:"ip_ranges"`
	Export_targets    []RouteTargetType  `json:"export_targets"`
	Import_targets    []RouteTargetType  `json:"import_targets"`
	Prefixes          []PrefixType       `json:"prefixes"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Name              string             `json:"name"`
	Rd                *string            `json:"rd,omitempty"`
	Enforce_unique    bool               `json:"enforce_unique"`
}

// A collection of Devices which operate with a shared control plane (e.g. a switch stack).
type VirtualChassisFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Domain              *StrFilterLookup      `json:"domain,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Member_count        *Union                `json:"member_count,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Master_id           []string              `json:"master_id,omitempty"`
	Master              []string              `json:"master,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	AND                 *VirtualChassisFilter `json:"AND,omitempty"`
	OR                  *VirtualChassisFilter `json:"OR,omitempty"`
	NOT                 *VirtualChassisFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A collection of Devices which operate with a shared control plane (e.g. a switch stack).
type VirtualChassisType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Member_count      Union              `json:"member_count"`
	Master            *DeviceType        `json:"master,omitempty"`
	Members           []DeviceType       `json:"members"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Comments          string             `json:"comments"`
	Name              string             `json:"name"`
	Domain            string             `json:"domain"`
}

// A virtual connection between two or more endpoints, delivered across one or more physical circuits.
type VirtualCircuitFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Cid                 *StrFilterLookup      `json:"cid,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Provider_id         []string              `json:"provider_id,omitempty"`
	Provider            []string              `json:"provider,omitempty"`
	Provider_account_id []string              `json:"provider_account_id,omitempty"`
	Provider_account    []string              `json:"provider_account,omitempty"`
	Provider_network_id []string              `json:"provider_network_id,omitempty"`
	Type_id             []string              `json:"type_id,omitempty"`
	Type                []string              `json:"type,omitempty"`
	Status              *string               `json:"status,omitempty"`
	AND                 *VirtualCircuitFilter `json:"AND,omitempty"`
	OR                  *VirtualCircuitFilter `json:"OR,omitempty"`
	NOT                 *VirtualCircuitFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// VirtualCircuitTermination(id, created, last_updated, custom_field_data, virtual_circuit, role, interface, description)
type VirtualCircuitTerminationFilter struct {
	Id                  *IDFilterLookup                  `json:"id,omitempty"`
	Interface_id        *IDFilterLookup                  `json:"interface_id,omitempty"`
	Description         *StrFilterLookup                 `json:"description,omitempty"`
	Created             *DatetimeFilterLookup            `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup            `json:"last_updated,omitempty"`
	Created_by_request  *string                          `json:"created_by_request,omitempty"`
	Updated_by_request  *string                          `json:"updated_by_request,omitempty"`
	Modified_by_request *string                          `json:"modified_by_request,omitempty"`
	Q                   *string                          `json:"q,omitempty"`
	Tag                 []string                         `json:"tag,omitempty"`
	Virtual_circuit_id  []string                         `json:"virtual_circuit_id,omitempty"`
	Role                *string                          `json:"role,omitempty"`
	Provider_id         []string                         `json:"provider_id,omitempty"`
	Provider            []string                         `json:"provider,omitempty"`
	Provider_account_id []string                         `json:"provider_account_id,omitempty"`
	Provider_account    []string                         `json:"provider_account,omitempty"`
	Provider_network_id []string                         `json:"provider_network_id,omitempty"`
	AND                 *VirtualCircuitTerminationFilter `json:"AND,omitempty"`
	OR                  *VirtualCircuitTerminationFilter `json:"OR,omitempty"`
	NOT                 *VirtualCircuitTerminationFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                            `json:"DISTINCT,omitempty"`
}

// VirtualCircuitTermination(id, created, last_updated, custom_field_data, virtual_circuit, role, interface, description)
type VirtualCircuitTerminationType struct {
	Custom_fields     JSON                `json:"custom_fields"`
	Tags              []TagType           `json:"tags"`
	Changelog         []ObjectChangeType  `json:"changelog"`
	Display           string              `json:"display"`
	Class_type        string              `json:"class_type"`
	Virtual_circuit   *VirtualCircuitType `json:"virtual_circuit"`
	Interface         *InterfaceType      `json:"interface"`
	Id                string              `json:"id"`
	Created           *DateTime           `json:"created,omitempty"`
	Last_updated      *DateTime           `json:"last_updated,omitempty"`
	Custom_field_data JSON                `json:"custom_field_data"`
	Role              string              `json:"role"`
	Description       string              `json:"description"`
}

// A virtual connection between two or more endpoints, delivered across one or more physical circuits.
type VirtualCircuitType struct {
	Changelog         []ObjectChangeType              `json:"changelog"`
	Display           string                          `json:"display"`
	Class_type        string                          `json:"class_type"`
	Tags              []TagType                       `json:"tags"`
	Journal_entries   []JournalEntryType              `json:"journal_entries"`
	Custom_fields     JSON                            `json:"custom_fields"`
	Provider_network  *ProviderNetworkType            `json:"provider_network"`
	Provider_account  *ProviderAccountType            `json:"provider_account,omitempty"`
	Type              *VirtualCircuitTypeType         `json:"type"`
	Tenant            *TenantType                     `json:"tenant,omitempty"`
	Terminations      []VirtualCircuitTerminationType `json:"terminations"`
	Id                string                          `json:"id"`
	Created           *DateTime                       `json:"created,omitempty"`
	Last_updated      *DateTime                       `json:"last_updated,omitempty"`
	Custom_field_data JSON                            `json:"custom_field_data"`
	Description       string                          `json:"description"`
	Comments          string                          `json:"comments"`
	Cid               string                          `json:"cid"`
	Status            string                          `json:"status"`
}

func (*VirtualCircuitType) isCircuitGroupAssignmentMemberType() {}

// Like physical circuits, virtual circuits can be organized by their functional role. For example, a user might wish
// to categorize virtual circuits by their technological nature or by product name.
type VirtualCircuitTypeFilter struct {
	Id                  *IDFilterLookup           `json:"id,omitempty"`
	Name                *StrFilterLookup          `json:"name,omitempty"`
	Slug                *StrFilterLookup          `json:"slug,omitempty"`
	Color               []string                  `json:"color,omitempty"`
	Description         *StrFilterLookup          `json:"description,omitempty"`
	Created             *DatetimeFilterLookup     `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup     `json:"last_updated,omitempty"`
	Created_by_request  *string                   `json:"created_by_request,omitempty"`
	Updated_by_request  *string                   `json:"updated_by_request,omitempty"`
	Modified_by_request *string                   `json:"modified_by_request,omitempty"`
	Q                   *string                   `json:"q,omitempty"`
	Tag                 []string                  `json:"tag,omitempty"`
	AND                 *VirtualCircuitTypeFilter `json:"AND,omitempty"`
	OR                  *VirtualCircuitTypeFilter `json:"OR,omitempty"`
	NOT                 *VirtualCircuitTypeFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                     `json:"DISTINCT,omitempty"`
}

// Like physical circuits, virtual circuits can be organized by their functional role. For example, a user might wish
// to categorize virtual circuits by their technological nature or by product name.
type VirtualCircuitTypeType struct {
	Changelog         []ObjectChangeType   `json:"changelog"`
	Display           string               `json:"display"`
	Class_type        string               `json:"class_type"`
	Tags              []TagType            `json:"tags"`
	Custom_fields     JSON                 `json:"custom_fields"`
	Color             string               `json:"color"`
	Virtual_circuits  []VirtualCircuitType `json:"virtual_circuits"`
	Id                string               `json:"id"`
	Created           *DateTime            `json:"created,omitempty"`
	Last_updated      *DateTime            `json:"last_updated,omitempty"`
	Custom_field_data JSON                 `json:"custom_field_data"`
	Name              string               `json:"name"`
	Slug              string               `json:"slug"`
	Description       string               `json:"description"`
}

// VirtualDeviceContext(id, created, last_updated, custom_field_data, description, device, name, status, identifier, primary_ip4, primary_ip6, tenant, comments)
type VirtualDeviceContextFilter struct {
	Id                  *IDFilterLookup             `json:"id,omitempty"`
	Device              *DjangoModelFilterInput     `json:"device,omitempty"`
	Name                *StrFilterLookup            `json:"name,omitempty"`
	Identifier          *IntFilterLookup            `json:"identifier,omitempty"`
	Description         *StrFilterLookup            `json:"description,omitempty"`
	Created             *DatetimeFilterLookup       `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup       `json:"last_updated,omitempty"`
	Created_by_request  *string                     `json:"created_by_request,omitempty"`
	Updated_by_request  *string                     `json:"updated_by_request,omitempty"`
	Modified_by_request *string                     `json:"modified_by_request,omitempty"`
	Q                   *string                     `json:"q,omitempty"`
	Tag                 []string                    `json:"tag,omitempty"`
	Tenant_group_id     []string                    `json:"tenant_group_id,omitempty"`
	Tenant_group        []string                    `json:"tenant_group,omitempty"`
	Tenant_id           []string                    `json:"tenant_id,omitempty"`
	Tenant              []string                    `json:"tenant,omitempty"`
	Primary_ip4_id      []string                    `json:"primary_ip4_id,omitempty"`
	Primary_ip6_id      []string                    `json:"primary_ip6_id,omitempty"`
	Device_id           []string                    `json:"device_id,omitempty"`
	Interface_id        []string                    `json:"interface_id,omitempty"`
	Status              *string                     `json:"status,omitempty"`
	Has_primary_ip      *bool                       `json:"has_primary_ip,omitempty"`
	AND                 *VirtualDeviceContextFilter `json:"AND,omitempty"`
	OR                  *VirtualDeviceContextFilter `json:"OR,omitempty"`
	NOT                 *VirtualDeviceContextFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                       `json:"DISTINCT,omitempty"`
}

// VirtualDeviceContext(id, created, last_updated, custom_field_data, description, device, name, status, identifier, primary_ip4, primary_ip6, tenant, comments)
type VirtualDeviceContextType struct {
	Changelog         []ObjectChangeType `json:"changelog"`
	Display           string             `json:"display"`
	Class_type        string             `json:"class_type"`
	Tags              []TagType          `json:"tags"`
	Journal_entries   []JournalEntryType `json:"journal_entries"`
	Custom_fields     JSON               `json:"custom_fields"`
	Device            *DeviceType        `json:"device,omitempty"`
	Primary_ip4       *IPAddressType     `json:"primary_ip4,omitempty"`
	Primary_ip6       *IPAddressType     `json:"primary_ip6,omitempty"`
	Tenant            *TenantType        `json:"tenant,omitempty"`
	Interfaces        []InterfaceType    `json:"interfaces"`
	Id                string             `json:"id"`
	Created           *DateTime          `json:"created,omitempty"`
	Last_updated      *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data JSON               `json:"custom_field_data"`
	Description       string             `json:"description"`
	Name              string             `json:"name"`
	Status            string             `json:"status"`
	Identifier        *int32             `json:"identifier,omitempty"`
	Comments          string             `json:"comments"`
}

// VirtualDisk(id, created, last_updated, custom_field_data, virtual_machine, name, description, size)
type VirtualDiskFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Size                *IntFilterLookup      `json:"size,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Virtual_machine_id  []string              `json:"virtual_machine_id,omitempty"`
	Virtual_machine     []string              `json:"virtual_machine,omitempty"`
	AND                 *VirtualDiskFilter    `json:"AND,omitempty"`
	OR                  *VirtualDiskFilter    `json:"OR,omitempty"`
	NOT                 *VirtualDiskFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// VirtualDisk(id, created, last_updated, custom_field_data, virtual_machine, name, description, size)
type VirtualDiskType struct {
	Changelog         []ObjectChangeType  `json:"changelog"`
	Display           string              `json:"display"`
	Class_type        string              `json:"class_type"`
	Tags              []TagType           `json:"tags"`
	Journal_entries   []JournalEntryType  `json:"journal_entries"`
	Custom_fields     JSON                `json:"custom_fields"`
	Virtual_machine   *VirtualMachineType `json:"virtual_machine"`
	Id                string              `json:"id"`
	Created           *DateTime           `json:"created,omitempty"`
	Last_updated      *DateTime           `json:"last_updated,omitempty"`
	Custom_field_data JSON                `json:"custom_field_data"`
	Name              string              `json:"name"`
	Description       string              `json:"description"`
	Size              int32               `json:"size"`
}

// A virtual machine which runs inside a Cluster.
type VirtualMachineFilter struct {
	Id                  *IDFilterLookup         `json:"id,omitempty"`
	Cluster             *DjangoModelFilterInput `json:"cluster,omitempty"`
	Vcpus               *DecimalFilterLookup    `json:"vcpus,omitempty"`
	Memory              *IntFilterLookup        `json:"memory,omitempty"`
	Disk                *IntFilterLookup        `json:"disk,omitempty"`
	Description         *StrFilterLookup        `json:"description,omitempty"`
	Interface_count     *Union                  `json:"interface_count,omitempty"`
	Virtual_disk_count  *Union                  `json:"virtual_disk_count,omitempty"`
	Serial              *StrFilterLookup        `json:"serial,omitempty"`
	Created             *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request  *string                 `json:"created_by_request,omitempty"`
	Updated_by_request  *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request *string                 `json:"modified_by_request,omitempty"`
	Q                   *string                 `json:"q,omitempty"`
	Tag                 []string                `json:"tag,omitempty"`
	Tenant_group_id     []string                `json:"tenant_group_id,omitempty"`
	Tenant_group        []string                `json:"tenant_group,omitempty"`
	Tenant_id           []string                `json:"tenant_id,omitempty"`
	Tenant              []string                `json:"tenant,omitempty"`
	Contact             []string                `json:"contact,omitempty"`
	Contact_role        []string                `json:"contact_role,omitempty"`
	Contact_group       []string                `json:"contact_group,omitempty"`
	Local_context_data  *bool                   `json:"local_context_data,omitempty"`
	Primary_ip4_id      []string                `json:"primary_ip4_id,omitempty"`
	Primary_ip6_id      []string                `json:"primary_ip6_id,omitempty"`
	Status              *string                 `json:"status,omitempty"`
	Cluster_group_id    []string                `json:"cluster_group_id,omitempty"`
	Cluster_group       []string                `json:"cluster_group,omitempty"`
	Cluster_type_id     []string                `json:"cluster_type_id,omitempty"`
	Cluster_type        []string                `json:"cluster_type,omitempty"`
	Cluster_id          []string                `json:"cluster_id,omitempty"`
	Device_id           []string                `json:"device_id,omitempty"`
	Device              []string                `json:"device,omitempty"`
	Region_id           []string                `json:"region_id,omitempty"`
	Region              []string                `json:"region,omitempty"`
	Site_group_id       []string                `json:"site_group_id,omitempty"`
	Site_group          []string                `json:"site_group,omitempty"`
	Site_id             []string                `json:"site_id,omitempty"`
	Site                []string                `json:"site,omitempty"`
	Name                *StrFilterLookup        `json:"name,omitempty"`
	Role_id             []string                `json:"role_id,omitempty"`
	Role                []string                `json:"role,omitempty"`
	Platform_id         []string                `json:"platform_id,omitempty"`
	Platform            []string                `json:"platform,omitempty"`
	Mac_address         []string                `json:"mac_address,omitempty"`
	Has_primary_ip      *bool                   `json:"has_primary_ip,omitempty"`
	Config_template_id  []string                `json:"config_template_id,omitempty"`
	AND                 *VirtualMachineFilter   `json:"AND,omitempty"`
	OR                  *VirtualMachineFilter   `json:"OR,omitempty"`
	NOT                 *VirtualMachineFilter   `json:"NOT,omitempty"`
	DISTINCT            *bool                   `json:"DISTINCT,omitempty"`
}

// A virtual machine which runs inside a Cluster.
type VirtualMachineType struct {
	Config_context     JSON                    `json:"config_context"`
	Contacts           []ContactAssignmentType `json:"contacts"`
	Changelog          []ObjectChangeType      `json:"changelog"`
	Display            string                  `json:"display"`
	Class_type         string                  `json:"class_type"`
	Tags               []TagType               `json:"tags"`
	Journal_entries    []JournalEntryType      `json:"journal_entries"`
	Custom_fields      JSON                    `json:"custom_fields"`
	Interface_count    Union                   `json:"interface_count"`
	Virtual_disk_count Union                   `json:"virtual_disk_count"`
	Config_template    *ConfigTemplateType     `json:"config_template,omitempty"`
	Site               *SiteType               `json:"site,omitempty"`
	Cluster            *ClusterType            `json:"cluster,omitempty"`
	Device             *DeviceType             `json:"device,omitempty"`
	Tenant             *TenantType             `json:"tenant,omitempty"`
	Platform           *PlatformType           `json:"platform,omitempty"`
	Role               *DeviceRoleType         `json:"role,omitempty"`
	Primary_ip4        *IPAddressType          `json:"primary_ip4,omitempty"`
	Primary_ip6        *IPAddressType          `json:"primary_ip6,omitempty"`
	Interfaces         []VMInterfaceType       `json:"interfaces"`
	Services           []ServiceType           `json:"services"`
	Virtualdisks       []VirtualDiskType       `json:"virtualdisks"`
	Id                 string                  `json:"id"`
	Created            *DateTime               `json:"created,omitempty"`
	Last_updated       *DateTime               `json:"last_updated,omitempty"`
	Custom_field_data  JSON                    `json:"custom_field_data"`
	Description        string                  `json:"description"`
	Comments           string                  `json:"comments"`
	Local_context_data *JSON                   `json:"local_context_data,omitempty"`
	Name               string                  `json:"name"`
	Status             string                  `json:"status"`
	Vcpus              *Decimal                `json:"vcpus,omitempty"`
	Memory             *int32                  `json:"memory,omitempty"`
	Disk               *int32                  `json:"disk,omitempty"`
	Serial             string                  `json:"serial"`
}

// A Webhook defines a request that will be sent to a remote application when an object is created, updated, and/or
// delete in NetBox. The request will contain a representation of the object, which the remote application can act on.
// Each Webhook can be limited to firing only on certain actions or certain object types.
type WebhookFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Name                *StrFilterLookup      `json:"name,omitempty"`
	Payload_url         *StrFilterLookup      `json:"payload_url,omitempty"`
	Http_method         *StrFilterLookup      `json:"http_method,omitempty"`
	Http_content_type   *StrFilterLookup      `json:"http_content_type,omitempty"`
	Secret              *StrFilterLookup      `json:"secret,omitempty"`
	Ssl_verification    *bool                 `json:"ssl_verification,omitempty"`
	Ca_file_path        *StrFilterLookup      `json:"ca_file_path,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	AND                 *WebhookFilter        `json:"AND,omitempty"`
	OR                  *WebhookFilter        `json:"OR,omitempty"`
	NOT                 *WebhookFilter        `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A Webhook defines a request that will be sent to a remote application when an object is created, updated, and/or
// delete in NetBox. The request will contain a representation of the object, which the remote application can act on.
// Each Webhook can be limited to firing only on certain actions or certain object types.
type WebhookType struct {
	Changelog          []ObjectChangeType `json:"changelog"`
	Display            string             `json:"display"`
	Class_type         string             `json:"class_type"`
	Tags               []TagType          `json:"tags"`
	Custom_fields      JSON               `json:"custom_fields"`
	Id                 string             `json:"id"`
	Created            *DateTime          `json:"created,omitempty"`
	Last_updated       *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data  JSON               `json:"custom_field_data"`
	Name               string             `json:"name"`
	Description        string             `json:"description"`
	Payload_url        string             `json:"payload_url"`
	Http_method        string             `json:"http_method"`
	Http_content_type  string             `json:"http_content_type"`
	Additional_headers string             `json:"additional_headers"`
	Body_template      string             `json:"body_template"`
	Secret             string             `json:"secret"`
	Ssl_verification   bool               `json:"ssl_verification"`
	Ca_file_path       *string            `json:"ca_file_path,omitempty"`
}

// A wireless network formed among an arbitrary number of access point and clients.
type WirelessLANFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Ssid                *StrFilterLookup      `json:"ssid,omitempty"`
	Auth_psk            *StrFilterLookup      `json:"auth_psk,omitempty"`
	Scope_id            *IntFilterLookup      `json:"scope_id,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Scope_type          *string               `json:"scope_type,omitempty"`
	Region_id           []string              `json:"region_id,omitempty"`
	Region              []string              `json:"region,omitempty"`
	Site_group_id       []string              `json:"site_group_id,omitempty"`
	Site_group          []string              `json:"site_group,omitempty"`
	Site_id             []string              `json:"site_id,omitempty"`
	Site                []string              `json:"site,omitempty"`
	Location_id         []string              `json:"location_id,omitempty"`
	Location            []string              `json:"location,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Group_id            []string              `json:"group_id,omitempty"`
	Group               []string              `json:"group,omitempty"`
	Status              *string               `json:"status,omitempty"`
	Vlan_id             []string              `json:"vlan_id,omitempty"`
	Interface_id        []string              `json:"interface_id,omitempty"`
	Auth_type           *string               `json:"auth_type,omitempty"`
	Auth_cipher         *string               `json:"auth_cipher,omitempty"`
	AND                 *WirelessLANFilter    `json:"AND,omitempty"`
	OR                  *WirelessLANFilter    `json:"OR,omitempty"`
	NOT                 *WirelessLANFilter    `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A nested grouping of WirelessLANs
type WirelessLANGroupFilter struct {
	Id                  *IDFilterLookup         `json:"id,omitempty"`
	Name                *StrFilterLookup        `json:"name,omitempty"`
	Slug                *StrFilterLookup        `json:"slug,omitempty"`
	Description         *StrFilterLookup        `json:"description,omitempty"`
	Created             *DatetimeFilterLookup   `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup   `json:"last_updated,omitempty"`
	Created_by_request  *string                 `json:"created_by_request,omitempty"`
	Updated_by_request  *string                 `json:"updated_by_request,omitempty"`
	Modified_by_request *string                 `json:"modified_by_request,omitempty"`
	Q                   *string                 `json:"q,omitempty"`
	Tag                 []string                `json:"tag,omitempty"`
	Parent_id           []string                `json:"parent_id,omitempty"`
	Parent              []string                `json:"parent,omitempty"`
	Ancestor_id         []string                `json:"ancestor_id,omitempty"`
	Ancestor            []string                `json:"ancestor,omitempty"`
	AND                 *WirelessLANGroupFilter `json:"AND,omitempty"`
	OR                  *WirelessLANGroupFilter `json:"OR,omitempty"`
	NOT                 *WirelessLANGroupFilter `json:"NOT,omitempty"`
	DISTINCT            *bool                   `json:"DISTINCT,omitempty"`
}

// A nested grouping of WirelessLANs
type WirelessLANGroupType struct {
	Changelog         []ObjectChangeType     `json:"changelog"`
	Display           string                 `json:"display"`
	Class_type        string                 `json:"class_type"`
	Tags              []TagType              `json:"tags"`
	Custom_fields     JSON                   `json:"custom_fields"`
	Parent            *WirelessLANGroupType  `json:"parent,omitempty"`
	Wireless_lans     []WirelessLANType      `json:"wireless_lans"`
	Children          []WirelessLANGroupType `json:"children"`
	Id                string                 `json:"id"`
	Created           *DateTime              `json:"created,omitempty"`
	Last_updated      *DateTime              `json:"last_updated,omitempty"`
	Custom_field_data JSON                   `json:"custom_field_data"`
	Description       string                 `json:"description"`
	Name              string                 `json:"name"`
	Slug              string                 `json:"slug"`
	Lft               int32                  `json:"lft"`
	Rght              int32                  `json:"rght"`
	Tree_id           int32                  `json:"tree_id"`
	Level             int32                  `json:"level"`
}

type WirelessLANScopeType struct {
	// Underlying value of the GraphQL union
	Value WirelessLANScopeTypeValue `json:"-"`
}

func (base *WirelessLANScopeType) UnmarshalJSON(b []byte) error {
	type Raw WirelessLANScopeType
	var data struct {
		*Raw
		TypeName string `json:"__typename"`
	}
	data.Raw = (*Raw)(base)
	err := json.Unmarshal(b, &data)
	if err != nil {
		return err
	}
	switch data.TypeName {
	case "LocationType":
		base.Value = new(LocationType)
	case "RegionType":
		base.Value = new(RegionType)
	case "SiteGroupType":
		base.Value = new(SiteGroupType)
	case "SiteType":
		base.Value = new(SiteType)
	case "":
		return fmt.Errorf("gqlclient: union WirelessLANScopeType: missing __typename field")
	default:
		return fmt.Errorf("gqlclient: union WirelessLANScopeType: unknown __typename %q", data.TypeName)
	}
	return json.Unmarshal(b, base.Value)
}

// WirelessLANScopeTypeValue is one of: LocationType | RegionType | SiteGroupType | SiteType
type WirelessLANScopeTypeValue interface {
	isWirelessLANScopeType()
}

// A wireless network formed among an arbitrary number of access point and clients.
type WirelessLANType struct {
	Changelog         []ObjectChangeType    `json:"changelog"`
	Display           string                `json:"display"`
	Class_type        string                `json:"class_type"`
	Tags              []TagType             `json:"tags"`
	Journal_entries   []JournalEntryType    `json:"journal_entries"`
	Custom_fields     JSON                  `json:"custom_fields"`
	Group             *WirelessLANGroupType `json:"group,omitempty"`
	Vlan              *VLANType             `json:"vlan,omitempty"`
	Tenant            *TenantType           `json:"tenant,omitempty"`
	Interfaces        []InterfaceType       `json:"interfaces"`
	Id                string                `json:"id"`
	Created           *DateTime             `json:"created,omitempty"`
	Last_updated      *DateTime             `json:"last_updated,omitempty"`
	Custom_field_data JSON                  `json:"custom_field_data"`
	Description       string                `json:"description"`
	Comments          string                `json:"comments"`
	Auth_type         *string               `json:"auth_type,omitempty"`
	Auth_cipher       *string               `json:"auth_cipher,omitempty"`
	Auth_psk          string                `json:"auth_psk"`
	Ssid              string                `json:"ssid"`
	Status            string                `json:"status"`
	Scope             *WirelessLANScopeType `json:"scope,omitempty"`
}

// A point-to-point connection between two wireless Interfaces.
type WirelessLinkFilter struct {
	Id                  *IDFilterLookup       `json:"id,omitempty"`
	Ssid                *StrFilterLookup      `json:"ssid,omitempty"`
	Auth_psk            *StrFilterLookup      `json:"auth_psk,omitempty"`
	Distance            *DecimalFilterLookup  `json:"distance,omitempty"`
	Distance_unit       *StrFilterLookup      `json:"distance_unit,omitempty"`
	Description         *StrFilterLookup      `json:"description,omitempty"`
	Created             *DatetimeFilterLookup `json:"created,omitempty"`
	Last_updated        *DatetimeFilterLookup `json:"last_updated,omitempty"`
	Created_by_request  *string               `json:"created_by_request,omitempty"`
	Updated_by_request  *string               `json:"updated_by_request,omitempty"`
	Modified_by_request *string               `json:"modified_by_request,omitempty"`
	Q                   *string               `json:"q,omitempty"`
	Tag                 []string              `json:"tag,omitempty"`
	Tenant_group_id     []string              `json:"tenant_group_id,omitempty"`
	Tenant_group        []string              `json:"tenant_group,omitempty"`
	Tenant_id           []string              `json:"tenant_id,omitempty"`
	Tenant              []string              `json:"tenant,omitempty"`
	Interface_a_id      []string              `json:"interface_a_id,omitempty"`
	Interface_b_id      []string              `json:"interface_b_id,omitempty"`
	Status              *string               `json:"status,omitempty"`
	Auth_type           *string               `json:"auth_type,omitempty"`
	Auth_cipher         *string               `json:"auth_cipher,omitempty"`
	AND                 *WirelessLinkFilter   `json:"AND,omitempty"`
	OR                  *WirelessLinkFilter   `json:"OR,omitempty"`
	NOT                 *WirelessLinkFilter   `json:"NOT,omitempty"`
	DISTINCT            *bool                 `json:"DISTINCT,omitempty"`
}

// A point-to-point connection between two wireless Interfaces.
type WirelessLinkType struct {
	Changelog           []ObjectChangeType `json:"changelog"`
	Display             string             `json:"display"`
	Class_type          string             `json:"class_type"`
	Tags                []TagType          `json:"tags"`
	Journal_entries     []JournalEntryType `json:"journal_entries"`
	Custom_fields       JSON               `json:"custom_fields"`
	Interface_a         *InterfaceType     `json:"interface_a"`
	Interface_b         *InterfaceType     `json:"interface_b"`
	Tenant              *TenantType        `json:"tenant,omitempty"`
	_interface_a_device *DeviceType        `json:"_interface_a_device,omitempty"`
	_interface_b_device *DeviceType        `json:"_interface_b_device,omitempty"`
	Id                  string             `json:"id"`
	Created             *DateTime          `json:"created,omitempty"`
	Last_updated        *DateTime          `json:"last_updated,omitempty"`
	Custom_field_data   JSON               `json:"custom_field_data"`
	Description         string             `json:"description"`
	Comments            string             `json:"comments"`
	Distance            *Decimal           `json:"distance,omitempty"`
	Distance_unit       *string            `json:"distance_unit,omitempty"`
	_abs_distance       *Decimal           `json:"_abs_distance,omitempty"`
	Auth_type           *string            `json:"auth_type,omitempty"`
	Auth_cipher         *string            `json:"auth_cipher,omitempty"`
	Auth_psk            string             `json:"auth_psk"`
	Ssid                string             `json:"ssid"`
	Status              string             `json:"status"`
}

func ListIps(client *gqlclient.Client, ctx context.Context) (ip_address_list []IPAddressType, err error) {
	op := gqlclient.NewOperation("query listIps {\n\tip_address_list {\n\t\taddress\n\t\tdns_name\n\t\tstatus\n\t}\n}\n")
	var respData struct {
		Ip_address_list []IPAddressType
	}
	err = client.Execute(ctx, op, &respData)
	return respData.Ip_address_list, err
}

func ListIpRanges(client *gqlclient.Client, ctx context.Context) (ip_range_list []IPRangeType, err error) {
	op := gqlclient.NewOperation("query listIpRanges {\n\tip_range_list {\n\t\tid\n\t\tstatus\n\t\trole {\n\t\t\tid\n\t\t\tname\n\t\t}\n\t\tstart_address\n\t\tend_address\n\t\tcustom_fields\n\t}\n}\n")
	var respData struct {
		Ip_range_list []IPRangeType
	}
	err = client.Execute(ctx, op, &respData)
	return respData.Ip_range_list, err
}
